/****************************************************************
*                                                               *
*    Name: Action.cpp                                           *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the only input form to handle what the user    *
*        want. This will be shown if the user want to copy a    *
*        file, or want to find a file, but when if she/he want  *
*        change the permissions of files, too.                  *
*        So it is a universal input window.                     *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "Action.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TActionForm *ActionForm;
//---------------------------------------------------------------------------
__fastcall TActionForm::TActionForm(TComponent* Owner)
    : TForm(Owner)
{

    char cline[100];
    FILE *filein;

    status=0;
    archive=false;
if( ActionForm==this ) {
try {
    filein = fopen((Form1->home+".vc/doon").c_str(), "rt");
    if( filein ) {
        ActionForm->doon->Clear();
        fgets(cline, 200, filein);
        AnsiString line=Trim(AnsiString(cline));
        while( !feof(filein) ) {
            if( line!="" ) ActionForm->doon->Items->Add(line);
            fgets(cline, 200, filein);line=Trim(AnsiString(cline));
        }
        fclose(filein);
    }

    filein = fopen((Form1->home+".vc/doon2").c_str(), "rt");
    if( filein ) {
        ActionForm->doon2->Clear();
        fgets(cline, 200, filein);
        AnsiString line=Trim(AnsiString(cline));
        while( !feof(filein) ) {
            if( line!="" ) ActionForm->doon2->Items->Add(line);
            fgets(cline, 200, filein);line=Trim(AnsiString(cline));
        }
        fclose(filein);
    }
}
catch(...) {
    ShowMessage("!!! Error while reading ActionForm's history !!!");
}
}
}
//---------------------------------------------------------------------------
void __fastcall TActionForm::OkClick(TObject *Sender)
{
    status=1;
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::CancelClick(TObject *Sender)
{
    status=2;
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    if( status==0 ) status=2;
    if( status!=2 && ActionForm!=this && archive==0 ) {
        ActionForm->doon->Items=doon->Items;
        ActionForm->doon2->Items=doon2->Items;
    }
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{

    if( Key==4100 || Key==4101 ) {
        status=1;
        if( doon->Enabled ) {
            try {
                if( (Caption.Length()>3 && Caption.SubString(1,3)=="Del") ) {}
                else
                if( doon->Items->Add(String(doon->Text))==doon->MaxItems ) doon->Items->Delete(doon->MaxItems-1);
            } catch(...) {}
        }
        if( doon2->Enabled ) {
            try {
                if( doon2->Items->Add(String(doon2->Text))==doon2->MaxItems )
                    doon2->Items->Delete(doon2->MaxItems-1);
            } catch(...) {}
        }
        Close();
    }

    if( Key==4096 ) {
        status=2;
        Close();
    }

    if( ( Key==4117 || Key==4115) && Shift.Contains(ssCtrl) ) {
        if( doon2->Focused() )
            doon2->DroppedDown=true;
        else
            doon->DroppedDown=true;
        Key==0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::doonKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::doon2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::symlinksKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::FormShow(TObject *Sender)
{
    Font->Height=13;
    int align;
    if( mess1->Width>mess2->Width ) align=mess1->Width; else align=mess2->Width;
    if( ActionForm!=this && archive==0 ) {
        doon->Items=ActionForm->doon->Items;
        doon2->Items=ActionForm->doon2->Items;
    } else if( archive!=0 ) {
        try {
            if( archive==1 )
                doon2->Text=String(doon2->Items->GetText()).SubString(1,String(doon2->Items->GetText()).Pos(String(char(10)))-1);
            else if( archive==2 ) {
                int ind=Form1->GetCrPacIndByExt(Form1->act->panel[Form1->act->active->Row].ext);
                if( ind!=-1 )
                    doon2->Text=Form1->cr_pacs[ind].Name;
            }
//            doon2->Text=doon2->Text.SubString(1,doon2->Text.Length()-1);
            doon2Change(this);
        } catch(...) {}

    }
    doon->AutoComplete=Form1->cl->AutoComplete;
    doon2->AutoComplete=Form1->cl->AutoComplete;
    doon->Left=align+20;
    doon2->Left=align+20;
    doon->Width=Width-(align+25);
    doon2->Width=Width-(align+25);
    doon->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::recursiveKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::presattrKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::mess1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TActionForm::mess2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    FormKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------


void __fastcall TActionForm::FormCreate(TObject *Sender)
{
    SetFocus();
}
//---------------------------------------------------------------------------



void __fastcall TActionForm::doon2Change(TObject *Sender)
{
    if( archive==1 ) {
        if( Form1->GetCrPacInd(String(doon2->Text))==-1 ) {
            doon->Text="";
            return;
        }
        AnsiString cmd=Form1->cr_pacs[Form1->GetCrPacInd(String(doon2->Text))].Handle;
        AnsiString first,last;

        if( cmd.Pos("%packfile")>0 ) {
            TForm1::AnsiSplit(cmd,"%packfile",first,last);
            cmd=first+String(Form1->nact->dirloc->Text+Form1->act->panel[Form1->act->active->Row].Name)+Form1->cr_pacs[Form1->GetCrPacInd(String(doon2->Text))].Ext+last;
        }
        if( cmd.Pos("%files")>0 ) {
            TForm1::AnsiSplit(cmd,"%files",first,last);
            cmd=first+Form1->act->archive_filelist+last;
        } else
        if( cmd.Pos("%file")>0 ) {
            TForm1::AnsiSplit(cmd,"%file",first,last);
            cmd=first+String(Form1->act->panel[Form1->act->active->Row].Name)+last;
        }
        doon->Text=cmd;
    }
    else if( archive==2 ) {
        if( Form1->GetCrPacInd(String(doon2->Text))==-1 ) {
            doon->Text="";
            return;
        }
        AnsiString cmd=Form1->cr_pacs[Form1->GetCrPacInd(String(doon2->Text))].HandleExtr;
        AnsiString first,last;

        if( cmd.Pos("%packfile")>0 ) {
            TForm1::AnsiSplit(cmd,"%packfile",first,last);
            cmd=first+String(Form1->act->dirloc->Text+Form1->act->panel[Form1->act->active->Row].Name)+last;
        }
        if( cmd.Pos("%destdir")>0 ) {
            TForm1::AnsiSplit(cmd,"%destdir",first,last);
            cmd=first+String(Form1->nact->dirloc->Text)+last;
        }
        if( cmd.Pos("%destfile")>0 ) {
            TForm1::AnsiSplit(cmd,"%destfile",first,last);
            cmd=first+String(Form1->act->panel[Form1->act->active->Row].Name.SubString(1,Form1->act->panel[Form1->act->active->Row].Name.Length()-Form1->act->panel[Form1->act->active->Row].ext.Length()))+last;
        }
        doon->Text=cmd;
    }
}
//---------------------------------------------------------------------------

