/****************************************************************
*                                                               *
*    Name: Action.h                                             *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the only input form to handle what the user    *
*        want. This will be shown if the user want to copy a    *
*        file, or want to find a file, but when if she/he want  *
*        change the permissions of files, too.                  *
*        So it is a universal input window.                     *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef ActionH
#define ActionH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include "Main.h"
//---------------------------------------------------------------------------
class TActionForm : public TForm
{
__published:	// IDE-managed Components
    TButton *Ok;
    TButton *Cancel;
    TCheckBox *symlinks;
    TCheckBox *recursive;
    TCheckBox *presattr;
    TLabel *mess1;
    TLabel *mess2;
    TComboBox *doon;
    TComboBox *doon2;
    void __fastcall OkClick(TObject *Sender);
    void __fastcall CancelClick(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall doonKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall doon2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall symlinksKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall recursiveKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall presattrKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall mess1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall mess2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall doon2Change(TObject *Sender);
private:	// User declarations
public:		// User declarations
    int status; // 0 - do nothing, 1 - ok, 2 - cancel
    int archive; // 0 - all case, 1 - if create archive, 2 - if unpack archive
    __fastcall TActionForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TActionForm *ActionForm;
//---------------------------------------------------------------------------
#endif
