/****************************************************************
*                                                               *
*    Name: Configure.cpp                                        *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the cpp file of the configuration form.        *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "Configure.h"
#include <stdio.h>
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TConfigForm *ConfigForm;
//---------------------------------------------------------------------------
__fastcall TConfigForm::TConfigForm(TComponent* Owner)
    : TForm(Owner)
{
    AnsiString programpath=Application->ExeName;
    if( programpath.Pos("/")>0 )
    while( programpath[programpath.Length()]!='/' )
        programpath=programpath.SubString(1,programpath.Length()-1);

    home=GetEnvironmentVariable("HOME");
    if( home=="")
        home=programpath;
    else
        home=home+"/";

    colwhat1->Items->Add("name");
    colwhat1->Items->Add("size");
    colwhat1->Items->Add("rights");
    colwhat1->Items->Add("link");
    colwhat1->Items->Add("date");
    colwhat2->Items->Add("name");
    colwhat2->Items->Add("size");
    colwhat2->Items->Add("rights");
    colwhat2->Items->Add("link");
    colwhat2->Items->Add("date");
    colwhat3->Items->Add("name");
    colwhat3->Items->Add("size");
    colwhat3->Items->Add("rights");
    colwhat3->Items->Add("link");
    colwhat3->Items->Add("date");
    colwhat4->Items->Add("name");
    colwhat4->Items->Add("size");
    colwhat4->Items->Add("rights");
    colwhat4->Items->Add("link");
    colwhat4->Items->Add("date");
    colwhat5->Items->Add("name");
    colwhat5->Items->Add("size");
    colwhat5->Items->Add("rights");
    colwhat5->Items->Add("link");
    colwhat5->Items->Add("date");
    scs=NULL;scn=0;
}
//---------------------------------------------------------------------------
void __fastcall TConfigForm::CloseClick(TObject *Sender)
{
    TForm::Close();
}
//---------------------------------------------------------------------------
void __fastcall TConfigForm::SaveClick(TObject *Sender)
{
    SaveFile();
}
//---------------------------------------------------------------------------

int TConfigForm::SaveFile()
{
    char cline[100];
    AnsiString line;
    FILE *filein;
    FILE *fileout;
    int mode=0; // 0 - general, 1 - ext, 2 - pack
try {


    filein = fopen((home+".vc/vc.cfg").c_str(), "rt");
    fileout = fopen((home+".vc/vc.cfg_new").c_str(), "w");
    if( !filein ) {
        ShowMessage("Error while saving the config file!");
        return 1;
    }

    if( !fileout ) {
        fclose(filein);
        ShowMessage("Error while saving the config file!");
        return 1;
    }

    do {
        fgets(cline, 200, filein);
        line=Trim(AnsiString(cline));

        if( line=="[general]" ) {
            mode=0;
        }
        if( line=="[color]" ) {
            mode=3;
        }
        if( line=="[package]" ) {
            mode=2;
        }
        if( line=="[extensions]" ) {
            mode=1;
        }
        if( line=="[create_package]" ) {
            mode=4;
        }
        if( line=="[version]" ) {
            mode=5;
        }

        if( line.Pos("=")>0 ) {
          if( mode==5 ) {
            AnsiString mnemo;
            AnsiString param;
            Form1->AnsiSplit(line,"=",mnemo,param);
            if( mnemo.AnsiCompare("version")==0 ) {
                fputs(String(mnemo+"="+Form1->configfile_version+"\n").c_str(),fileout);
            }
            else fputs(cline,fileout);
          }
        }

        if( line.Pos("=")>0 ) {
          if( mode==3 ) {
            AnsiString mnemo;
            AnsiString param;
            Form1->AnsiSplit(line,"=",mnemo,param);
            if( mnemo.AnsiCompare("col_panel_bg")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_bg)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_panel_font")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_font)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_panel_exec")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_exec)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_panel_hl_bg")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_hl_bg)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_panel_hl_font")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_hl_font)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_panel_hl_exec")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_hl_exec)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_panel_sel")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_panel_sel)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_cl_bg")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_cl_bg)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_cl_font")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_cl_font)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_button_bg")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_button_bg)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_button_font")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_button_font)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_bg")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_bg)+"\n").c_str(),fileout);
            } else
            if( mnemo.AnsiCompare("col_font")==0 ) {
                fputs(String(mnemo+"="+ColorToString(Form1->col_font)+"\n").c_str(),fileout);
            }
            else fputs(cline,fileout);
          }
        }

        if( line.Pos("=")>0 ) {
          if( mode==0 ) {
            AnsiString mnemo;
            AnsiString param;
            Form1->AnsiSplit(line,"=",mnemo,param);
            if( mnemo.AnsiCompare("execpath")==0 ) {
                fputs(String(mnemo+"="+execpath->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwidth1")==0 ) {
                fputs(String(mnemo+"="+IntToStr(colwidth1->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwidth2")==0 ) {
                fputs(String(mnemo+"="+IntToStr(colwidth2->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwidth3")==0 ) {
                fputs(String(mnemo+"="+IntToStr(colwidth3->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwidth4")==0 ) {
                fputs(String(mnemo+"="+IntToStr(colwidth4->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwidth5")==0 ) {
                fputs(String(mnemo+"="+IntToStr(colwidth5->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwhat1")==0 ) {
                fputs(String(mnemo+"="+colwhat1->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwhat2")==0 ) {
                fputs(String(mnemo+"="+colwhat2->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwhat3")==0 ) {
                fputs(String(mnemo+"="+colwhat3->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwhat4")==0 ) {
                fputs(String(mnemo+"="+colwhat4->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("colwhat5")==0 ) {
                fputs(String(mnemo+"="+colwhat5->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("packageprefix")==0 ) {
                fputs(String(mnemo+"="+packageprefix->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("tmppath")==0 ) {
                fputs(String(mnemo+"="+tmppath->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("extviewer")==0 ) {
                fputs(String(mnemo+"="+extviewer->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("exteditor")==0 ) {
                fputs(String(mnemo+"="+exteditor->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("execcompare")==0 ) {
                fputs(String(mnemo+"="+execcompare->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("dateformat")==0 ) {
                fputs(String(mnemo+"="+dateformat->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("showhiddenfiles")==0 ) {
                if( showhiddenfiles->Checked ) {
                    fputs(String(mnemo+"=true"+"\n").c_str(),fileout);
                } else {
                    fputs(String(mnemo+"=false"+"\n").c_str(),fileout);
                }
            } else if( mnemo.AnsiCompare("autocomplete")==0 ) {
                if( Autocomplete->Checked ) {
                    fputs(String(mnemo+"=true"+"\n").c_str(),fileout);
                } else {
                    fputs(String(mnemo+"=false"+"\n").c_str(),fileout);
                }
            } else if( mnemo.AnsiCompare("ignorecase")==0 ) {
                if( ignorecase->Checked ) {
                    fputs(String(mnemo+"=true"+"\n").c_str(),fileout);
                } else {
                    fputs(String(mnemo+"=false"+"\n").c_str(),fileout);
                }
            } else if( mnemo.AnsiCompare("humanread")==0 ) {
                if( humanread->Checked ) {
                    fputs(String(mnemo+"=true"+"\n").c_str(),fileout);
                } else {
                    fputs(String(mnemo+"=false"+"\n").c_str(),fileout);
                }
            } else if( mnemo.AnsiCompare("extls")==0 ) {
                if( extls->Checked ) {
                    fputs(String(mnemo+"=true"+"\n").c_str(),fileout);
                } else {
                    fputs(String(mnemo+"=false"+"\n").c_str(),fileout);
                }
            } else if( mnemo.AnsiCompare("maxtreads")==0 ) {
                fputs(String(mnemo+"="+IntToStr(maxthreads->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("copybytes")==0 ) {
                fputs(String(mnemo+"="+IntToStr(copybytes->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("fontheight")==0 ) {
                fputs(String(mnemo+"="+IntToStr(fontheight->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("fontweight")==0 ) {
                fputs(String(mnemo+"="+IntToStr(fontweight->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("viewerfontheight")==0 ) {
                fputs(String(mnemo+"="+IntToStr(viewerfontheight->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("viewerheight")==0 ) {
                fputs(String(mnemo+"="+IntToStr(viewerheight->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("viewerwidth")==0 ) {
                fputs(String(mnemo+"="+IntToStr(viewerwidth->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("dist")==0 ) {
                fputs(String(mnemo+"="+IntToStr(dist->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("topshift")==0 ) {
                fputs(String(mnemo+"="+IntToStr(topshift->Value)+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("iconset")==0 ) {
                if( iconset->Text=="KDE" )
                    fputs(String(mnemo+"=1\n").c_str(),fileout);
                else
                if( iconset->Text=="Gnome" )
                    fputs(String(mnemo+"=2\n").c_str(),fileout);
                else
                    fputs(String(mnemo+"=0\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("directory_mode")==0 ) {
                fputs(String(mnemo+"="+dir_pref->Text+"%DIR%"+dir_post->Text+"\n").c_str(),fileout);
            } else if( mnemo.AnsiCompare("dirstr")==0 ) {
                fputs(String(mnemo+"="+dirstr->Text+"\n").c_str(),fileout);
            } else fputs(cline,fileout);
          }
        } else fputs(cline,fileout);

//pacs
        if( mode==2 ) {
            pacs->Lines->SaveToFile(home+".vc/pacs");
            FILE* filepacs = fopen((home+".vc/pacs").c_str(), "rt");
            if( filepacs ) {
                do {
                    fgets(cline, 200, filepacs);
                    fputs(cline,fileout);
                } while( !feof(filepacs) );
                fclose(filepacs);
                DeleteFile(home+".vc/pacs");
            }
            mode=-1;
        }
// exts
        if( mode==1 ) {
            exts->Lines->SaveToFile(home+".vc/exts");
            FILE* fileexts = fopen((home+".vc/exts").c_str(), "rt");
            if( fileexts ) {
                do {
                    fgets(cline, 200, fileexts);
                    fputs(cline,fileout);
                } while( !feof(fileexts) );
                fclose(fileexts);
                DeleteFile(home+".vc/exts");
            }
            mode=-1;
        }

//create_pacs
        if( mode==4 ) {
            cr_pacs->Lines->SaveToFile(home+".vc/cr_pacs");
            FILE* filepacs = fopen((home+".vc/cr_pacs").c_str(), "rt");
            if( filepacs ) {
                do {
                    fgets(cline, 200, filepacs);
                    fputs(cline,fileout);
                } while( !feof(filepacs) );
                fclose(filepacs);
                DeleteFile(home+".vc/cr_pacs");
            }
            mode=-1;
        }

    } while ( !feof(filein) );

    fclose(filein);
    fclose(fileout);

    DeleteFile(home+".vc/vc.cfg_old");
    RenameFile(home+".vc/vc.cfg",home+".vc/vc.cfg_old");
    DeleteFile(home+".vc/vc.cfg");
    RenameFile(home+".vc/vc.cfg_new",home+".vc/vc.cfg");

    WriteSC();

    Form1->RereadConfig();
    return 0;
}
catch(...) {
    if( filein ) fclose(filein);
    if( fileout )fclose(fileout);
    ShowMessage("!!! Error while saving the config file !!!");
    return 0;
}

}

void __fastcall TConfigForm::FormShow(TObject *Sender)
{
    Font->Height=13;
    Label1->Font->Height=13;
    Label2->Font->Height=13;
    Label3->Font->Height=13;
    Label4->Font->Height=13;
    Label5->Font->Height=13;
    Label6->Font->Height=13;
    Label7->Font->Height=13;
    Label8->Font->Height=13;
    Label9->Font->Height=13;
    Label10->Font->Height=13;
    Label11->Font->Height=13;
    Label12->Font->Height=13;
    Label13->Font->Height=13;
    Label14->Font->Height=13;
    Label15->Font->Height=13;
    Label16->Font->Height=13;
    Label17->Font->Height=13;
    Label18->Font->Height=13;
    Label19->Font->Height=13;
    Label20->Font->Height=13;
    Label21->Font->Height=13;
    Label22->Font->Height=13;
    Label23->Font->Height=13;
    Label24->Font->Height=13;
    Label25->Font->Height=13;
    Label26->Font->Height=13;
    Label30->Font->Height=13;
    Label31->Font->Height=13;
    Label32->Font->Height=13;
    Label33->Font->Height=13;
    Label34->Font->Height=13;
    Label35->Font->Height=13;
    Label36->Font->Height=13;
    Label37->Font->Height=13;
    Label38->Font->Height=13;
    Label76->Font->Height=13;

    showhiddenfiles->Font->Height=13;
    Autocomplete->Font->Height=13;
    ignorecase->Font->Height=13;
    humanread->Font->Height=13;
    extls->Font->Height=13;

    execpath->Font->Height=13;
    packageprefix->Font->Height=13;
    tmppath->Font->Height=13;
    execcompare->Font->Height=13;
    extviewer->Font->Height=13;
    exteditor->Font->Height=13;
    dateformat->Font->Height=13;
    copybytes->Font->Height=13;
    maxthreads->Font->Height=13;
    Save->Font->Height=13;
    Close->Font->Height=13;
    colwidth1->Font->Height=13;
    colwidth2->Font->Height=13;
    colwidth3->Font->Height=13;
    colwidth4->Font->Height=13;
    colwidth5->Font->Height=13;
    colwhat1->Font->Height=13;
    colwhat2->Font->Height=13;
    colwhat3->Font->Height=13;
    colwhat4->Font->Height=13;
    colwhat5->Font->Height=13;
    fontheight->Font->Height=13;
    fontweight->Font->Height=13;
    viewerfontheight->Font->Height=13;
    viewerheight->Font->Height=13;
    viewerwidth->Font->Height=13;
    dist->Font->Height=13;
    topshift->Font->Height=13;
    iconset->Font->Height=13;
    dir_pref->Font->Height=13;
    dir_post->Font->Height=13;
    dirstr->Font->Height=13;
    exts->Font->Height=13;
    pacs->Font->Height=13;
    cr_pacs->Font->Height=13;
    BGrid1->Font->Height=13;


    PageControl1->Height=humanread->Top+(2*dir_pref->Height)+5;
    exts->Height=TabSheet4->Height;
    pacs->Height=exts->Height;
    cr_pacs->Height=exts->Height;
    BGrid1->Height=exts->Height;
    Save->Top=PageControl1->Height+15;
    Close->Top=Save->Top;
    Height=Save->Top+Save->Height+7;

    execpath->Left=Label15->Left+Label15->Width+Form1->osztas;
    packageprefix->Left=execpath->Left;
    tmppath->Left=execpath->Left;
    execcompare->Left=execpath->Left;
    extviewer->Left=execpath->Left;
    exteditor->Left=execpath->Left;
    dateformat->Left=execpath->Left;
    Label24->Left=execpath->Left;

    Label2->Left=packageprefix->Left+packageprefix->Width+Form1->osztas;
    Label16->Left=Label2->Left;
    Label19->Left=Label2->Left;
    Label21->Left=Label2->Left;
    Label23->Left=Label2->Left;
    Label30->Left=Label2->Left;
    Label31->Left=Label2->Left;
    Label79->Left=Label2->Left;
    copybytes->Left=Label31->Left+Label31->Width+Form1->osztas;
    maxthreads->Left=copybytes->Left;

    int fw=Label2->Left+Label2->Width;
    if( Label24->Left+Label24->Width>fw )
        fw=Label24->Left+Label24->Width;

    colwidth4->Left=Label3->Left+Label3->Width+Form1->osztas;
    colwidth2->Left=colwidth4->Left;
    colwidth3->Left=colwidth4->Left;
    colwidth1->Left=colwidth4->Left;
    colwidth5->Left=colwidth4->Left;

    colwhat4->Left=Label10->Left+Label10->Width+Form1->osztas;
    colwhat2->Left=colwhat4->Left;
    colwhat3->Left=colwhat4->Left;
    colwhat1->Left=colwhat4->Left;
    colwhat5->Left=colwhat4->Left;

    fontheight->Left=Label33->Left+Label33->Width+Form1->osztas;
    fontweight->Left=Label33->Left+Label33->Width+Form1->osztas;

    viewerfontheight->Left=Label35->Left+Label35->Width+Form1->osztas;
    dist->Left=Label35->Left+Label35->Width+Form1->osztas;

    viewerheight->Left=Label26->Left+Label26->Width+Form1->osztas;
    viewerwidth->Left=viewerheight->Left;

    if( Label76->Left<viewerfontheight->Left+viewerfontheight->Width )
        Label76->Left=viewerfontheight->Left+viewerfontheight->Width+Form1->osztas;
    Label38->Left=Label76->Left;
    iconset->Left=Label38->Left+Label38->Width+Form1->osztas;
    topshift->Left=iconset->Left;//Label76->Left+Label76->Width+Form1->osztas;

    dir_pref->Left=Label36->Left+Label36->Width+Form1->osztas;
    Label37->Left=dir_pref->Left+dir_pref->Width+Form1->osztas;
    dir_post->Left=Label37->Left+Label37->Width+Form1->osztas;

    Label77->Left=dir_post->Left+dir_post->Width+(Form1->osztas*3);
    dirstr->Left=Label77->Left+Label77->Width+Form1->osztas;

    PageControl1->Width=fw+15;
    Width=PageControl1->Width+15;
    exts->Width=PageControl1->Width-8;
    pacs->Width=exts->Width;
    cr_pacs->Width=exts->Width;
    BGrid1->Width=exts->Width-(Change->Width+Form1->osztas*2);
    Change->Left=BGrid1->Width+Form1->osztas;
    BGrid1->ColWidths[0]=330;
    if( BGrid1->Width-BGrid1->ColWidths[0]>0 )
        BGrid1->ColWidths[1]=BGrid1->Width-BGrid1->ColWidths[0];

    Close->Left=PageControl1->Left+PageControl1->Width-Close->Width;
    Save->Left=PageControl1->Left+PageControl1->Width-Close->Width-(2*Form1->osztas)-Save->Width;
    ver_warning->Left=PageControl1->Left;
    ver_warning->Top=Save->Top;
// end of form resize

// here start
    execpath->Text=Form1->execpath;
    if( Form1->fv1->ColWidths[1]>=0 && Form1->fv1->ColWidths[1]<=1000 )
        colwidth1->Value=Form1->fv1->ColWidths[1];
    else
        colwidth1->Value=64;
    if( Form1->fv1->ColWidths[2]>=0 && Form1->fv1->ColWidths[2]<=1000 )
        colwidth2->Value=Form1->fv1->ColWidths[2];
    else
        colwidth2->Value=64;
    if( Form1->fv1->ColWidths[3]>=0 && Form1->fv1->ColWidths[3]<=1000 )
        colwidth3->Value=Form1->fv1->ColWidths[3];
    else
        colwidth3->Value=64;
    if( Form1->fv1->ColWidths[4]>=0 && Form1->fv1->ColWidths[4]<=1000 )
        colwidth4->Value=Form1->fv1->ColWidths[4];
    else
        colwidth4->Value=64;
    if( Form1->fv1->ColWidths[5]>=0 && Form1->fv1->ColWidths[5]<=1000 )
        colwidth5->Value=Form1->fv1->ColWidths[5];
    else
        colwidth5->Value=64;
    colwhat1->Text=Form1->colwhat1;
    colwhat2->Text=Form1->colwhat2;
    colwhat3->Text=Form1->colwhat3;
    colwhat4->Text=Form1->colwhat4;
    colwhat5->Text=Form1->colwhat5;
    packageprefix->Text=Form1->packageprefix.SubString(Form1->programpath.Length()+1,Form1->packageprefix.Length()-Form1->programpath.Length()+1);
    tmppath->Text=Form1->tmppath;
    extviewer->Text=Form1->extviewer;
    exteditor->Text=Form1->exteditor;
    execcompare->Text=Form1->execcompare;
    dateformat->Text=Form1->dateformat;
    showhiddenfiles->Checked=true;
    Autocomplete->Checked=Form1->cl->AutoComplete;
    ignorecase->Checked=Form1->ignorecase;
    humanread->Checked=Form1->humanread;
    extls->Checked=Form1->extls;
    if( Form1->maxthreads>=1 && Form1->maxthreads<=30 )
        maxthreads->Value=Form1->maxthreads;
    else
        maxthreads->Value=5;
    if( Form1->copybytes>=10 && Form1->copybytes<=100000 )
        copybytes->Value=Form1->copybytes;
    else
        copybytes->Value=32765;
    if( Form1->Font->Height>=10 && Form1->Font->Height<=100 )
        fontheight->Value=Form1->Font->Height;
    else
        fontheight->Value=13;
    if( Form1->fv1->Font->Weight>=50 && Form1->fv1->Font->Weight<=150 )
        fontweight->Value=Form1->fv1->Font->Weight;
    else
        fontweight->Value=70;
    if( Form1->viewerfontheight>=10 && Form1->viewerfontheight<=100 )
        viewerfontheight->Value=Form1->viewerfontheight;
    else
        viewerfontheight->Value=13;
    if( Form1->viewerheight>=10 && Form1->viewerheight<=10000 )
        viewerheight->Value=Form1->viewerheight;
    else
        viewerheight->Value=300;
    if( Form1->viewerwidth>=10 && Form1->viewerwidth<=10000 )
        viewerwidth->Value=Form1->viewerwidth;
    else
        viewerwidth->Value=400;
    if( Form1->osztas>=0 && Form1->osztas<=100 )
        dist->Value=Form1->osztas;
    else
        dist->Value=2;
    if( Form1->topshift>=-10 && Form1->topshift<=10 )
        topshift->Value=Form1->topshift;
    else
        topshift->Value=2;
    if( Form1->iconset==0 ) iconset->Text="default"; else
    if( Form1->iconset==1 ) iconset->Text="KDE"; else
    if( Form1->iconset==2 ) iconset->Text="Gnome";
    dir_pref->Text=Form1->dir_pref;
    dir_post->Text=Form1->dir_post;
    dirstr->Text=Form1->dirstr;

    pacs->Clear();
    for( int i=0;i<Form1->pacs.Length();i++ ) {
        pacs->Lines->Add(Form1->pacs[i].Name+"_ext="+Form1->pacs[i].Ext);
        pacs->Lines->Add(Form1->pacs[i].Name+"_handle="+Form1->pacs[i].Handle);

        pacs->Lines->Add(Form1->pacs[i].Name+"_copyin="+BoolToStr(Form1->pacs[i].copyin,true).LowerCase());
        pacs->Lines->Add(Form1->pacs[i].Name+"_copyout="+BoolToStr(Form1->pacs[i].copyout,true).LowerCase());
        pacs->Lines->Add(Form1->pacs[i].Name+"_rm="+BoolToStr(Form1->pacs[i].rm,true).LowerCase());
        pacs->Lines->Add(Form1->pacs[i].Name+"_dir="+BoolToStr(Form1->pacs[i].dir,true).LowerCase());
        pacs->Lines->Add(Form1->pacs[i].Name+"_run="+BoolToStr(Form1->pacs[i].run,true).LowerCase());

        pacs->Lines->Add("");
    }

    cr_pacs->Clear();
    for( int i=0;i<Form1->cr_pacs.Length();i++ ) {
        cr_pacs->Lines->Add(Form1->cr_pacs[i].Name+"_ext="+Form1->cr_pacs[i].Ext);
        cr_pacs->Lines->Add(Form1->cr_pacs[i].Name+"_handle="+Form1->cr_pacs[i].Handle);
        cr_pacs->Lines->Add(Form1->cr_pacs[i].Name+"_handleextr="+Form1->cr_pacs[i].HandleExtr);
        cr_pacs->Lines->Add("");
    }

    exts->Clear();
    for( int i=0;i<Form1->exts.Length();i++ ) {
        exts->Lines->Add(Form1->exts[i].Name+"_ext="+Form1->exts[i].Ext);
        exts->Lines->Add(Form1->exts[i].Name+"_handle="+Form1->exts[i].Handle);

        exts->Lines->Add("");
    }

    if( Form1->configfile_version==Form1->act_configfile_version )
        ver_warning->Caption="";
    else
        ver_warning->Caption="Your configfile version: "+Form1->configfile_version+", but program require version: "+Form1->act_configfile_version+"!";
    RefreshSC();
    Save->SetFocus();
}
//---------------------------------------------------------------------------

int TConfigForm::CallKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
// close: esc, F3, F10
    if( Key==4096 || Key==4146 || Key==4153 ) {
        TForm::Close();
    }

// save and apply: enter
    if( Key==4100 || Key==4101 ) {
        SaveFile();
    }
    return 0;
}

int TConfigForm::CallKeyDown2(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
// close: esc, F3, F10
    if( Key==4096 || Key==4146 || Key==4153 ) {
        TForm::Close();
    }
    return 0;
}

void __fastcall TConfigForm::SaveKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown2(Sender,Key,Shift);
}
//---------------------------------------------------------------------------


void __fastcall TConfigForm::CloseKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown2(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::execpathKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::packageprefixKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::tmppathKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::execcompareKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::exteditorKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::dateformatKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::showhiddenfilesKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::ignorecaseKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::humanreadKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::colwhat1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::colwhat2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::colwhat3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::colwhat4KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::colwhat5KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::dir_prefKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::dir_postKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::hotdir1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::hotdir2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::hotdir3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::hotdir4KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::hotdir5KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::extsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown2(Sender,Key,Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::pacsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown2(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void TConfigForm::RefreshSC()
{
    if( scs ) {delete []scs;}
    scn=45;
    scs=new MySC[scn];

    scs[0].what="Sort by Name";
    scs[0].sc=&(Form1->Sortbyname1->ShortCut);
    scs[1].what="Sort by Size";
    scs[1].sc=&(Form1->Sortbysize1->ShortCut);
    scs[2].what="Sort by Date";
    scs[2].sc=&(Form1->Sortbydate1->ShortCut);
    scs[3].what="Sort Dir. Asc.";
    scs[3].sc=&(Form1->Invertsortdirection1->ShortCut);
    scs[4].what="Sort Dir. Desc.";
    scs[4].sc=&(Form1->Sortdirection1->ShortCut);
    scs[5].what="View";
    scs[5].sc=&(Form1->F3View1->ShortCut);
    scs[6].what="Edit";
    scs[6].sc=&(Form1->F4Edit1->ShortCut);
    scs[7].what="Create File";
    scs[7].sc=&(Form1->CreateFile1->ShortCut);
    scs[8].what="Copy";
    scs[8].sc=&(Form1->F5Copy1->ShortCut);
    scs[9].what="Move";
    scs[9].sc=&(Form1->F6Move1->ShortCut);
    scs[10].what="Rename";
    scs[10].sc=&(Form1->Rename1->ShortCut);
    scs[11].what="Create Directory";
    scs[11].sc=&(Form1->F7CreateDirectory1->ShortCut);
    scs[12].what="Delete";
    scs[12].sc=&(Form1->F8Delete1->ShortCut);
    scs[13].what="Main Menu";
    scs[13].sc=&(Form1->MainMenu2->ShortCut);
    scs[14].what="Exit";
    scs[14].sc=&(Form1->F10Exit1->ShortCut);
    scs[15].what="Create Symlink";
    scs[15].sc=&(Form1->Createsymlink1->ShortCut);
    scs[16].what="Edit Symlink";
    scs[16].sc=&(Form1->Editsymlink1->ShortCut);
    scs[17].what="Chmod";
    scs[17].sc=&(Form1->Chmod1->ShortCut);
    scs[18].what="Chown";
    scs[18].sc=&(Form1->Chown1->ShortCut);
    scs[19].what="Find File";
    scs[19].sc=&(Form1->Findfile1->ShortCut);
    scs[20].what="Target = Source Dir.";
    scs[20].sc=&(Form1->TargetdirSourcedir1->ShortCut);
    scs[21].what="Compare by Content";
    scs[21].sc=&(Form1->Comparebycontent1->ShortCut);
    scs[22].what="Reread Dir. Content";
    scs[22].sc=&(Form1->Rereaddirectory1->ShortCut);
    scs[23].what="Show All Dir. Size";
    scs[23].sc=&(Form1->ShowAllDirectorySize1->ShortCut);
    scs[24].what="Bookmark";
    scs[24].sc=&(Form1->ActivateBookmark1->ShortCut);
    scs[25].what="Invert Selection";
    scs[25].sc=&(Form1->Selectinvert1->ShortCut);
    scs[26].what="Invert Selection by Mask";
    scs[26].sc=&(Form1->Selectinvertbymask1->ShortCut);
    scs[27].what="Selection None";
    scs[27].sc=&(Form1->Selectionnone1->ShortCut);
    scs[28].what="Seletction All";
    scs[28].sc=&(Form1->SelectAll1->ShortCut);
    scs[29].what="New FTP Connection";
    scs[29].sc=&(Form1->NewFtpConnection1->ShortCut);
    scs[30].what="Close FTP Connection";
    scs[30].sc=&(Form1->CloseFTPConnection1->ShortCut);
    scs[31].what="Configure";
    scs[31].sc=&(Form1->Configure1->ShortCut);
    scs[32].what="Reread Config File";
    scs[32].sc=&(Form1->Rereadconfigfile1->ShortCut);
    scs[33].what="Free Child Processes";
    scs[33].sc=&(Form1->Freechildprocesses1->ShortCut);
    scs[34].what="Incriese Font Size";
    scs[34].sc=&(Form1->IncrieseFontSize1->ShortCut);
    scs[35].what="Decrease Font Size";
    scs[35].sc=&(Form1->DecreaseFontSize1->ShortCut);
    scs[36].what="Help";
    scs[36].sc=&(Form1->Help2->ShortCut);
    scs[37].what="About";
    scs[37].sc=&(Form1->About1->ShortCut);
    scs[38].what="Internal Viewer";
    scs[38].sc=&(Form1->InternalView1->ShortCut);
    scs[39].what="Multi Rename Tool";
    scs[39].sc=&(Form1->MultiRenameTool1->ShortCut);
    scs[40].what="Add new bookmark";
    scs[40].sc=&(Form1->bmsc);
    scs[41].what="New tab";
    scs[41].sc=&(Form1->NewTab->ShortCut);
    scs[42].what="Close tab";
    scs[42].sc=&(Form1->CloseTab->ShortCut);
    scs[43].what="Create archive file";
    scs[43].sc=&(Form1->CreateArchiveFile1->ShortCut);
    scs[44].what="Unpack archive file";
    scs[44].sc=&(Form1->UnpackArchiveFile1->ShortCut);
    BGrid1->RowCount=scn;
    BGrid1->Invalidate();
}
//---------------------------------------------------------------------------

void TConfigForm::WriteSC()
{
    FILE *filein = fopen((home+".vc/shortcuts").c_str(), "w");
    if( !filein ) return;
try {
    for( int i=0;i<scn;i++ )
        fputs(String(IntToStr(*scs[i].sc)+"\n").c_str(),filein);
    fclose(filein);
} catch (...) {try{fclose(filein);}catch(...){}}
}

void __fastcall TConfigForm::AutocompleteKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button1Click(TObject *Sender)
{
    FontDialog1->Font=Form1->Font;

    FontDialog1->Execute();

    Form1->Font=FontDialog1->Font;

    Form1->Resize_my();
}
//---------------------------------------------------------------------------


void __fastcall TConfigForm::Button3Click(TObject *Sender)
{
    FontDialog1->Font=Form1->free1->Font;

    FontDialog1->Execute();

    Form1->dirloc1->Font=FontDialog1->Font;
    Form1->dirloc2->Font=FontDialog1->Font;
    Form1->selbar1->Font=FontDialog1->Font;
    Form1->selbar2->Font=FontDialog1->Font;
    Form1->free1->Font=FontDialog1->Font;
    Form1->free2->Font=FontDialog1->Font;
    Form1->ShowPath->Font=FontDialog1->Font;

    Form1->Resize_my();
}
//---------------------------------------------------------------------------


void __fastcall TConfigForm::Button6Click(TObject *Sender)
{
    FontDialog1->Font=Form1->cl->Font;

    FontDialog1->Execute();

    Form1->cl->Font=FontDialog1->Font;

    Form1->Resize_my();
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button5Click(TObject *Sender)
{
    FontDialog1->Font=Form1->StatusBar1->Font;

    FontDialog1->Execute();

    Form1->StatusBar1->Font=FontDialog1->Font;

    Form1->Resize_my();
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button7Click(TObject *Sender)
{
    FontDialog1->Font=Form1->fv1->Font;

    FontDialog1->Execute();

    Form1->fv1->Font=FontDialog1->Font;
    Form1->fv2->Font=FontDialog1->Font;

    Form1->Resize_my();
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button2Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_bg;

    ColorDialog1->Execute();

    Form1->col_panel_bg=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button4Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_font;

    ColorDialog1->Execute();

    Form1->col_panel_font=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button8Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_exec;

    ColorDialog1->Execute();

    Form1->col_panel_exec=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button9Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_hl_bg;

    ColorDialog1->Execute();

    Form1->col_panel_hl_bg=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button10Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_hl_font;

    ColorDialog1->Execute();

    Form1->col_panel_hl_font=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button11Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_hl_exec;

    ColorDialog1->Execute();

    Form1->col_panel_hl_exec=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button12Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_panel_sel;

    ColorDialog1->Execute();

    Form1->col_panel_sel=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button13Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_cl_bg;

    ColorDialog1->Execute();

    Form1->col_cl_bg=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button14Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_cl_font;

    ColorDialog1->Execute();

    Form1->col_cl_font=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button15Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_button_bg;

    ColorDialog1->Execute();

    Form1->col_button_bg=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button16Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_button_font;

    ColorDialog1->Execute();

    Form1->col_button_font=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button17Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_bg;

    ColorDialog1->Execute();

    Form1->col_bg=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button18Click(TObject *Sender)
{
    ColorDialog1->Color=Form1->col_font;

    ColorDialog1->Execute();

    Form1->col_font=ColorDialog1->Color;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button19Click(TObject *Sender)
{
Form1->col_panel_bg=clBase;
Form1->col_panel_font=clBlack;
Form1->col_panel_exec=clBlue;
Form1->col_panel_hl_bg=clHighlight;
Form1->col_panel_hl_font=clHighlightText;
Form1->col_panel_hl_exec=clAqua;
Form1->col_panel_sel=clRed;
Form1->col_cl_bg=clBase;
Form1->col_cl_font=clBlack;
Form1->col_button_bg=clBackground;
Form1->col_button_font=clBlack;
Form1->col_bg=clBackground;
Form1->col_font=clBlack;
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button20Click(TObject *Sender)
{
Form1->col_panel_bg=clBlack;
Form1->col_panel_font=0x00D6D6D6;
Form1->col_panel_exec=clWhite;
Form1->col_panel_hl_bg=0x00959595;
Form1->col_panel_hl_font=clWhite;
Form1->col_panel_hl_exec=clWhite;
Form1->col_panel_sel=clRed;
Form1->col_cl_bg=clBlack;
Form1->col_cl_font=0x00DEDEDE;
Form1->col_button_bg=clBackground;
Form1->col_button_font=clBlack;
Form1->col_bg=clBackground;
Form1->col_font=clBlack;

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::dirstrKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::extlsKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::Button21Click(TObject *Sender)
{
    FontDialog1->Font=Form1->viewerfont->Font;

    FontDialog1->Execute();

    Form1->viewerfont->Font=FontDialog1->Font;

    Form1->Resize_my();

}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::extviewerKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::BGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
    if( ARow<scn )
        if( ACol==0 )
            BGrid1->Canvas->TextRect(Rect,Rect.Left,Rect.Top,scs[ARow].what);
        else
            BGrid1->Canvas->TextRect(Rect,Rect.Left,Rect.Top,ShortCutToText(*scs[ARow].sc));
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::ChangeClick(TObject *Sender)
{
    NewShortCutForm->ShowModal();
    if( NewShortCutForm->shortcut==-1 ) return;

    if( BGrid1->Row<scn )
        *scs[BGrid1->Row].sc=(unsigned short)NewShortCutForm->shortcut;
    RefreshSC();
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::BGrid1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( Key==4103 && BGrid1->Row<scn ) {
        *scs[BGrid1->Row].sc=0;
        RefreshSC();
    }
    if( (Key==4100 || Key==4101) && BGrid1->Row<scn ) {
        NewShortCutForm->ShowModal();
        if( NewShortCutForm->shortcut==-1 ) return;

        if( BGrid1->Row<scn )
            *scs[BGrid1->Row].sc=(unsigned short)NewShortCutForm->shortcut;
        RefreshSC();
    }
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::ChangeKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( Key==4103 && BGrid1->Row<scn) {
        *scs[BGrid1->Row].sc=0;
        RefreshSC();
    }
}
//---------------------------------------------------------------------------


void __fastcall TConfigForm::FormCreate(TObject *Sender)
{
    SetFocus();
}
//---------------------------------------------------------------------------


void __fastcall TConfigForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    Action=caFree;
}
//---------------------------------------------------------------------------

void __fastcall TConfigForm::BGrid1DblClick(TObject *Sender)
{
    NewShortCutForm->ShowModal();
    if( NewShortCutForm->shortcut==-1 ) return;

    if( BGrid1->Row<scn )
        *scs[BGrid1->Row].sc=(unsigned short)NewShortCutForm->shortcut;
    RefreshSC();
}
//---------------------------------------------------------------------------


void __fastcall TConfigForm::iconsetChange(TObject *Sender)
{
    if( iconset->Text=="KDE" )
        Form1->iconset=1;
    else
    if( iconset->Text=="Gnome" )
        Form1->iconset=2;
    else
        Form1->iconset=0;
    Form1->fv1->Invalidate();
    Form1->fv2->Invalidate();
}
//---------------------------------------------------------------------------

