/****************************************************************
*                                                               *
*    Name: Main.cpp                                             *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        The CPP file of the main form.                         *
*        It also contains, some classes to handle threads       *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "Main.h"
#include "const.h"
#include "Configure.h"
#include <stdio.h>
#include <wait.h>
#include <sys/types.h>
#include <sys/stat.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"


TForm1 *Form1;
//---------------------------------------------------------------------------
void readstr(FILE *f,char *string)                                      // Read
{
    do {
        fgets(string, 200, f);
    } while (
        !feof(f) &&
        ((string[0] == '#') || (string[0] == '/') || (string[0] == '\n'))
    );
   return;
}
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{       
    act_configfile_version="0.1";
    configfile_version="0.0";

    col_panel_bg=fv1->Color;
    col_panel_font=fv1->Font->Color;
    col_panel_exec=clBlue;
    col_panel_hl_bg=clHighlight;
    col_panel_hl_font=clHighlightText;
    col_panel_hl_exec=clAqua;
    col_panel_sel=clRed;
    col_cl_bg=cl->Color;
    col_cl_font=cl->Font->Color;
    col_button_bg=clBackground;
    col_button_font=clBlack;
    col_bg=clBackground;
    col_font=clBlack;
    viewerfont->Font->Name="misc-fixed";
    viewerfont->Font->Height=13;
    viewerfont->Font->Pitch=fpFixed;

    readedconfig=false;
    osztas=2;
    topshift=2;
    iconset=0;
    humanread=false;
    viewerfontheight=13;
    viewerheight=480;
    viewerwidth=640;
    nowrefresh=true;
    prate=1.0f/2.0f;
    dirstr="Dir";
    extls=false;

    bm_theline=NULL;
    bm_addnew=NULL;
    bm_config=NULL;
    bmsc=16450;

    maxthreads=-1;
    copybytes=32765;

    uid=getuid();
    gid=getgid();

    ignorecase=true;

    execpath="xterm -e";
    tmppath="/tmp/";

    programpath=Application->ExeName;
    if( programpath.Pos("/")>0 )
    while( programpath[programpath.Length()]!='/' )
        programpath=programpath.SubString(1,programpath.Length()-1);

    home=GetEnvironmentVariable("HOME");
    if( home=="")
        home=programpath;
    else
        home=home+"/";

    packageprefix=programpath+"pack/";

    panels=new CAct[2];
    act=&panels[0];
    nact=&panels[1];
    act->num=0;
    act->active=fv1;
    act->dirloc=dirloc1;
    act->sb=sb1;
    act->selbar=selbar1;
    act->free=free1;
    act->tabs=tabs1;
    nact->num=1;
    nact->active=fv2;
    nact->dirloc=dirloc2;
    nact->sb=sb2;
    nact->selbar=selbar2;
    nact->free=free2;
    nact->tabs=tabs2;


    dirloc1->Text=panels[0].dirent->Location();
    dirloc2->Text=panels[1].dirent->Location();
    ShowPath->Caption=panels[0].dirent->Location();

    ChPanel(1);

    nact->RefreshPanel();act->RefreshPanel();
    fv1->ColWidths[0]=18;
    fv2->ColWidths[0]=18;
    act->active->SetFocus();

    if( Form1->Font->Height>Form1->Font->Size ) {
        fv1->DefaultRowHeight=Form1->Font->Height+5;
        fv2->DefaultRowHeight=Form1->Font->Height+5;
    } else {
        fv1->DefaultRowHeight=Form1->Font->Size+8;
        fv2->DefaultRowHeight=Form1->Font->Size+8;
    }

// setup from the config file
    RereadConfig();
    readcommandline();
    readpositions();
    Resize_my();
    if( maxthreads==-1 ) {
        maxthreads=5;
        if( copy_thread ) delete []copy_thread;
        if( viewforms ) delete []viewforms;
        copy_thread=new CMyThread*[maxthreads];
        viewforms=new TViewForm*[maxthreads];
        for( int i=0;i<maxthreads;i++ ) {
            viewforms[i]=NULL;
            copy_thread[i]=new CMyThread(true);
        }
    }

    MkDir(tmppath+"fctmp"+IntToStr(uid));
    startwithxterm->Down=true;
    prcss_n=0;

    Resize();
    Resize_my();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::About1Click(TObject *Sender)
{
    ShowMessage(Caption+"\n by\n Balzs Tuska <btuska@elte.hu>");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Form1->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::fv1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)>=1 ) Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::fv2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)>=1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::clKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::clKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)>=1 ) Key = 0;
}
//---------------------------------------------------------------------------

int TForm1::CallKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    chk_pcss();
    int ret=0;
    if( Key<65566 ) {
        if( Shift.Contains(ssAlt) && ((64<Key && Key<130) || (45<Key && Key<58)) ) {
            char el[1];
            if( 64<Key && Key<91 )
                el[0]=char(Key+32);
            else
                el[0]=char(Key);
            pfind=pfind+String(el).SubString(1,1);
            StatusBar1->SimpleText=pfind;
            for( int i=act->active->Row;; ) {
                AnsiString ebben=AnsiString(act->panel[i].Name).LowerCase();
                if( ebben.Pos(pfind)==1 ) {
                    act->active->Row=i;
                    break;
                }
                if( i+1==act->active->Row || (i+1==act->active->RowCount && act->active->Row==0) ) break;
                if( i+1<act->active->RowCount ) i++; else i=0;
            }
            return 1;
        }

        if( ( ( 33<Key && Key<130 && Key!=42 && Key!=43  && Key!=45 && !Shift.Contains(ssCtrl) ) || Key==4099 || Key==65535 ) || ( cl->Focused() && ( Key==4128 || Key==4114 || Key==4116 || Key==4112 || Key==4113 || Key==32 || Key==42 || Key==43 || Key==45 || Key==4103 || Key==4097 ) ) ) {
            if( !cl->Focused() )
            if( 64<Key && Key<91 && !Shift.Contains(ssShift) ) {
                char el[1];
                el[0]=char(Key+32);
                cl->Text=cl->Text+String(el).SubString(1,1);
            } else if( 33<Key && Key<130 ) {
                char el[1];
                el[0]=char(Key);
                cl->Text=cl->Text+String(el).SubString(1,1);
            }

            if( Key==4099 ) {
                if( !cl->Focused() && cl->Text!="" ) {
                    cl->Text=cl->Text.SubString(1,cl->Text.Length()-1);
                }
                if( !cl->Focused() && cl->Text=="" ) {
                    act->cdpp();
                    act->RefreshPanel();
                    return 1;
                }
            }

            if( !cl->Focused() ) {
                cl->SetFocus();
                cl->SelStart=cl->Text.Length();
                cl->SelLength=0;
                ret=1;
            }
            return 0;
        } else {

            if( !act->active->Focused() ) {
// up
                if( Key==4115 ) {
                    if( act->active->Row>0 ) act->active->Row--;
                } else
// down
                if( Key==4117 ) {
                    if( act->active->Row<act->active->RowCount-1 ) act->active->Row++;
                } else
// home
                if( Key==4112 ) {
                    act->active->Row=0;
                } else
// end
                if( Key==4113 ) {
                    act->active->Row=act->active->RowCount-1;
                }
                SetStatusBar();
                act->active->SetFocus();
                ret=1;
            }

        }
    }
    return RefreshButtons(Key,Shift)+ret;
}
//---------------------------------------------------------------------------

void TForm1::CallKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( Key==4131 ) pfind="";
}
//---------------------------------------------------------------------------

int TForm1::RefreshButtons(int Key,TShiftState Shift)
{
// ctrl-down (pull down commandline)
    if( ( Key==4117 || Key==4115 ) && Shift.Contains(ssCtrl) ) {
        cl->DroppedDown=true;
        return 1;
    }

// tab
    if( Key==4097 ) {
        if( Shift.Contains(ssCtrl) ) {
            if( Shift.Contains(ssShift) ) {
                if( act->tabs->TabIndex>0 )
                    act->tabs->TabIndex--;
                else
                    act->tabs->TabIndex=act->tabs->Tabs->Count-1;
            } else {
                if( act->tabs->TabIndex<act->tabs->Tabs->Count-1 )
                    act->tabs->TabIndex++;
                else
                    act->tabs->TabIndex=0;
            }
            act->dirloc->Text=act->tabs->Tabs->Items[act->tabs->TabIndex]->Caption;
            act->RefreshPanel();
        } else {
            ChPanel();
            if( !act->active->Focused() )
                act->active->SetFocus();
        }
        return 1;
    }

// esc
    if( Key==4096 ) {
        cl->Text="";
        return 1;
    }

// Enter
    if( Key==4100 || Key==4101 ) {
        if( Shift.Contains(ssCtrl) ) {
            Ctrl_Enter_my(Shift);
            SetStatusBar();
            return 1;
        }
        if( Shift.Contains(ssAlt) && Shift.Contains(ssShift) ) {
            act->ShowAllDirectorySize();
            SetStatusBar();
            return 1;
        }
        if( cl->Text=="" ) {
            act->Enter_my();
        } else {
            if( cl->Text.Pos("cd")==1 ) {
                if( act->mode==NORMAL ) {
                    if( cl->Text.Pos(" ")>0 && cl->Text.Pos(" ")<cl->Text.Length() ) {
                        if( String(Trim(cl->Text.SubString(4,cl->Text.Length()-3)))==".." ) {
                            act->cdpp();
                        } else
                        if( String(Trim(cl->Text.SubString(4,cl->Text.Length()-3)))[1]=='/' )
                            act->dirloc->Text=Trim(cl->Text.SubString(4,cl->Text.Length()-3));
                        else
                            act->dirloc->Text=act->dirloc->Text+Trim(cl->Text.SubString(4,cl->Text.Length()-3));
                        if( String(act->dirloc->Text)[act->dirloc->Text.Length()]!='/' ) act->dirloc->Text=act->dirloc->Text+"/";
                    } else
                        act->dirloc->Text=home;
                    act->RefreshPanel();
                } else if( act->mode==FTP ) {
                    if( cl->Text.Pos(" ")>0 && cl->Text.Pos(" ")<cl->Text.Length() ) {
                        if( String(Trim(cl->Text.SubString(4,cl->Text.Length()-3)))==".." ) {
                            act->cdpp();
                        } else {
                            if( String(Trim(cl->Text.SubString(4,cl->Text.Length()-3)))[1]=='/' ) {
                                act->archdir=Trim(cl->Text.SubString(4,cl->Text.Length()-3));
                                if( String(act->archdir)[act->archdir.Length()]!='/' ) act->archdir=act->archdir+"/";
                                act->dirloc->Text="ftp://"+act->servername+act->archdir;
                                act->prevdir=act->dirloc->Text+"..";
                            } else {
                                act->archdir=act->archdir+Trim(cl->Text.SubString(4,cl->Text.Length()-3));
                                if( String(act->archdir)[act->archdir.Length()]!='/' ) act->archdir=act->archdir+"/";
                                act->dirloc->Text="ftp://"+act->servername+act->archdir;
                                act->prevdir=act->dirloc->Text+"..";
                            }
                        }
                        act->RefreshPanel();
                    }
                }
            } else {
                if( cl->Text.Pos(">") || cl->Text.Pos("<"))
                    ExecCmd(String(cl->Text),false);
                else
                    ExecCmd(String(cl->Text),startwithxterm->Down);
            }
            try {
                if( cl->Items->Add(String(cl->Text))==cl->MaxItems ) cl->Items->Delete(cl->MaxItems-1);
            } catch(...) {}
            cl->Text="";
        }
        return 0;
    }
// Shift-F5
    if( Key==4148 ) {
        act->Copy_my(nact,Shift);
        return 1;
    }
// Insert
    if( Key==4102 ) {
        if( act->active->Row==0 ) {
            if( act->active->Row<act->active->RowCount-1 )
                act->active->Row++;
            return 0;
        }
        act->panel[act->active->Row].Selected=!act->panel[act->active->Row].Selected;
        if( act->panel[act->active->Row].Selected ) {
            act->selected++;
            act->selected_bytes+=act->panel[act->active->Row].Size;
        } else {
            act->selected--;
            act->selected_bytes-=act->panel[act->active->Row].Size;
        }
        if( act->active->Row<act->active->RowCount-1 )
            act->active->Row++;
        else
            act->active->Invalidate();
        act->RefreshSelBar();
        return 0;
    }
// Ctrl-pgup
    if( Key==4118 ) {
        if( Shift.Contains(ssCtrl) ) {
            act->active->Row=0;
            act->Enter_my();
            return 1;
        }
    }
// Ctrl-pgdn
    if( Key==4119 ) {
        if( Shift.Contains(ssCtrl) ) {
            act->Enter_my();
            return 1;
        }
    }

// space
    if( Key==32 ) {
        nowrefresh=false;
        if( act->mode==NORMAL && act->panel[act->active->Row].Type=="Directory" && act->panel[act->active->Row].Name!=".." ) {
            act->panel[act->active->Row].Size=act->GetDirSize(String(act->dirloc->Text+act->panel[act->active->Row].Name));
            act->active->Invalidate();
        }
        nowrefresh=true;
        return 0;
    }
    return 0;
}
//---------------------------------------------------------------------------

int TForm1::Exit_my()
{
    writecommandline();
    writepositions();
    writebookmark();
    WriteTabs();
    return 0;
}
//---------------------------------------------------------------------------

int TForm1::Ctrl_Enter_my(TShiftState Shift)
{
    if( act->active->Row==0 )
        cl->Text=cl->Text+act->dirloc->Text;
    else {
        if( Shift.Contains(ssShift) ) cl->Text=cl->Text+act->dirloc->Text;
        cl->Text=cl->Text+act->panel[act->active->Row].Name;
    }
    return 0;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::F5Copy1Click(TObject *Sender)
{
    act->Copy_my(nact,*(new TShiftState));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F10Exit1Click(TObject *Sender)
{
    Form1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F8Delete1Click(TObject *Sender)
{
    act->Delete_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F6Move1Click(TObject *Sender)
{
    act->Move_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F7CreateDirectory1Click(TObject *Sender)
{
    act->MkDir_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv1DrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
{
    AnsiString colwhatx="";
    CAct *most=act;
    if( !most->panel ) return;
    if( nact->num==0 ) most=nact;
    if( most->panel[ARow].exec ) {
        if( ARow==fv1->Row && act->num==0 )
            fv1->Canvas->Font->Color=col_panel_hl_exec;
        else
            fv1->Canvas->Font->Color=col_panel_exec;
    } else {
        if( ARow==fv1->Row && act->num==0 )
            fv1->Canvas->Font->Color=col_panel_hl_font;
        else
            fv1->Canvas->Font->Color=col_panel_font;
    }

    if( most->panel[ARow].Selected )
        fv1->Canvas->Font->Color=col_panel_sel;

    if( act->num==0 && ARow==fv1->Row ) {
        fv1->Canvas->Brush->Color=col_panel_hl_bg;
        SetStatusBar();
    } else
        fv1->Canvas->Brush->Color=col_panel_bg;

    fv1->Canvas->FillRect(Rect);
    switch (ACol) {
        case 0:
            if( iconset==1 )
                imglst2->Draw(fv1->Canvas,Rect.Left,Rect.Top,most->panel[ARow].ii);
            else
            if( iconset==2 )
                imglst3->Draw(fv1->Canvas,Rect.Left,Rect.Top,most->panel[ARow].ii);
            else
                imglst->Draw(fv1->Canvas,Rect.Left,Rect.Top,most->panel[ARow].ii);
            break;
        case 1: colwhatx=colwhat1;
            break;
        case 2: colwhatx=colwhat2;
            break;
        case 3: colwhatx=colwhat3;
            break;
        case 4: colwhatx=colwhat4;
            break;
        case 5: colwhatx=colwhat5;
            break;
    }

    int topplus=(fv1->DefaultRowHeight-fv1->Font->Size)/2-topshift;
                if( colwhatx=="name") {
                    if( most->panel[ARow].Type=="Directory" )
                        fv1->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,dir_pref+most->panel[ARow].Name+dir_post);
                    else
                        fv1->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Name);
                } else if( colwhatx=="size") {
                    AnsiString newsize=HumanSize(most->panel[ARow].Size,most->panel[ARow].Type);
                    fv1->Canvas->TextRect(Rect,Rect.Right-10-fv1->Canvas->TextWidth(newsize),Rect.Top-topplus,newsize);
                } else if( colwhatx=="date") {
                    fv1->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Date);
                } else if( colwhatx=="rights") {
                    fv1->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Mask);
                } else if( colwhatx=="link") {
                    fv1->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Link);
                }
    if( most->panel[ARow].Focused ) {
        fv1->Row=ARow ;
        most->panel[ARow].Focused=false;
    }
    if( fv1->Row==ARow )
        sb1->Position=fv1->TopRow;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2DrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
{
    AnsiString colwhatx="";
    CAct *most=act;
    if( !most->panel ) return;
    if( nact->num==1 ) most=nact;
    if( most->panel[ARow].exec ) {
        if( ARow==fv2->Row && act->num==1 )
            fv2->Canvas->Font->Color=col_panel_hl_exec;
        else
            fv2->Canvas->Font->Color=col_panel_exec;
    } else {
        if( ARow==fv2->Row && act->num==1 )
            fv2->Canvas->Font->Color=col_panel_hl_font;
        else
            fv2->Canvas->Font->Color=col_panel_font;
    }

    if( most->panel[ARow].Selected )
        fv2->Canvas->Font->Color=col_panel_sel;

    if( act->num==1 && ARow==fv2->Row ) {
        fv2->Canvas->Brush->Color=col_panel_hl_bg;
        SetStatusBar();
    } else
        fv2->Canvas->Brush->Color=col_panel_bg;

    fv2->Canvas->FillRect(Rect);

    switch (ACol) {
        case 0:
            if( iconset==1 )
                imglst2->Draw(fv2->Canvas,Rect.Left,Rect.Top,most->panel[ARow].ii);
            else
            if( iconset==2 )
                imglst3->Draw(fv2->Canvas,Rect.Left,Rect.Top,most->panel[ARow].ii);
            else
                imglst->Draw(fv2->Canvas,Rect.Left,Rect.Top,most->panel[ARow].ii);
                break;
        case 1: colwhatx=colwhat1;
            break;
        case 2: colwhatx=colwhat2;
            break;
        case 3: colwhatx=colwhat3;
            break;
        case 4: colwhatx=colwhat4;
            break;
        case 5: colwhatx=colwhat5;
            break;
    }

    int topplus=(fv2->DefaultRowHeight-fv2->Font->Size)/2-topshift;
                if( colwhatx=="name") {
                    if( most->panel[ARow].Type=="Directory" )
                        fv2->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,dir_pref+most->panel[ARow].Name+dir_post);
                    else
                        fv2->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Name);
                } else if( colwhatx=="size") {
                    AnsiString newsize=HumanSize(most->panel[ARow].Size,most->panel[ARow].Type);
                    fv2->Canvas->TextRect(Rect,Rect.Right-10-fv2->Canvas->TextWidth(newsize),Rect.Top-topplus,newsize);
                } else if( colwhatx=="date") {
                    fv2->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Date);
                } else if( colwhatx=="rights") {
                    fv2->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Mask);
                } else if( colwhatx=="link") {
                    fv2->Canvas->TextRect(Rect,Rect.Left,Rect.Top-topplus,most->panel[ARow].Link);
                }
    if( most->panel[ARow].Focused ) {
        fv2->Row=ARow ;
        most->panel[ARow].Focused=false;
    }
    if( fv2->Row==ARow )
        sb2->Position=fv2->TopRow;
}
//---------------------------------------------------------------------------

void TForm1::ChPanel(int panel)
{
    if( panel==-1 ) {
        if( act->active==fv1 ) {
            act=&panels[1];
            nact=&panels[0];
        } else {
            act=&panels[0];
            nact=&panels[1];
        }
    } else if( panel==1 ) {
            act=&panels[0];
            nact=&panels[1];
    } else if( panel==2 ) {
            act=&panels[1];
            nact=&panels[0];
    }
    act->dirloc->Color=col_panel_hl_bg;
    act->dirloc->Font->Color=col_panel_hl_font;
    act->dirloc->Height=fv1->DefaultRowHeight;
    nact->dirloc->Color=col_bg;
    nact->dirloc->Font->Color=col_font;
    nact->dirloc->Height=fv1->DefaultRowHeight;
    SetShowPath(String(act->dirloc->Text));
}


void __fastcall TForm1::fv1Click(TObject *Sender)
{
    if( act->num!=0 ) {
        ChPanel(1);
        fv1->Invalidate();
        fv2->Invalidate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2Click(TObject *Sender)
{
    if( act->num!=1 ) {
        ChPanel(2);
        fv1->Invalidate();
        fv2->Invalidate();
    }
}
//---------------------------------------------------------------------------

void TForm1::RereadConfig()
{
    char cline[200];
    FILE *filein;
    AnsiString ret;
try {
    filein = fopen((home+".vc/vc.cfg").c_str(), "rt");
    if( !filein ) {
        filein = fopen((programpath+"vc.cfg").c_str(), "rt");
        if( filein ) {
            MkDir((home+".vc").c_str());
            FILE *dst=fopen((home+".vc/vc.cfg").c_str(),"w");
            if( dst ) {
                char *buffer=new char[copybytes];
                int readed=0;
                while( !feof(filein) && readed>=0 ) {
                    readed=fread(buffer,sizeof(char),copybytes,filein);
                    if( readed>0 ) readed=fwrite(buffer,sizeof(char),readed,dst);
                }
                fclose(dst);
                delete []buffer;
                fclose(filein);
                filein = fopen((home+".vc/vc.cfg").c_str(), "rt");
            }
        }
    }
    if( !filein ) {
        ShowMessage("Can not read the config file!");
        readedconfig=false;
        Resize();
        readedconfig=true;
        Resize_my();
        return;
    }
    readstr(filein,cline);
    AnsiString line=Trim(AnsiString(cline));
    while( !feof(filein) ) {
        if( line=="[version]" )
            line=RereadConfig_ver(filein);
        else if( line=="[general]" )
            line=RereadConfig_gen(filein);
        else if( line=="[color]" )
            line=RereadConfig_col(filein);
        else if( line=="[create_package]" )
            line=RereadConfig_create_pac(filein);
        else if( line=="[package]" )
            line=RereadConfig_pac(filein);
        else if( line=="[extensions]" )
            line=RereadConfig_ext(filein);
        if( line=="" ) {readstr(filein,cline);line=Trim(AnsiString(cline));}
    }
    fclose(filein);
    ReadShortCuts();
    Refresh_col();
    RereadBookmark();
    RefreshBookmark();
    RereadTabs();
}
catch(...) {
    if( filein ) fclose(filein);
    ShowMessage("!!! Error while reading the config file !!!");
}
    readedconfig=false;
    Resize();
    readedconfig=true;
    Resize_my();
}

AnsiString TForm1::RereadConfig_ver(FILE *filein)
{
    char cline[100];
    while( !feof(filein) ) {
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        if( line.Pos("=")>0 ) {
            AnsiString mnemo;
            AnsiString param;
            AnsiSplit(line,"=",mnemo,param);
            if( mnemo.AnsiCompare("version")==0 )
                configfile_version=param;
       } else return line;
    }
    return "";
}

AnsiString TForm1::RereadConfig_gen(FILE *filein)
{
    char cline[100];
    while( !feof(filein) ) {
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        if( line.Pos("=")>0 ) {
            AnsiString mnemo;
            AnsiString param;
            AnsiSplit(line,"=",mnemo,param);
            if( mnemo.AnsiCompare("execpath")==0 )
                execpath=param;
            else if( mnemo.AnsiCompare("colwidth1")==0 ) {
                HeaderControl1->Sections->Items[0]->Width=StrToInt(param)+18;
                HeaderControl2->Sections->Items[0]->Width=StrToInt(param)+18;
                fv1->ColWidths[1]=StrToInt(param);
                fv2->ColWidths[1]=StrToInt(param);
            } else if( mnemo.AnsiCompare("colwidth2")==0 ) {
                HeaderControl1->Sections->Items[1]->Width=StrToInt(param);
                HeaderControl2->Sections->Items[1]->Width=StrToInt(param);
                fv1->ColWidths[2]=StrToInt(param);
                fv2->ColWidths[2]=StrToInt(param);
            } else if( mnemo.AnsiCompare("colwidth3")==0 ) {
                HeaderControl1->Sections->Items[2]->Width=StrToInt(param);
                HeaderControl2->Sections->Items[2]->Width=StrToInt(param);
                fv1->ColWidths[3]=StrToInt(param);
                fv2->ColWidths[3]=StrToInt(param);
            } else if( mnemo.AnsiCompare("colwidth4")==0 ) {
                HeaderControl1->Sections->Items[3]->Width=StrToInt(param);
                HeaderControl2->Sections->Items[3]->Width=StrToInt(param);
                fv1->ColWidths[4]=StrToInt(param);
                fv2->ColWidths[4]=StrToInt(param);
            } else if( mnemo.AnsiCompare("colwidth5")==0 ) {
                HeaderControl1->Sections->Items[4]->Width=StrToInt(param);
                HeaderControl2->Sections->Items[4]->Width=StrToInt(param);
                fv1->ColWidths[5]=StrToInt(param);
                fv2->ColWidths[5]=StrToInt(param);
            } else if( mnemo.AnsiCompare("colwhat1")==0 ) {
                HeaderControl1->Sections->Items[0]->Text=param;
                HeaderControl2->Sections->Items[0]->Text=param;
                colwhat1=param;
            } else if( mnemo.AnsiCompare("colwhat2")==0 ) {
                HeaderControl1->Sections->Items[1]->Text=param;
                HeaderControl2->Sections->Items[1]->Text=param;
                colwhat2=param;
            } else if( mnemo.AnsiCompare("colwhat3")==0 ) {
                HeaderControl1->Sections->Items[2]->Text=param;
                HeaderControl2->Sections->Items[2]->Text=param;
                colwhat3=param;
            } else if( mnemo.AnsiCompare("colwhat4")==0 ) {
                HeaderControl1->Sections->Items[3]->Text=param;
                HeaderControl2->Sections->Items[3]->Text=param;
                colwhat4=param;
            } else if( mnemo.AnsiCompare("colwhat5")==0 ) {
                HeaderControl1->Sections->Items[4]->Text=param;
                HeaderControl2->Sections->Items[4]->Text=param;
                colwhat5=param;
            } else if( mnemo.AnsiCompare("packageprefix")==0 ) {
                packageprefix=programpath+param;
            } else if( mnemo.AnsiCompare("tmppath")==0 ) {
                tmppath=param;
            } else if( mnemo.AnsiCompare("extviewer")==0 ) {
                extviewer=param;
            } else if( mnemo.AnsiCompare("exteditor")==0 ) {
                exteditor=param;
            } else if( mnemo.AnsiCompare("execcompare")==0 ) {
                execcompare=param;
            } else if( mnemo.AnsiCompare("dateformat")==0 ) {
                dateformat=param;
            } else if( mnemo.AnsiCompare("showhiddenfiles")==0 ) {
                if( param=="on" || param=="true" ) {
// <TODO>
                } else {
// <TODO>
                }
            } else if( mnemo.AnsiCompare("autocomplete")==0 ) {
                if( param=="on" || param=="true" ) {
                    cl->AutoComplete=true;
                } else {
                    cl->AutoComplete=false;
                }
            } else if( mnemo.AnsiCompare("")==0 ) {
                if( param=="on" || param=="true" ) {
                    ignorecase=true;
                } else {
                    ignorecase=false;
                }
            } else if( mnemo.AnsiCompare("humanread")==0 ) {
                if( param=="on" || param=="true" ) {
                    humanread=true;
                } else {
                    humanread=false;
                }
            } else if( mnemo.AnsiCompare("extls")==0 ) {
                if( param=="on" || param=="true" ) {
                    extls=true;
                } else {
                    extls=false;
                }
            } else if( mnemo.AnsiCompare("maxtreads")==0 ) {
                int newthreads=StrToInt(param);
                if( maxthreads!=newthreads ) {
                    maxthreads=newthreads;
                    if( copy_thread ) delete []copy_thread;
                    if( viewforms ) delete []viewforms;
                    copy_thread=new CMyThread*[maxthreads];
                    viewforms=new TViewForm*[maxthreads];
                    for( int i=0;i<maxthreads;i++ ) {
                        viewforms[i]=NULL;
                        copy_thread[i]=new CMyThread(true);
                    }
                }
            } else if( mnemo.AnsiCompare("copybytes")==0 ) {
                copybytes=StrToInt(param);
            } else if( mnemo.AnsiCompare("fontheight")==0 ) {
// ---IDEFONT---
                int height=StrToInt(param);
                Form1->Font->Height=height;
                dirloc1->Font->Height=height;
                dirloc2->Font->Height=height;
                selbar1->Font->Height=height;
                selbar2->Font->Height=height;
                free1->Font->Height=height;
                free2->Font->Height=height;
                cl->Font->Height=height;
                StatusBar1->Font->Height=height;
                fv1->Font->Height=height;
                fv2->Font->Height=height;
                ShowPath->Font->Height=height;
            } else if( mnemo.AnsiCompare("rowheight")==0 ) {
                fv1->DefaultRowHeight=StrToInt(param);
                fv2->DefaultRowHeight=StrToInt(param);
            } else if( mnemo.AnsiCompare("fontweight")==0 ) {
// ---IDEFONT---
                int weight=StrToInt(param);
                fv1->Font->Weight=weight;
                fv2->Font->Weight=weight;
                dirloc1->Font->Weight=weight;
                dirloc2->Font->Weight=weight;
                selbar1->Font->Weight=weight;
                selbar2->Font->Weight=weight;
                free1->Font->Weight=weight;
                free2->Font->Weight=weight;
                ShowPath->Font->Weight=weight;
            } else if( mnemo.AnsiCompare("viewerfontheight")==0 ) {
                viewerfontheight=StrToInt(param);
            } else if( mnemo.AnsiCompare("viewerheight")==0 ) {
                viewerheight=StrToInt(param);
                if( viewerheight<100 ) viewerheight=100;
            } else if( mnemo.AnsiCompare("viewerwidth")==0 ) {
                viewerwidth=StrToInt(param);
                if( viewerwidth<100 ) viewerwidth=100;
            } else if( mnemo.AnsiCompare("dist")==0 ) {
                osztas=StrToInt(param);
            } else if( mnemo.AnsiCompare("topshift")==0 ) {
                topshift=StrToInt(param);
            } else if( mnemo.AnsiCompare("iconset")==0 ) {
                iconset=StrToInt(param);
            } else if( mnemo.AnsiCompare("dirstr")==0 ) {
                dirstr=param;
            } else if( mnemo.AnsiCompare("directory_mode")==0 ) {
                int pos=param.Pos("%DIR%");
                if( pos>=1 ) {
                    if( pos>=2 )
                        dir_pref=param.SubString(1,pos-1);
                    else
                        dir_pref="";
                    if( pos+5<=param.Length() )
                        dir_post=param.SubString(pos+5,param.Length()-(pos+5)+1);
                    else
                        dir_post="";
                } else {
                    dir_pref="";
                    dir_post="";
                }
            }

       } else return line;
    }
    return "";
}

AnsiString TForm1::RereadConfig_pac(FILE *filein)
{
    char cline[100];
    while( !feof(filein) ) {
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        if( line.Pos("=")>0 ) {
            AnsiString mnemo;
            AnsiString param;
            AnsiSplit(line,"=",mnemo,param);
            if( mnemo.Pos("_")>0 ) {
                AnsiString mnemo1;
                AnsiString mnemo2;
                AnsiSplit(mnemo,"_",mnemo1,mnemo2);
                int ennyi=GetPacInd(mnemo1);
                if( ennyi==-1 ) {
                    pacs.AddLast(CPac());
                    pacs[pacs.Length()-1].Name=mnemo1;
                    pacs[pacs.Length()-1].num=pacs.Length()-1;
                    pacs[pacs.Length()-1].copyin=false;
                    pacs[pacs.Length()-1].copyout=false;
                    pacs[pacs.Length()-1].rm=false;
                    pacs[pacs.Length()-1].dir=false;
                    pacs[pacs.Length()-1].run=false;
                    ennyi=pacs.Length()-1;
                }
                if( mnemo2=="ext" )
                    pacs[ennyi].Ext=param;
                else if( mnemo2=="handle" )
                    pacs[ennyi].Handle=param;
                else if( mnemo2=="copyin" ) {

                    if( param=="on" || param=="true" )
                        pacs[ennyi].copyin=true;
                    else
                        pacs[ennyi].copyin=false;
                } else if( mnemo2=="copyout" ) {
                    if( param=="on" || param=="true" )
                        pacs[ennyi].copyout=true;
                    else
                        pacs[ennyi].copyout=false;
                } else if( mnemo2=="rm" ) {
                    if( param=="on" || param=="true" )
                        pacs[ennyi].rm=true;
                    else
                        pacs[ennyi].rm=false;
                } else if( mnemo2=="dir" ) {
                    if( param=="on" || param=="true" )
                        pacs[ennyi].dir=true;
                    else
                        pacs[ennyi].dir=false;
                } else if( mnemo2=="run" ) {
                    if( param=="on" || param=="true" )
                        pacs[ennyi].run=true;
                    else
                        pacs[ennyi].run=false;
                }
            }

        } else return line;
    }
    return "";
}

AnsiString TForm1::RereadConfig_create_pac(FILE *filein)
{
    char cline[100];
    while( !feof(filein) ) {
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        if( line.Pos("=")>0 ) {
            AnsiString mnemo;
            AnsiString param;
            AnsiSplit(line,"=",mnemo,param);
            if( mnemo.Pos("_")>0 ) {
                AnsiString mnemo1;
                AnsiString mnemo2;
                AnsiSplit(mnemo,"_",mnemo1,mnemo2);
                int ennyi=GetCrPacInd(mnemo1);
                if( ennyi==-1 ) {
                    cr_pacs.AddLast(CPac2());
                    cr_pacs[cr_pacs.Length()-1].Name=mnemo1;
                    cr_pacs[cr_pacs.Length()-1].num=cr_pacs.Length()-1;
                    ennyi=cr_pacs.Length()-1;
                }
                if( mnemo2=="ext" )
                    cr_pacs[ennyi].Ext=param;
                else if( mnemo2=="handle" )
                    cr_pacs[ennyi].Handle=param;
                else if( mnemo2=="handleextr" )

                    cr_pacs[ennyi].HandleExtr=param;
            }

        } else return line;
    }
    return "";
}

AnsiString TForm1::RereadConfig_col(FILE *filein)
{
    char cline[100];
    while( !feof(filein) ) {
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        if( line.Pos("=")>0 ) {
            AnsiString mnemo;
            AnsiString param;
            AnsiSplit(line,"=",mnemo,param);
            if( mnemo.AnsiCompare("col_panel_bg")==0 ) {
                col_panel_bg=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_panel_font")==0 ) {
                col_panel_font=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_panel_exec")==0 ) {
                col_panel_exec=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_panel_hl_bg")==0 ) {
                col_panel_hl_bg=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_panel_hl_font")==0 ) {
                col_panel_hl_font=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_panel_hl_exec")==0 ) {
                col_panel_hl_exec=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_panel_sel")==0 ) {
                col_panel_sel=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_cl_bg")==0 ) {
                col_cl_bg=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_cl_font")==0 ) {
                col_cl_font=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_button_bg")==0 ) {
                col_button_bg=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_button_font")==0 ) {
                col_button_font=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_bg")==0 ) {
                col_bg=StringToColor(param);
            } else
            if( mnemo.AnsiCompare("col_font")==0 ) {
                col_font=StringToColor(param);
            }
        } else return line;
    }
    return "";
}

AnsiString TForm1::RereadConfig_ext(FILE *filein)
{
    char cline[100];
    while( !feof(filein) ) {
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        if( line.Pos("=")>0 ) {
            AnsiString mnemo;
            AnsiString param;
            AnsiSplit(line,"=",mnemo,param);
            if( mnemo.Pos("_")>0 ) {
                AnsiString mnemo1;
                AnsiString mnemo2;
                AnsiSplit(mnemo,"_",mnemo1,mnemo2);
                int ennyi=GetExtInd(mnemo1);
                if( ennyi==-1 ) {
                    exts.AddLast(CExt());
                    exts[exts.Length()-1].Name=mnemo1;
                    exts[exts.Length()-1].num=exts.Length()-1;
                    ennyi=exts.Length()-1;
                }
                if( mnemo2=="ext" )
                    exts[ennyi].Ext=param;
                else if( mnemo2=="handle" )
                    exts[ennyi].Handle=param;
            }

        } else return line;
    }
    return "";
}

int TForm1::GetPacInd(AnsiString name)
{
    for( int i=0;i<pacs.Length();i++ )
        if( pacs[i].Name==name ) return i;
    return -1;
}

int TForm1::GetCrPacInd(AnsiString name)
{
    for( int i=0;i<cr_pacs.Length();i++ )
        if( cr_pacs[i].Name==name ) return i;
    return -1;
}

int TForm1::GetCrPacIndByExt(AnsiString ext)
{
    for( int i=0;i<cr_pacs.Length();i++ )
        if( cr_pacs[i].Ext==ext ) return i;
    return -1;
}

int TForm1::GetPacIndByExt(AnsiString ext)
{
    for( int i=0;i<pacs.Length();i++ )
        if( pacs[i].Ext==ext ) return i;
    return -1;
}

int TForm1::GetExtInd(AnsiString name)
{
    for( int i=0;i<exts.Length();i++ )
        if( exts[i].Name==name ) return i;
    return -1;
}

int TForm1::GetExtIndByExt(AnsiString ext)
{
    for( int i=0;i<exts.Length();i++ )
        if( exts[i].Ext==ext ) return i;
    return -1;
}


int TForm1::ExecCmd(AnsiString name, bool ep, bool pwait)
{
try {
    int valami=fork();
    int valami2;
    int status;
    if( valami==-1 )
        ShowMessage("Fork was not succeed!");
    else
    if( valami==0 ) {
        if( act->mode==NORMAL ) ChDir(String(act->dirloc->Text));
        if( !ep )
            system((name).c_str());
        else
            system((execpath+" "+name).c_str());
        _exit(0);
    } else {
        if( pwait )
            waitpid(valami,&status,0);
        else {
            sprcss[prcss_n]=valami;
            prcss_n++;
            waitpid(valami,&status,WNOHANG);
        }
    }

    StatusBar1->SimpleText="Execute: "+name+", Child pid: "+IntToStr(valami)+", wait pid: "+IntToStr(valami2);
}
catch(...) {
    ShowMessage("!!! Error while executing "+name+" !!!");
}
}

void __fastcall TForm1::dirloc1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::dirloc2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::selbar1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::selbar2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::dirloc1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::dirloc2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::selbar1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::selbar2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rereadconfigfile1Click(TObject *Sender)
{
    RereadConfig();
    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EditSymlink1Click(TObject *Sender)
{
    act->EditSymlink_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::F3View1Click(TObject *Sender)
{
    act->View_my();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::F4Edit1Click(TObject *Sender)
{
// chech one of the panels are not NORMAL
    if( act->mode!=NORMAL && act->mode!=SEARCH) {
        ShowMessage("It has not implemented, yet!");
        return;
    }
    if( act->panel[act->active->Row].Type=="Directory" || act->panel[act->active->Row].Name==".." )
        return;
    if( exteditor=="") {
        ShowMessage("No editor has been set! Use the extedit parameter in vc.cfg!");
        return;
    }
    if( act->mode==SEARCH )
        ExecCmd(exteditor+" \""+AnsiString(act->panel[act->active->Row].Name)+"\"");
    else
        ExecCmd(exteditor+" \""+AnsiString(act->dirloc->Text)+AnsiString(act->panel[act->active->Row].Name)+"\"");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Chmod1Click(TObject *Sender)
{
    act->Chmod_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Chown1Click(TObject *Sender)
{
    act->Chown_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv1DblClick(TObject *Sender)
{
    act->Enter_my();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2DblClick(TObject *Sender)
{
    act->Enter_my();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
    Resize_my();
}
//---------------------------------------------------------------------------

bool TForm1::FitOnMask(AnsiString string, AnsiString mask)
{
    int lastst=0;
    int lastst2=0;
    int sn=1;
    int mn=1;

    while( sn<=string.Length() && mn<=mask.Length() ) {
        if( mask[mn]=='*' ) {
            lastst=mn;
            lastst2=sn;
            if( mn<mask.Length() ) {
                mn++;
                continue;
            } else
                return true;

        }

        if( ignorecase ) {
            if( string[sn]>='A' && string[sn]<='Z' ) string[sn]+=32;
            if( mask[mn]>='A' && mask[mn]<='Z' ) mask[mn]+=32;
        }
        if( string[sn]==mask[mn] || mask[mn]=='?' ) {
            mn++;
            if( mn>mask.Length() )
                if( sn==string.Length() )
                    return true;
                else
                    if( lastst==0 )
                        return false;
                    else {
                        mn=lastst;
                        sn=lastst2++;
                    }
        } else {
            if( lastst==0 )
                return false;
            else {
                mn=lastst;
                sn=lastst2++;
            }
        }
        sn++;
    }
    while( mn<=mask.Length() && mask[mn]=='*' ) mn++;

    return sn==string.Length()+1 && mn==mask.Length()+1;
}
//---------------------------------------------------------------------------

AnsiString TForm1::GetStringByMask(AnsiString string, AnsiString mask)
{
    AnsiString ret="";
    for( int i=1;i<=mask.Length();i++ ) {
        if( mask[i]=='*' )
            ret=ret+string;
        else
            ret=ret+mask[i];
    }
    return ret;
}

void __fastcall TForm1::FormActivate(TObject *Sender)
{
// there is no refresh temporary 
    if( false && nowrefresh ) {
        if( nact->mode==NORMAL ) {
            nact->prevdir="";
            nact->RefreshPanel();
        }
        if( act->mode==NORMAL ) {
            act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
            act->RefreshPanel();
        }
    }
    fv1->Enabled=true;
    fv2->Enabled=true;
    act->active->Enabled=true;
    nact->active->Enabled=true;
    pfind="";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Findfile1Click(TObject *Sender)
{
    act->FindFile_my();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TargetdirSourcedir1Click(TObject *Sender)
{
    if( act->mode!=NORMAL ) return;
    if( nact->mode!=NORMAL ) return;
    nact->dirloc->Text=act->dirloc->Text;
    nact->prevdir="";
    nact->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Selectinvert1Click(TObject *Sender)
{
    act->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Selectinvertbymask1Click(TObject *Sender)
{
    act->SelectMask();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Selectionnone1Click(TObject *Sender)
{
    act->SelectNone();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Freechildprocesses1Click(TObject *Sender)
{
    chk_pcss();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Comparebycontent1Click(TObject *Sender)
{
// chech one of the panels are not NORMAL
    if( act->mode!=NORMAL && act->mode!=SEARCH) {
        ShowMessage("It has not been implemented, yet!");
        return;
    }
    if( nact->mode!=NORMAL && nact->mode!=SEARCH) {
        ShowMessage("It has not been implemented, yet!");
        return;
    }
    if( act->panel[act->active->Row].Type=="Directory" || nact->panel[nact->active->Row].Type=="Directory" ) {
        ShowMessage("You can only compare two files!");
        return;
    }
    if( execcompare=="") {
        ShowMessage("No compare program has been set! Use the execcompare parameter in vc.cfg!");
        return;
    }

    AnsiString cmp1=AnsiString(act->dirloc->Text)+AnsiString(act->panel[act->active->Row].Name);
    AnsiString cmp2=AnsiString(nact->dirloc->Text)+AnsiString(nact->panel[nact->active->Row].Name);
    if( act->mode==SEARCH )
        AnsiString(act->panel[act->active->Row].Name);
    if( nact->mode==SEARCH )
        AnsiString(nact->panel[nact->active->Row].Name);
    ExecCmd(execcompare+" \""+cmp1+"\" \""+cmp2+"\"");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Sortbyname1Click(TObject *Sender)
{
    act->sortmode=0;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Sortbysize1Click(TObject *Sender)
{
    act->sortmode=1;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Sortbydate1Click(TObject *Sender)
{
    act->sortmode=2;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Invertsortdirection1Click(TObject *Sender)
{
    act->sortdir=1;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Sortdirection1Click(TObject *Sender)
{
    act->sortdir=0;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::sb2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb1Scroll(TObject *Sender, TScrollCode ScrollCode,
      int &ScrollPos)
{
    fv1->TopRow=ScrollPos;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sb2Scroll(TObject *Sender, TScrollCode ScrollCode,
      int &ScrollPos)
{
    fv2->TopRow=ScrollPos;    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CreateFile1Click(TObject *Sender)
{
    act->Create_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rename1Click(TObject *Sender)
{
    if( act->mode!=NORMAL )
        return;
    act->Rename_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Rereaddirectory1Click(TObject *Sender)
{
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    if( act->mode==ARCH )
        Form1->pacs[act->def_pac].listed=false;
    act->RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ShowAllDirectorySize1Click(TObject *Sender)
{
    act->ShowAllDirectorySize();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Help2Click(TObject *Sender)
{
    int i=0;
    for( i=0;i<Form1->maxthreads && Form1->viewforms[i] && !Form1->viewforms[i]->free;i++ ) {}
    if( i==Form1->maxthreads ) return;
    if( Form1->viewforms[i]!=NULL ) Form1->viewforms[i]=NULL;
    Form1->viewforms[i]=&TViewForm(Form1->Owner);
    viewforms[i]->filename=programpath+"vchelp.txt";
    viewforms[i]->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewFtpConnection1Click(TObject *Sender)
{
    if( nact->mode==FTP )
        return;
    act->NewFtpConnection();
}

int TForm1::AnsiCounter(AnsiString string, char ch)
{
    int ret=0;
    for( int i=1;i<=string.Length();i++ )
        if( string[i]==ch ) ret++;
    return ret;
}

void TForm1::Resize_my()
{
// ---IDEFONT---
    if( !readedconfig ) return;

    fv1->DefaultRowHeight=fv1->Font->Height+5;
    fv2->DefaultRowHeight=fv2->Font->Height+5;
    StatusBar1->Height=StatusBar1->Font->Height+5;
    sb1->Width=15;
    sb2->Width=15;

// separator
    separator->Width=osztas+1;

    Panel11->Top=0;
    Panel21->Top=0;
// 1
    tabs1->Top=0;
    tabs1->Left=osztas;
    tabs1->Height=fv1->DefaultRowHeight+8;
    if( tabs1->Visible==true )
        dirloc1->Top=tabs1->Height;
    else
        dirloc1->Top=0;
    dirloc1->Left=osztas;
    dirloc1->Height=fv1->DefaultRowHeight;
    selbar1->Height=fv1->DefaultRowHeight;
    free1->Height=fv1->DefaultRowHeight;
    HeaderControl1->Height=fv1->DefaultRowHeight;


    root1->Height=fv1->DefaultRowHeight;
    root1->Width=root1->Height;
    up1->Height=fv1->DefaultRowHeight;
    up1->Width=up1->Height;
    home1->Height=fv1->DefaultRowHeight;
    home1->Width=home1->Height;

    Panel11->Width=int(float(Form1->Width-(osztas*2))*prate);

    tabs1->Width=Panel11->Width;

    dirloc1->Width=Panel11->Width-(root1->Width+up1->Width+home1->Width+osztas*4);

    home1->Top=dirloc1->Top;
    home1->Left=dirloc1->Left+dirloc1->Width+osztas;
    root1->Top=dirloc1->Top;
    root1->Left=home1->Left+home1->Width+osztas;
    up1->Top=dirloc1->Top;
    up1->Left=root1->Left+root1->Width+osztas;

    Panel1->Top=dirloc1->Top+dirloc1->Height+osztas;
    Panel1->Left=dirloc1->Left;
    if( tabs1->Visible==true )
        Panel1->Height=Form1->ClientHeight-(StatusBar1->Height+cl->Height+2+dirloc1->Height+tabs1->Height+selbar1->Height+free1->Height+(4*osztas));
    else
        Panel1->Height=Form1->ClientHeight-(StatusBar1->Height+cl->Height+2+dirloc1->Height+selbar1->Height+free1->Height+(4*osztas));
    Panel1->Width=Panel11->Width-(sb1->Width+osztas);

    fv1->Top=HeaderControl1->Height-1;
    fv1->Left=0;
    fv1->Height=Panel1->Height-HeaderControl1->Height;
    fv1->Width=Panel1->Width;

    sb1->Top=Panel1->Top;
    sb1->Left=Panel1->Left+Panel1->Width;
    sb1->Height=Panel1->Height;
    if( fv1->DefaultRowHeight!=0 )
        sb1->LargeChange=fv1->Height/fv1->DefaultRowHeight;
    if( fv1->RowCount-sb1->LargeChange>0 )
        sb1->Max=fv1->RowCount-sb1->LargeChange;
    else
        sb1->Max=0;

    selbar1->Top=Panel1->Top+Panel1->Height+osztas;
    selbar1->Left=dirloc1->Left;
    selbar1->Width=Panel1->Width;

    free1->Top=selbar1->Top+selbar1->Height+osztas;
    free1->Left=dirloc1->Left;
    free1->Width=Panel1->Width;

// 2
    home2->Height=home1->Height;
    home2->Width=home2->Height;
    root2->Height=root1->Height;
    root2->Width=root2->Height;
    up2->Height=up1->Height;
    up2->Width=up2->Height;

    Panel21->Width=int(float(Form1->Width-(osztas*2))*(1-prate));

    tabs2->Width=Panel21->Width;
    tabs2->Top=0;
    tabs2->Left=0;
    tabs2->Height=fv2->DefaultRowHeight+8;
    if( tabs2->Visible==true )
        dirloc2->Top=tabs2->Height;
    else
        dirloc2->Top=0;
    dirloc2->Left=0;
    dirloc2->Width=Panel21->Width-(root2->Width+up2->Width+home2->Width+osztas*4);
    dirloc2->Height=fv2->DefaultRowHeight;
    selbar2->Height=fv2->DefaultRowHeight;
    free2->Height=fv2->DefaultRowHeight;
    HeaderControl2->Height=fv2->DefaultRowHeight;

    home2->Top=dirloc2->Top;
    home2->Left=dirloc2->Left+dirloc2->Width+osztas;
    root2->Top=dirloc2->Top;
    root2->Left=home2->Left+home2->Width+osztas;
    up2->Top=dirloc2->Top;
    up2->Left=root2->Left+root2->Width+osztas;

    Panel2->Top=dirloc2->Top+dirloc2->Height+osztas;
    Panel2->Left=dirloc2->Left;
    if( tabs2->Visible==true )
        Panel2->Height=Form1->ClientHeight-(StatusBar1->Height+cl->Height+2+dirloc2->Height+tabs2->Height+selbar2->Height+free2->Height+(4*osztas));
    else
        Panel2->Height=Form1->ClientHeight-(StatusBar1->Height+cl->Height+2+dirloc2->Height+selbar2->Height+free2->Height+(4*osztas));
    Panel2->Width=Panel21->Width-(sb2->Width+osztas);

    fv2->Top=HeaderControl2->Height-1;
    fv2->Left=0;
    fv2->Height=Panel2->Height-HeaderControl2->Height;
    fv2->Width=Panel2->Width;

    sb2->Top=Panel2->Top;
    sb2->Left=Panel2->Left+Panel2->Width;
    sb2->Height=Panel2->Height;
    if( fv2->DefaultRowHeight!=0 )
        sb2->LargeChange=fv2->Height/fv2->DefaultRowHeight;
    if( fv2->RowCount-sb2->LargeChange>0 )
        sb2->Max=fv2->RowCount-sb2->LargeChange;
    else
        sb2->Max=0;

    selbar2->Top=Panel2->Top+Panel2->Height+osztas;
    selbar2->Left=dirloc2->Left;
    selbar2->Width=Panel2->Width;

    free2->Top=selbar2->Top+selbar2->Height+osztas;
    free2->Left=dirloc2->Left;
    free2->Width=Panel2->Width;

    Panel11->Height=free1->Top+free1->Height+osztas;
    Panel21->Height=free2->Top+free2->Height+osztas;
// cl
    Panel3->Height=cl->Height;
    cl->Top=0;
    ShowPath->Top=cl->Top+4;
    startwithxterm->Height=fv1->DefaultRowHeight;
    startwithxterm->Width=startwithxterm->Height;
    startwithxterm->Top=cl->Top+4;
    startwithxterm->Left=Form1->Width-osztas-startwithxterm->Width;

    SetShowPath();

    Invalidate();
    StatusBar1->SimpleText="X, Y: "+IntToStr(Width)+", "+IntToStr(Height);
}

void __fastcall TForm1::HeaderControl1SectionResize(
      TCustomHeaderControl *HeaderControl, TCustomHeaderSection *Section)
{
    fv1->ColWidths[1]=HeaderControl1->Sections->Items[0]->Width-18;
    fv1->ColWidths[2]=HeaderControl1->Sections->Items[1]->Width;
    fv1->ColWidths[3]=HeaderControl1->Sections->Items[2]->Width;
    fv1->ColWidths[4]=HeaderControl1->Sections->Items[3]->Width;
    fv1->ColWidths[5]=HeaderControl1->Sections->Items[4]->Width;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HeaderControl2SectionResize(
      TCustomHeaderControl *HeaderControl, TCustomHeaderSection *Section)
{
    fv2->ColWidths[1]=HeaderControl2->Sections->Items[0]->Width-18;
    fv2->ColWidths[2]=HeaderControl2->Sections->Items[1]->Width;
    fv2->ColWidths[3]=HeaderControl2->Sections->Items[2]->Width;
    fv2->ColWidths[4]=HeaderControl2->Sections->Items[3]->Width;
    fv2->ColWidths[5]=HeaderControl2->Sections->Items[4]->Width;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HeaderControl1SectionClick(
      TCustomHeaderControl *HeaderControl, TCustomHeaderSection *Section)
{
    if( Section->DisplayName=="name" ) {
        if( panels[0].sortmode==0 ) {
            if( panels[0].sortdir==1 )
                panels[0].sortdir=0;
            else
                panels[0].sortdir=1;
        } else
        panels[0].sortmode=0;
    } else
    if( Section->DisplayName=="size" ) {
        if( panels[0].sortmode==1 ) {
            if( panels[0].sortdir==1 )
                panels[0].sortdir=0;
            else
                panels[0].sortdir=1;

        } else
        panels[0].sortmode=1;
    } else
    if( Section->DisplayName=="date" ) {
        if( panels[0].sortmode==2 ) {
            if( panels[0].sortdir==1 )
                panels[0].sortdir=0;
            else
                panels[0].sortdir=1;
        } else
        panels[0].sortmode=2;
    }

    panels[0].RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HeaderControl2SectionClick(
      TCustomHeaderControl *HeaderControl, TCustomHeaderSection *Section)
{
    if( Section->DisplayName=="name" ) {
        if( panels[1].sortmode==0 ) {
            if( panels[1].sortdir==1 )
                panels[1].sortdir=0;
            else
                panels[1].sortdir=1;
        } else
        panels[1].sortmode=0;
    } else
    if( Section->DisplayName=="size" ) {
        if( panels[1].sortmode==1 ) {
            if( panels[1].sortdir==1 )
                panels[1].sortdir=0;
            else
                panels[1].sortdir=1;
        } else
        panels[1].sortmode=1;
    } else
    if( Section->DisplayName=="date" ) {
        if( panels[1].sortmode==3 ) {
            if( panels[1].sortdir==1 )
                panels[1].sortdir=0;
            else
                panels[1].sortdir=1;
        } else
        panels[1].sortmode=2;
    }

    panels[1].RefreshPanel();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IncrieseFontSize1Click(TObject *Sender)
{
// ---IDEFONT---
    Form1->Font->Height++;

    dirloc1->Font->Height++;
    dirloc2->Font->Height++;
    selbar1->Font->Height++;
    selbar2->Font->Height++;
    free1->Font->Height++;
    free2->Font->Height++;

    ShowPath->Font->Height++;
    cl->Font->Height++;

    StatusBar1->Font->Height++;

    fv1->Font->Height++;
    fv2->Font->Height++;

    Resize_my();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::DecreaseFontSize1Click(TObject *Sender)
{
// ---IDEFONT---
    Form1->Font->Height--;

    dirloc1->Font->Height--;
    dirloc2->Font->Height--;
    selbar1->Font->Height--;
    selbar2->Font->Height--;
    free1->Font->Height--;
    free2->Font->Height--;

    ShowPath->Font->Height--;
    cl->Font->Height--;

    StatusBar1->Font->Height--;

    fv1->Font->Height--;
    fv2->Font->Height--;

    Resize_my();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::free1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::free1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::free2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::free2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if( CallKeyDown(Sender,Key,Shift)==1 ) Key = 0;
}
//---------------------------------------------------------------------------

void TForm1::readcommandline()
{
    char cline[100];
    FILE *filein;
    filein = fopen((home+".vc/history").c_str(), "rt");
    if( filein ) {
        cl->Clear();
        readstr(filein,cline);
        AnsiString line=Trim(AnsiString(cline));
        while( !feof(filein) ) {
            if( line!="" ) cl->Items->Add(line);
            readstr(filein,cline);line=Trim(AnsiString(cline));
        }
        fclose(filein);
    }

}

void TForm1::writecommandline()
{
    cl->Items->SaveToFile(home+".vc/history");
    ActionForm->doon->Items->SaveToFile(home+".vc/doon");
    ActionForm->doon2->Items->SaveToFile(home+".vc/doon2");
}

void TForm1::readpositions()
{
    char cline[100];
    FILE *filein;
    filein = fopen((home+".vc/positions").c_str(), "rt");
    if( !filein ) {
        Position=poDesktopCenter;
        return;
    }
    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    Form1->Top=StrToInt(Trim(AnsiString(cline)));
    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    Form1->Left=StrToInt(Trim(AnsiString(cline)));
    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    Form1->Width=StrToInt(Trim(AnsiString(cline)));
    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    Form1->Height=StrToInt(Trim(AnsiString(cline)));
    fclose(filein);
}

void TForm1::writepositions()
{
    FILE *filein;
    filein = fopen((home+".vc/positions").c_str(), "w");
    if( !filein ) {
        return;
    }
    AnsiString line=IntToStr(Top);
    fputs((line+"\n").c_str(),filein);
    line=IntToStr(Left);
    fputs((line+"\n").c_str(),filein);
    line=IntToStr(Width);
    fputs((line+"\n").c_str(),filein);
    line=IntToStr(Height);
    fputs((line+"\n").c_str(),filein);
    fclose(filein);
}

void __fastcall TForm1::SelectAll1Click(TObject *Sender)
{
    act->SelectNNone();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    pacs.DelList();
    exts.DelList();
    if( panels )
        delete []panels;
    if( copy_thread )
        delete []copy_thread;
}
//---------------------------------------------------------------------------
void TForm1::AnsiSplit(const AnsiString string,const AnsiString pattern,AnsiString &first,AnsiString &last)
{
    int pos=string.Pos(pattern);
    int slen=string.Length();
    int plen=pattern.Length();
    if( pos<=0 ) {
        first=string;
        last="";
        return;
    }
    if( pos>1 && pos<=slen && pos+plen>slen ) {
        try {
            first=string.SubString(1,pos-1);
            last="";
        } catch( ... ) {
            first=string;
            last="";
            return;
        }
        return;
    }

    if( pos+plen>slen ) {
        first=string;
        last="";
        return;
    }

    if( pos==1 ) {
        try {
            first="";
            last=string.SubString(1+plen,string.Length()-(plen-1));
        } catch( ... ) {
            first="";
            last=string;
            return;
        }
        return;
    }

    try {
        first=Trim(string.SubString(1,pos-1));
        last=Trim(string.SubString(pos+plen,slen-(pos+plen-1)));
    }
    catch( ... ) {
        first=string;
        last="";
        return;
    }
}

AnsiString TForm1::HumanSize(__int64 psize,AnsiString type)
{
    AnsiString postfix;
    AnsiString ret;
    AnsiString sep=".";
    float size=psize;

    if( size==0 && type=="Directory" ) return dirstr;

    if( humanread ) {

    if( size>1024 ) {
        size/=1024;
        postfix="K";
        if( size>1024 ) {
            size/=1024;
            postfix="M";
            if( size>1024 ) {
                size/=1024;
                postfix="G";
                if( size>1024 ) {
                    size/=1024;
                    postfix="T";
                    if( size>1024 ) {
                        size/=1024;
                        postfix="P";
                        if( size>1024 ) {
                            size/=1024;
                            postfix="E";
                            if( size>1024 ) {
                                size/=1024;
                                postfix="Z";
                                if( size>1024 ) {
                                    size/=1024;
                                    postfix="Y";
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    }
    ret=FloatToStr(size);
    if( ret.Pos(",") ) sep=",";
    if( ret.Pos(sep) && ret.Pos(sep)+1<ret.Length() ) ret=ret.SubString(1,ret.Pos(sep)+1);
    return ret+postfix;
}

void __fastcall TForm1::CloseFTPConnection1Click(TObject *Sender)
{
    if( act->mode==FTP ) {
        act->CloseFTPConnection();
    } else if( nact->mode==FTP ) {
        nact->CloseFTPConnection();
    }
}
//---------------------------------------------------------------------------

void TForm1::SetShowPath(AnsiString newpath)
{
    if( newpath!="") ShowPath->Caption=newpath;
// if it is too wide
    if( ShowPath->Width>((2*Form1->Width)/3) ) {
        ShowPath->Left=((2*Form1->Width)/3)-ShowPath->Width;
    } else {
        ShowPath->Left=dirloc1->Left;
    }
    int newwidth=Form1->Width-(ShowPath->Left+ShowPath->Width)-startwithxterm->Width-(osztas*3);
    if( newwidth>cl->Width) {
        cl->Left=ShowPath->Left+ShowPath->Width+osztas;
        cl->Width=newwidth;
    } else {
        cl->Width=newwidth;
        cl->Left=ShowPath->Left+ShowPath->Width+osztas;
    }
}

void __fastcall TForm1::root1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::up1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::root2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::up2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::root1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::up1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::root2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::up2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::root1Click(TObject *Sender)
{
    if( panels[0].mode==FTP ) {
        panels[0].archdir="/";
        panels[0].prevdir="ftp://"+panels[0].servername+panels[0].archdir;
        dirloc1->Text="ftp://"+panels[0].servername+panels[0].archdir;
        panels[0].RefreshPanel();
    } else
    if( panels[0].mode==NORMAL ) {
        panels[0].prevdir="";
        dirloc1->Text="/";
        panels[0].RefreshPanel();
    }
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::root2Click(TObject *Sender)
{
    if( panels[1].mode==FTP ) {
        panels[1].archdir="/";
        panels[1].prevdir="ftp://"+panels[1].servername+panels[1].archdir;
        dirloc2->Text="ftp://"+panels[1].servername+panels[1].archdir;
        panels[1].RefreshPanel();
    } else
    if( panels[1].mode==NORMAL ) {
        panels[1].prevdir="";
        dirloc2->Text="/";
        panels[1].RefreshPanel();
    }
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::up1Click(TObject *Sender)
{
    panels[0].cdpp();
    panels[0].RefreshPanel();
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::up2Click(TObject *Sender)
{
    panels[1].cdpp();
    panels[1].RefreshPanel();
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::home1Click(TObject *Sender)
{
    if( panels[0].mode!=NORMAL ) return;

    dirloc1->Text=GetEnvironmentVariable("HOME");
    panels[0].prevdir="";
    if( dirloc1->Text=="")
        dirloc1->Text="/";
    else
        dirloc1->Text=dirloc1->Text+"/";
    panels[0].RefreshPanel();
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::home2Click(TObject *Sender)
{
    if( panels[1].mode!=NORMAL ) return;

    dirloc2->Text=GetEnvironmentVariable("HOME");
    panels[1].prevdir="";
    if( dirloc2->Text=="")
        dirloc2->Text="/";
    else
        dirloc2->Text=dirloc2->Text+"/";
    panels[1].RefreshPanel();
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::home1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::home2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::home1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::home2KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::startwithxtermClick(TObject *Sender)
{
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::startwithxtermKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyDown(Sender,Key,Shift);
    Key = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::startwithxtermKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    CallKeyUp(Sender, Key, Shift);
}
//---------------------------------------------------------------------------
void TForm1::SetStatusBar()
{
    AnsiString newsize=IntToStr(act->panel[act->active->Row].Size);

    StatusBar1->SimpleText=
    act->panel[act->active->Row].Name+"   "+
    newsize+"   "+
    act->panel[act->active->Row].Date+"   "+
    act->panel[act->active->Row].Mask+"   "+
    act->panel[act->active->Row].Link;
}

void __fastcall TForm1::Configure1Click(TObject *Sender)
{
    configform=&TConfigForm(Owner);
    configform->Show();
//    ConfigForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MainMenu2Click(TObject *Sender)
{
    QMenuBar_activateItemAt((QMenuBarH *)(MainMenu1->Handle), 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ActivateBookmark1Click(TObject *Sender)
{
    QMenuBar_activateItemAt((QMenuBarH *)(MainMenu1->Handle), 4);
}
//---------------------------------------------------------------------------

void TForm1::ReadShortCuts()
{
    char cline[200];
    FILE *filein;
    AnsiString line;
    unsigned short shortcut;
try {
    filein = fopen((home+".vc/shortcuts").c_str(), "rt");
    if( !filein ) {
        return;
    }

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Sortbyname1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Sortbysize1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Sortbydate1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Invertsortdirection1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Sortdirection1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F3View1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F4Edit1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->CreateFile1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F5Copy1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F6Move1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Rename1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F7CreateDirectory1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F8Delete1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->MainMenu2->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->F10Exit1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Createsymlink1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Editsymlink1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Chmod1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Chown1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Findfile1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->TargetdirSourcedir1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Comparebycontent1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Rereaddirectory1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->ShowAllDirectorySize1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->ActivateBookmark1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Selectinvert1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Selectinvertbymask1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Selectionnone1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->SelectAll1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->NewFtpConnection1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->CloseFTPConnection1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Configure1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Rereadconfigfile1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Freechildprocesses1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->IncrieseFontSize1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->DecreaseFontSize1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->Help2->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->About1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->InternalView1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->MultiRenameTool1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    bmsc=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->NewTab->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->CloseTab->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->CreateArchiveFile1->ShortCut=shortcut;

    readstr(filein,cline);
    if( feof(filein) ) { fclose(filein); return;}
    shortcut=(unsigned short)StrToInt(Trim(AnsiString(cline)));
    Form1->UnpackArchiveFile1->ShortCut=shortcut;

    fclose(filein);
}
catch(...) {
    if( filein ) fclose(filein);
    ShowMessage("!!! Error while reading the shortcut file !!!");
}

}

void __fastcall TForm1::Createsymlink1Click(TObject *Sender)
{
    act->CreateSymlink_my(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    Exit_my();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::separatorMoved(TObject *Sender)
{
    prate=float(separator->Left)/float(Form1->Width);
    if( prate<0 ) prate=-prate;

    Resize_my();
}
//---------------------------------------------------------------------------

int TForm1::StrToChmod(AnsiString sperm, int ex_stat)
{
    int statfile=0;
    int start=1;
    if( sperm.Length()==12 ) {
        if( sperm[1]=='u' )
            statfile=statfile|S_ISUID;
        else
            if( sperm[1]=='?' )
                statfile=statfile|(ex_stat & S_ISUID);
        if( sperm[2]=='g' )
            statfile=statfile|S_ISGID;
        else
            if( sperm[2]=='?' )
                statfile=statfile|(ex_stat & S_ISGID);
        if( sperm[3]=='s' )
            statfile=statfile|S_ISVTX;
        else
            if( sperm[3]=='?' )
                statfile=statfile|(ex_stat & S_ISVTX);
        start=4;
    } else
    if( sperm.Length()==13 ) {
        if( sperm[2]=='u' )
            statfile=statfile|S_ISUID;
        else
            if( sperm[2]=='?' )
                statfile=statfile|(ex_stat & S_ISUID);
        if( sperm[3]=='g' )
            statfile=statfile|S_ISGID;
        else
            if( sperm[3]=='?' )
                statfile=statfile|(ex_stat & S_ISGID);
        if( sperm[4]=='s' )
            statfile=statfile|S_ISVTX;
        else
            if( sperm[4]=='?' )
                statfile=statfile|(ex_stat & S_ISVTX);
        start=5;
    } else
    if( sperm.Length()==10 ) {
        start=2;
    } else
    if( sperm.Length()==9 ) {
        start=1;
    } else {
        sperm="rwxr-xr-x";
        start=1;
    };

    if( sperm[start++]=='r' )
        statfile=statfile|S_IRUSR;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IRUSR);
    if( sperm[start++]=='w' )
        statfile=statfile|S_IWUSR;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IWUSR);
    if( sperm[start++]=='x' )
        statfile=statfile|S_IXUSR;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IXUSR);
    if( sperm[start++]=='r' )
        statfile=statfile|S_IRGRP;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IRGRP);
    if( sperm[start++]=='w' )
        statfile=statfile|S_IWGRP;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IWGRP);
    if( sperm[start++]=='x' )
        statfile=statfile|S_IXGRP;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IXGRP);
    if( sperm[start++]=='r' )
        statfile=statfile|S_IROTH;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IROTH);
    if( sperm[start++]=='w' )
        statfile=statfile|S_IWOTH;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IWOTH);
    if( sperm[start++]=='x' )
        statfile=statfile|S_IXOTH;
    else
        if( sperm[start-1]=='?' )
            statfile=statfile|(ex_stat & S_IXOTH);
    return statfile;
}

void TForm1::Refresh_col()
{
    fv1->Color=col_panel_bg;
    fv2->Color=col_panel_bg;
    cl->Color=col_cl_bg;
    cl->Font->Color=col_cl_font;

// general
    free1->Color=col_bg;
    free2->Color=col_bg;
    selbar1->Color=col_bg;
    selbar2->Color=col_bg;
    StatusBar1->Color=col_bg;
    ShowPath->Color=col_bg;
    Form1->Color=col_bg;
    Panel1->Color=col_bg;
    Panel2->Color=col_bg;
    Panel3->Color=col_bg;

    free1->Font->Color=col_font;
    free2->Font->Color=col_font;
    selbar1->Font->Color=col_font;
    selbar2->Font->Color=col_font;
    StatusBar1->Font->Color=col_font;
    ShowPath->Font->Color=col_font;
    Form1->Font->Color=col_font;

// button
    home1->Color=col_button_bg;
    home2->Color=col_button_bg;
    root1->Color=col_button_bg;
    root2->Color=col_button_bg;
    up1->Color=col_button_bg;
    up2->Color=col_button_bg;
    startwithxterm->Color=col_button_bg;
    sb1->Color=col_button_bg;
    sb2->Color=col_button_bg;

    home1->Font->Color=col_button_font;
    home2->Font->Color=col_button_font;
    root1->Font->Color=col_button_font;
    root2->Font->Color=col_button_font;
    up1->Font->Color=col_button_font;
    up2->Font->Color=col_button_font;
    startwithxterm->Font->Color=col_button_font;

    act->dirloc->Color=col_panel_hl_bg;
    act->dirloc->Font->Color=col_panel_hl_font;
    act->dirloc->Height=fv1->DefaultRowHeight;
    nact->dirloc->Color=col_bg;
    nact->dirloc->Font->Color=col_font;
    nact->dirloc->Height=fv1->DefaultRowHeight;

}

void __fastcall TForm1::InternalView1Click(TObject *Sender)
{
    act->InternalView();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N7Show(TObject *Sender)
{
    if( act->sortmode==0 ) Sortbyname1->Checked=true; else
    if( act->sortmode==1 ) Sortbysize1->Checked=true; else
    if( act->sortmode==2 ) Sortbydate1->Checked=true;

    if( act->sortdir==1 ) Invertsortdirection1->Checked=true; else
    if( act->sortdir==0 ) Sortdirection1->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv1MouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
    sb1->Position+=3;
    fv1->TopRow=sb1->Position;
    Handled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv1MouseWheelUp(TObject *Sender, TShiftState Shift,
      TPoint &MousePos, bool &Handled)
{
    sb1->Position-=3;
    fv1->TopRow=sb1->Position;
    Handled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2MouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
    sb2->Position+=3;
    fv2->TopRow=sb2->Position;
    Handled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2MouseWheelUp(TObject *Sender, TShiftState Shift,
      TPoint &MousePos, bool &Handled)
{
    sb2->Position-=3;
    fv2->TopRow=sb2->Position;
    Handled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv1MouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    if( act->num!=0 ) {
        ChPanel(1);
        fv1->Invalidate();
        fv2->Invalidate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::fv2MouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    if( act->num!=1 ) {
        ChPanel(2);
        fv1->Invalidate();
        fv2->Invalidate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HeaderControl1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HeaderControl2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if( !act->active->Focused() )
        act->active->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MultiRenameTool1Click(TObject *Sender)
{
    act->MultiRename(nact);
}
//---------------------------------------------------------------------------

void TForm1::chk_pcss()
{
    for( int i=0;i<prcss_n;i++ ) {
        int status=0;
        if( waitpid(sprcss[i],&status,WNOHANG)<=0 ) {
            for( int j=i;j+1<prcss_n;j++ )
                sprcss[j]=sprcss[j+1];
            prcss_n--;
            continue;
        }
        if( WIFEXITED(status) ) {
            if( waitpid(sprcss[i],&status,WNOHANG)>0 ) continue;
            for( int j=i;j+1<prcss_n;j++ )
                sprcss[j]=sprcss[j+1];
            prcss_n--;
        }
    }
}

int TForm1::MessageDlg_my(AnsiString message, AnsiString caption,
            AnsiString button1_caption, AnsiString button2_caption,
            AnsiString button3_caption, AnsiString button4_caption,
            AnsiString button5_caption, AnsiString button6_caption
        )
{
    int ret=1;
    TInfoForm *infoform=&TInfoForm(NULL);

    infoform->Caption=caption;
    infoform->Message1->Caption=message;

    infoform->Button1->Caption=button1_caption;
    infoform->Button2->Caption=button2_caption;

    infoform->Button3->Caption=button3_caption;
    infoform->Button4->Caption=button4_caption;
    infoform->Button5->Caption=button5_caption;
    infoform->Button6->Caption=button6_caption;

    if( button3_caption=="" ) {
        infoform->Button3->Visible=false;
        infoform->Button4->Visible=false;
        infoform->Button5->Visible=false;
        infoform->Button6->Visible=false;
    }
    else
    if( button4_caption=="" ) {
        infoform->Button4->Visible=false;
        infoform->Button5->Visible=false;
        infoform->Button6->Visible=false;
    }
    else
    if( button5_caption=="" ) {
        infoform->Button5->Visible=false;
        infoform->Button6->Visible=false;
    }
    else
    if( button6_caption=="" ) {
        infoform->Button6->Visible=false;
    }

    infoform->ShowModal();

    ret=infoform->ret;
    delete infoform;
    return ret;
}

void TForm1::RereadBookmark()
{
    mybookmark.DelList();
    FILE *filein;
    char cline[200];
    if( (filein=fopen((home+".vc/bookmark").c_str(), "rt"))!=NULL ) {
        fgets(cline, 200, filein);
        while( !feof(filein) ) {
            TMenuItem *mi=&TMenuItem(HotdirList1);
            mi->Caption=Trim(AnsiString(cline));
            mybookmark.AddLast(CMyBookmark(mi));
            mybookmark[mybookmark.Length()-1].mi->OnClick=mybookmark[mybookmark.Length()-1].BookmarkMenuClick;
            fgets(cline, 200, filein);
        }
        fclose(filein);
    }
}

void TForm1::RefreshBookmark()
{
    try {
        while( true ) HotdirList1->Delete(0);
    }
    catch(...) {}

    for( int i=0;i<mybookmark.Length();i++ ) {
        HotdirList1->Add(mybookmark[i].mi);
    }

    bm_theline=&TMenuItem(HotdirList1);
    bm_theline->Caption="-";
    HotdirList1->Add(bm_theline);

    bm_addnew=&TMenuItem(HotdirList1);
    bm_addnew->Caption="Add This Directory";
    bm_addnew->OnClick=bm_addnewClick;
    bm_addnew->ShortCut=bmsc;
    HotdirList1->Add(bm_addnew);

/*
    bm_config=&TMenuItem(HotdirList1);
    bm_config->Caption="Configure Bookmark";
    bm_config->OnClick=bm_configClick;
    HotdirList1->Add(bm_config);
*/
}

void __fastcall TForm1::bm_addnewClick(TObject *Sender)
{
    if( act->mode!=NORMAL ) return;
    TMenuItem *mi=&TMenuItem(HotdirList1);
    mi->Caption=Trim(AnsiString(act->dirloc->Text));
    mybookmark.AddLast(CMyBookmark(mi));
    mybookmark[mybookmark.Length()-1].mi->OnClick=mybookmark[mybookmark.Length()-1].BookmarkMenuClick;
    RefreshBookmark();
    writebookmark();
}

void __fastcall TForm1::bm_configClick(TObject *Sender)
{}

void TForm1::writebookmark()
{
    FILE *filein;
    if( (filein=fopen((home+".vc/bookmark").c_str(), "w"))!=NULL ) {
        for( int i=0;i<mybookmark.Length();i++ )
            fputs(String(mybookmark[i].mi->Caption+"\n").c_str(),filein);
        fclose(filein);
    }
}

void TForm1::WriteTabs()
{
try {
    FILE *filein;
    if( (filein=fopen((home+".vc/tabs").c_str(), "w"))!=NULL ) {
// tabs on panel1
        fputs(String(IntToStr(tabs1->Tabs->Count)+"\n").c_str(),filein);
        if( tabs1->Tabs->Count )
            fputs(String(IntToStr(tabs1->TabIndex)+"\n").c_str(),filein);
        for( int i=0;i<tabs1->Tabs->Count;i++ )
            fputs(String(tabs1->Tabs->Items[i]->Caption+"\n").c_str(),filein);

// tabs on panel2
        fputs(String(IntToStr(tabs2->Tabs->Count)+"\n").c_str(),filein);
        if( tabs2->Tabs->Count )
            fputs(String(IntToStr(tabs2->TabIndex)+"\n").c_str(),filein);
        for( int i=0;i<tabs2->Tabs->Count;i++ )
            fputs(String(tabs2->Tabs->Items[i]->Caption+"\n").c_str(),filein);
        fclose(filein);
    }
} catch(...) {}
}

void TForm1::RereadTabs()
{
try {
    FILE *filein;
    char cline[200];
    try {
        while( true ) tabs1->Tabs->Delete(0);
    }
    catch(...) {}
    try {
        while( true ) tabs2->Tabs->Delete(0);
    }
    catch(...) {}

    if( (filein=fopen((home+".vc/tabs").c_str(), "rt"))!=NULL ) {
// tabs on panel1
        int count=0;
        int index=0;
        readstr(filein,cline);
        count=StrToInt(Trim(AnsiString(cline)));
        if( count ) {
            readstr(filein,cline);
            index=StrToInt(Trim(AnsiString(cline)));
        }
        for( int i=0;i<count;i++ ) {
            fgets(cline,200,filein);
            AnsiString addthis=Trim(AnsiString(cline));
            if( addthis[1]!='/' ) addthis="/"+addthis;
            tabs1->Tabs->Add(addthis);
        }
        if( count ) {
            tabs1->TabIndex=index;
            dirloc1->Text=tabs1->Tabs->Items[index]->Caption;
            panels[0].RefreshPanel();
            tabs1->Visible=true;
        }

// tabs on panel2
        count=0;
        index=0;
        readstr(filein,cline);
        count=StrToInt(Trim(AnsiString(cline)));
        if( count ) {
            readstr(filein,cline);
            index=StrToInt(Trim(AnsiString(cline)));
        }
        for( int i=0;i<count;i++ ) {
            fgets(cline,200,filein);
            AnsiString addthis=Trim(AnsiString(cline));
            if( addthis[1]!='/' ) addthis="/"+addthis;
            tabs2->Tabs->Add(addthis);
        }
        if( count ) {
            tabs2->TabIndex=index;
            dirloc2->Text=tabs2->Tabs->Items[index]->Caption;
            panels[1].RefreshPanel();
            tabs2->Visible=true;
        }
        fclose(filein);
    }
} catch(...) {}
}

void __fastcall TForm1::NewTabClick(TObject *Sender)
{
    if( act->tabs->Visible )
        act->tabs->Tabs->Add(act->dirloc->Text);
    else {
        act->tabs->Visible=true;
        act->tabs->Tabs->Add(act->dirloc->Text);
    }
    Resize_my();    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::tabs1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    fv1->SetFocus();
    if( Button==mbMiddle ) {
        bool dosome=false;
        int closethis=tabs1->IndexOfTabAt(X,Y);
        if( tabs1->TabIndex==closethis ) {
            tabs1->TabIndex=0;
            dosome=true;
        }
        if( tabs1->Tabs->Count==1 ) {
            tabs1->Visible=false;
            Resize_my();
        }

        tabs1->Tabs->Delete(closethis);

        if( dosome && tabs1->Visible ) {
            panels[0].dirloc->Text=tabs1->Tabs->Items[tabs1->TabIndex]->Caption;
            panels[0].RefreshPanel();
        }

    }

    if( Button==mbLeft ) {
        panels[0].dirloc->Text=tabs1->Tabs->Items[tabs1->IndexOfTabAt(X,Y)]->Caption;
        panels[0].RefreshPanel();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::tabs2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    fv2->SetFocus();
    if( Button==mbMiddle ) {
        bool dosome=false;
        int closethis=tabs2->IndexOfTabAt(X,Y);
        if( tabs2->TabIndex==closethis ) {
            tabs2->TabIndex=0;
            dosome=true;
        }
        if( tabs2->Tabs->Count==1 ) {
            tabs2->Visible=false;
            Resize_my();
        }

        tabs2->Tabs->Delete(closethis);

        if( dosome && tabs2->Visible ) {
            panels[1].dirloc->Text=tabs2->Tabs->Items[tabs2->TabIndex]->Caption;
            panels[1].RefreshPanel();
        }

    }

    if( Button==mbLeft ) {
        panels[1].dirloc->Text=tabs2->Tabs->Items[tabs2->IndexOfTabAt(X,Y)]->Caption;
        panels[1].RefreshPanel();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CloseTabClick(TObject *Sender)
{
        bool dosome=false;
        int closethis=act->tabs->TabIndex;
        if( act->tabs->TabIndex==closethis ) {
            act->tabs->TabIndex=0;
            dosome=true;
        }

        if( act->tabs->Tabs->Count==1 ) {
            act->tabs->Visible=false;
            Resize_my();
        }

        act->tabs->Tabs->Delete(closethis);

        if( dosome && act->tabs->Visible ) {
            act->dirloc->Text=act->tabs->Tabs->Items[act->tabs->TabIndex]->Caption;
            act->RefreshPanel();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CloseTabShow(TObject *Sender)
{
    if( act->tabs->Visible )
        CloseTab->Enabled=true;
    else
        CloseTab->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CreateArchiveFile1Click(TObject *Sender)
{
    act->Create_Archive(nact);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UnpackArchiveFile1Click(TObject *Sender)
{
    act->Unpack_Archive(nact);
}
//---------------------------------------------------------------------------

