/****************************************************************
*                                                               *
*    Name: Main.h                                               *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        The heather file of the main form.                     *
*        It also contains, some classes to handle threads, and  *
*        files, packages, extensions, searches and the hot      *
*        directory list.                                        *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QComCtrls.hpp>
#include <QExtCtrls.hpp>
#include <QFileCtrls.hpp>
#include <QMenus.hpp>
#include <QTypes.hpp>
#include <QGrids.hpp>
#include <QImgList.hpp>
#include "MyFtp.h"
#include "Action.h"
#include "Configure.h"
#include "Viewer.h"
#include "Progress.h"
#include "MyThread.h"
#include "MyDirent.h"
#include "MyPanel.h"
#include "MyOperations.h"
#include "MyList.h"
#include "InformationForm.h"
#include "MyBookmark.h"

//---------------------------------------------------------------------------
class CAct;

class CMyThread;

class CPac
{
public:
    AnsiString Name;
    AnsiString Ext;
    AnsiString Handle;

    bool copyin;
    bool copyout;
    bool rm;
    bool dir;
    bool run;

    bool listed;

    int num;
};

class CPac2
{
public:
    AnsiString Name;
    AnsiString Ext;
    AnsiString Handle;
    AnsiString HandleExtr;

    int num;
};

class CExt
{
public:
    AnsiString Name;
    AnsiString Ext;
    AnsiString Handle;

    int num;
};

class TViewForm;

class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TStatusBar *StatusBar1;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TMenuItem *Help1;
    TMenuItem *About1;
    TMenuItem *F1F101;
    TMenuItem *F5Copy1;
    TMenuItem *F10Exit1;
    TMenuItem *F8Delete1;
    TMenuItem *F6Move1;
    TMenuItem *F7CreateDirectory1;
    TImageList *imglst;
    TMenuItem *Options;
    TMenuItem *Command1;
    TMenuItem *Rereadconfigfile1;
    TMenuItem *Createsymlink1;
    TMenuItem *Findfile1;
    TMenuItem *F3View1;
    TMenuItem *F4Edit1;
    TMenuItem *Editsymlink1;
    TMenuItem *Chmod1;
    TMenuItem *Chown1;
    TMenuItem *TargetdirSourcedir1;
    TMenuItem *HotdirList1;
    TMenuItem *Selectinvert1;
    TMenuItem *Selectinvertbymask1;
    TMenuItem *Selectionnone1;
    TMenuItem *N6;
    TMenuItem *Freechildprocesses1;
    TMenuItem *Comparebycontent1;
    TMenuItem *Sortbyname1;
    TMenuItem *Sortbysize1;
    TMenuItem *Sortbydate1;
    TMenuItem *Invertsortdirection1;
    TMenuItem *N7;
    TMenuItem *Sortdirection1;
    TMenuItem *CreateFile1;
    TMenuItem *Rename1;
    TMenuItem *Rereaddirectory1;
    TMenuItem *ShowAllDirectorySize1;
    TMenuItem *Help2;
    TMenuItem *N8;
    TMenuItem *NewFtpConnection1;
    TPanel *Panel11;
    TPanel *Panel21;
    TMenuItem *IncrieseFontSize1;
    TMenuItem *DecreaseFontSize1;
    TMenuItem *SelectAll1;
    TMenuItem *CloseFTPConnection1;
    TMenuItem *Configure1;
    TMenuItem *MainMenu2;
    TMenuItem *ActivateBookmark1;
    TEdit *dirloc1;
    TButton *home1;
    TButton *root1;
    TButton *up1;
    TEdit *free1;
    TPanel *Panel3;
    TComboBox *cl;
    TButton *startwithxterm;
    TEdit *dirloc2;
    TButton *home2;
    TButton *root2;
    TButton *up2;
    TScrollBar *sb2;
    TEdit *selbar2;
    TEdit *free2;
    TScrollBar *sb1;
    TPanel *Panel1;
    TDrawGrid *fv1;
    THeaderControl *HeaderControl1;
    TPanel *Panel2;
    TDrawGrid *fv2;
    THeaderControl *HeaderControl2;
    TEdit *selbar1;
    TLabel *ShowPath;
    TSplitter *separator;
    TEdit *viewerfont;
    TMenuItem *InternalView1;
    TMenuItem *MultiRenameTool1;
    TImageList *imglst2;
    TImageList *imglst3;
    TTabControl *tabs1;
    TMenuItem *NewTab;
    TTabControl *tabs2;
    TMenuItem *N1;
    TMenuItem *CloseTab;
    TMenuItem *CreateArchiveFile1;
    TMenuItem *UnpackArchiveFile1;
    void __fastcall About1Click(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall fv1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall fv2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall fv1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall fv2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall clKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
    void __fastcall clKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall F5Copy1Click(TObject *Sender);
    void __fastcall F10Exit1Click(TObject *Sender);
    void __fastcall F8Delete1Click(TObject *Sender);
    void __fastcall F6Move1Click(TObject *Sender);
    void __fastcall F7CreateDirectory1Click(TObject *Sender);
    void __fastcall fv1DrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall fv2DrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall fv1Click(TObject *Sender);
    void __fastcall fv2Click(TObject *Sender);
    void __fastcall dirloc1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall dirloc2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall selbar1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall selbar2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall dirloc1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall dirloc2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall selbar1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall selbar2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Rereadconfigfile1Click(TObject *Sender);
    void __fastcall EditSymlink1Click(TObject *Sender);
    void __fastcall F3View1Click(TObject *Sender);
    void __fastcall F4Edit1Click(TObject *Sender);
    void __fastcall Chmod1Click(TObject *Sender);
    void __fastcall Chown1Click(TObject *Sender);
    void __fastcall fv1DblClick(TObject *Sender);
    void __fastcall fv2DblClick(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall Findfile1Click(TObject *Sender);
    void __fastcall TargetdirSourcedir1Click(TObject *Sender);
    void __fastcall Selectinvert1Click(TObject *Sender);
    void __fastcall Selectinvertbymask1Click(TObject *Sender);
    void __fastcall Selectionnone1Click(TObject *Sender);
    void __fastcall Freechildprocesses1Click(TObject *Sender);
    void __fastcall Comparebycontent1Click(TObject *Sender);
    void __fastcall Sortbyname1Click(TObject *Sender);
    void __fastcall Sortbysize1Click(TObject *Sender);
    void __fastcall Sortbydate1Click(TObject *Sender);
    void __fastcall Invertsortdirection1Click(TObject *Sender);
    void __fastcall Sortdirection1Click(TObject *Sender);
    void __fastcall sb1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall sb1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall sb2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall sb2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall sb1Scroll(TObject *Sender, TScrollCode ScrollCode,
          int &ScrollPos);
    void __fastcall sb2Scroll(TObject *Sender, TScrollCode ScrollCode,
          int &ScrollPos);
    void __fastcall CreateFile1Click(TObject *Sender);
    void __fastcall Rename1Click(TObject *Sender);
    void __fastcall Rereaddirectory1Click(TObject *Sender);
    void __fastcall ShowAllDirectorySize1Click(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
    void __fastcall NewFtpConnection1Click(TObject *Sender);
    void __fastcall HeaderControl1SectionResize(
          TCustomHeaderControl *HeaderControl,
          TCustomHeaderSection *Section);
    void __fastcall HeaderControl2SectionResize(
          TCustomHeaderControl *HeaderControl,
          TCustomHeaderSection *Section);
    void __fastcall HeaderControl1SectionClick(
          TCustomHeaderControl *HeaderControl,
          TCustomHeaderSection *Section);
    void __fastcall HeaderControl2SectionClick(
          TCustomHeaderControl *HeaderControl,
          TCustomHeaderSection *Section);
    void __fastcall IncrieseFontSize1Click(TObject *Sender);
    void __fastcall DecreaseFontSize1Click(TObject *Sender);
    void __fastcall free1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall free1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall free2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall free2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall SelectAll1Click(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall CloseFTPConnection1Click(TObject *Sender);
    void __fastcall root1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall up1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall root2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall up2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall root1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall up1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall root2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall up2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall root1Click(TObject *Sender);
    void __fastcall root2Click(TObject *Sender);
    void __fastcall up1Click(TObject *Sender);
    void __fastcall up2Click(TObject *Sender);
    void __fastcall home1Click(TObject *Sender);
    void __fastcall home2Click(TObject *Sender);
    void __fastcall home1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall home2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall home1KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall home2KeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall startwithxtermClick(TObject *Sender);
    void __fastcall startwithxtermKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall startwithxtermKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Configure1Click(TObject *Sender);
    void __fastcall MainMenu2Click(TObject *Sender);
    void __fastcall ActivateBookmark1Click(TObject *Sender);
    void __fastcall Createsymlink1Click(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall separatorMoved(TObject *Sender);
    void __fastcall InternalView1Click(TObject *Sender);
    void __fastcall N7Show(TObject *Sender);
    void __fastcall fv1MouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall fv1MouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall fv2MouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall fv2MouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall fv1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall fv2MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall HeaderControl1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall HeaderControl2MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall MultiRenameTool1Click(TObject *Sender);
    void __fastcall NewTabClick(TObject *Sender);
    void __fastcall tabs1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall tabs2MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall CloseTabClick(TObject *Sender);
    void __fastcall CloseTabShow(TObject *Sender);
    void __fastcall CreateArchiveFile1Click(TObject *Sender);
    void __fastcall UnpackArchiveFile1Click(TObject *Sender);
private:	// User declarations
    CAct *panels;

    bool readedconfig;
    float prate;
    AnsiString pfind;
    int sprcss[1000];
    int prcss_n;
    CMyList<CMyBookmark> mybookmark;

    void chk_pcss();
    int CallKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
    void CallKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
    void ChPanel(int panel = -1);
    int RefreshButtons(int Key,TShiftState Shift);
    int Exit_my();
    int Ctrl_Enter_my(TShiftState Shift);
    AnsiString RereadConfig_ver(FILE *filein);
    AnsiString RereadConfig_gen(FILE *filein);
    AnsiString RereadConfig_pac(FILE *filein);
    AnsiString RereadConfig_create_pac(FILE *filein);
    AnsiString RereadConfig_ext(FILE *filein);
    AnsiString RereadConfig_col(FILE *filein);
    void readcommandline();
    void writecommandline();
    void readpositions();
    void writepositions();
    void ReadShortCuts();
    void SetStatusBar();
    TMenuItem *bm_theline;
    TMenuItem *bm_addnew;
    TMenuItem *bm_config;

public:		// User declarations
    bool ignorecase;
    int viewerfontheight;
    int viewerheight;
    int viewerwidth;
    CAct *act;
    CAct *nact;
    AnsiString configfile_version;
    AnsiString act_configfile_version;


    int uid;
    int gid;
    bool nowrefresh;

    CMyList<CPac> pacs;
    CMyList<CPac2> cr_pacs;
    CMyList<CExt> exts;

    AnsiString execpath;
    AnsiString tmppath;
    AnsiString programpath;
    AnsiString home;
    AnsiString execcompare;
    AnsiString dateformat;
    AnsiString colwhat1;
    AnsiString colwhat2;
    AnsiString colwhat3;
    AnsiString colwhat4;
    AnsiString colwhat5;
    AnsiString dir_pref;
    AnsiString dir_post;
    AnsiString extviewer;
    AnsiString exteditor;
    AnsiString packageprefix;
    int maxthreads;
    int copybytes;
    int osztas;
    int topshift;
    int iconset;
    unsigned short bmsc;
    bool humanread;
    TColor col_panel_bg;
    TColor col_panel_font;
    TColor col_panel_exec;
    TColor col_panel_hl_bg;
    TColor col_panel_hl_font;
    TColor col_panel_hl_exec;
    TColor col_panel_sel;
    TColor col_cl_bg;
    TColor col_cl_font;
    TColor col_button_bg;
    TColor col_button_font;
    TColor col_bg;
    TColor col_font;
    AnsiString dirstr;
    bool extls;

    CMyThread **copy_thread;
    TViewForm **viewforms;

    TConfigForm *configform;

    void RereadConfig();
    void Resize_my();
    void Refresh_col();
    int ExecCmd(AnsiString name, bool ep=false, bool pwait=false);
    void SetShowPath(AnsiString newpath="");
    int GetPacInd(AnsiString name);
    int GetCrPacInd(AnsiString name);
    int GetCrPacIndByExt(AnsiString ext);
    int GetPacIndByExt(AnsiString ext);
    int GetExtInd(AnsiString name);
    int GetExtIndByExt(AnsiString ext);
    static int MessageDlg_my(AnsiString message, AnsiString caption,
            AnsiString button1_caption="Ok",
            AnsiString button2_caption="Cancel",
            AnsiString button3_caption="",
            AnsiString button4_caption="",
            AnsiString button5_caption="",
            AnsiString button6_caption=""
        );

    static void AnsiSplit(const AnsiString string,const AnsiString pattern,AnsiString &first,AnsiString &last);
    static int AnsiCounter(AnsiString string, char ch);
    static AnsiString GetStringByMask(AnsiString string, AnsiString mask);
    AnsiString HumanSize(__int64 psize,AnsiString type);
    static int StrToChmod(AnsiString sperm, int ex_stat=0);
    bool FitOnMask(AnsiString string, AnsiString mask);
    void RereadBookmark();
    void RefreshBookmark();
    void writebookmark();
    void WriteTabs();
    void RereadTabs();
    void __fastcall bm_addnewClick(TObject *Sender);
    void __fastcall bm_configClick(TObject *Sender);
    __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------

#endif
