/****************************************************************
*                                                               *
*    Name: MyDirent.cpp                                         *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the cpp file of the CMyDirent class. This      *
*        will handle the listing a directory content.           *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------


#pragma hdrstop

#include "MyDirent.h"
#include <sys/stat.h>
#include <unistd.h>
#include <SysUtils.hpp>
//---------------------------------------------------------------------------

#pragma package(smart_init)
CMyDirent::CMyDirent ()
{
    count=0;
    filelist=NULL;
    prevlocation="prev";
    location="location";
}

bool CMyDirent::SetLocation(AnsiString newpath)
{
//    if( location==newlocation ) return true;
    if( newpath=="" ) location="/";
    location=newpath;
    if( location[location.Length()]!='/' ) location=location+"/";

    if ((dir = opendir(location.c_str())) == NULL)
    {
        location=prevlocation;
        return false;
    }

// set the counter
    count=0;
    while ((ent = readdir(dir)) != NULL) {
        if( String(ent->d_name)!="." )
            count++;
    }

// set the filelist
    rewinddir(dir);
    if( filelist!=NULL ) delete []filelist;
    filelist=new sfilelist[count];
    int i=0;
    while ((ent = readdir(dir)) != NULL) {
        struct stat64 tf;
        try {
            if( lstat64(String(location+String(ent->d_name)).c_str(),&tf)!=0 ) {}
        } catch(...) {continue;}
        if( String(ent->d_name)=="." ) continue;
        if( count<=i ) continue;

        filelist[i].attr=tf.st_mode;
        filelist[i].mask="-";
        filelist[i].uid=tf.st_uid;
        filelist[i].gid=tf.st_gid;
        filelist[i].size=tf.st_size;
        filelist[i].date=tf.st_mtim.tv_sec;
        filelist[i].name=String(ent->d_name);
        filelist[i].link="";
// the file is a link
//        if( filelist[i].attr & S_IFLNK ) {
            char linktarget[2000];
            int ll=0;
            if( 0<(ll=readlink(String(location+filelist[i].name).c_str(),linktarget,2000)) ) {
                filelist[i].link=String(linktarget).SubString(1,ll);
                filelist[i].mask[1]='l';
                struct stat64 tf2;
                try {
                    if( stat64(String(location+filelist[i].name).c_str(),&tf2)!=0 ) {}
                } catch(...) {}
                if( tf2.st_mode & S_IFDIR ) filelist[i].mask[1]='d';
            }
//        }
        if( filelist[i].attr & S_IFDIR ) filelist[i].mask[1]='d';

            if( filelist[i].attr & S_ISUID )
                filelist[i].mask=filelist[i].mask+"u";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_ISGID )
                filelist[i].mask=filelist[i].mask+"g";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_ISVTX )
                filelist[i].mask=filelist[i].mask+"s";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IRUSR )
                filelist[i].mask=filelist[i].mask+"r";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IWUSR )
                filelist[i].mask=filelist[i].mask+"w";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IXUSR )
                filelist[i].mask=filelist[i].mask+"x";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IRGRP )
                filelist[i].mask=filelist[i].mask+"r";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IWGRP )
                filelist[i].mask=filelist[i].mask+"w";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IXGRP )
                filelist[i].mask=filelist[i].mask+"x";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IROTH )
                filelist[i].mask=filelist[i].mask+"r";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IWOTH )
                filelist[i].mask=filelist[i].mask+"w";
            else
                filelist[i].mask=filelist[i].mask+"-";

            if( filelist[i].attr & S_IXOTH )
                filelist[i].mask=filelist[i].mask+"x";
            else
                filelist[i].mask=filelist[i].mask+"-";

        i++;
    }
    if (closedir(dir) != 0) {}

    prevlocation=location;
    return true;
}


