/****************************************************************
*                                                               *
*    Name: MyList.h                                             *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*       This file descibe my chainlist. This class is very      *
*       similar to the built in vector class, but it is mine.   *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef MyListH
#define MyListH
//---------------------------------------------------------------------------
template<class T>
class CMyList
{
private:
    struct element {
        T data;
        element *next;
        element *prev;
    };
    element *last;
    element *first;
    int len;

public:

CMyList()
{
    last=NULL;
    first=NULL;
    len=0;
}

void DelList()
{
    if( !last || !first ) {
        last=NULL;
        first=NULL;
        len=0;
        return;
    }

    element *delthis=first;
    element *delnext=delthis->next;
    while( delthis ) {
        delnext=delthis->next;
        delete delthis;
        delthis=delnext;
    }
    last=NULL;
    first=NULL;
    len=0;
}

void AddFirst(T newdata)
{
    element *addthis=new element;
    addthis->next=first;
    addthis->prev=NULL;
    addthis->data=newdata;
    if( first )
        first->prev=addthis;
    first=addthis;
    if( !last ) last=addthis;
    len++;
}

void AddLast(T newdata)
{
    element *addthis=new element;
    addthis->next=NULL;
    addthis->prev=last;
    addthis->data=newdata;
    if( last )
        last->next=addthis;
    last=addthis;
    if( !first ) first=addthis;
    len++;
}

T GetFirst()
{
    if( !first ) return T();
    return first->data;
}

T GetLast()
{
    if( !last ) return T();
    return last->data;
}

void DelFirst()
{
    if( !first ) return;
    element *delthis=first;
    first=first->next;
    if( first )
        first->prev=NULL;
    else
        last=NULL;
    delete delthis;
    len--;
}

void DelLast()
{
    if( !last ) return;
    element *delthis=last;
    last=last->prev;
    if( last )
        last->next=NULL;
    else
        first=NULL;
    delete delthis;
    len--;
}

T Get(int index=0)
{
    if( !first ) return T();
    element *searchthis=first;
    int i=0;
    while( i<index && searchthis!=last ) {
        searchthis=searchthis->next;
        i++;
    }
    return searchthis->data;
}

void Del(int index=0)
{
    if( !first ) return T();
    element *searchthis=first;
    int i=0;
    while( i<index && searchthis!=last ) {
        searchthis=searchthis->next;
        i++;
    }

    if( !searchthis ) return;
    if( searchthis->next )
        searchthis->next->prev=searchthis->prev;
    else
        last=searchthis->prev;
    if( searchthis->prev )
        searchthis->prev->next=searchthis->next;
    else
        first=searchthis->next;
    delete searchthis;
    len--;
}

bool IsNull()
{
    return first==NULL && last==NULL;
}

int Length()
{
    return len;
}

T operator[](int index) const
{
    return Get(index);
}


T& operator[](int index)
{
    if( !first ) throw true;
    element *searchthis=first;
    int i=0;
    while( i<index && searchthis!=last ) {
        searchthis=searchthis->next;
        i++;
    }
    return searchthis->data;
}


};
#endif
