/****************************************************************
*                                                               *
*    Name: MyPanel.cpp                                          *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This file describe the base file class, and the panel  *
*        class. There are the operations of the panels.         *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------


#pragma hdrstop

#include "MyPanel.h"
#include "Main.h"
#include "Action.h"
#include "Progress.h"
#include "RPMLikePackage.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

CAct::CAct()
{
    allproceed=false;
    allproceed_err=false;
    dirent=new CMyDirent();
    def_pac=-1;

    dirent->SetLocation(Form1->home);
    prevdir=dirent->Location()+"..";
    panel=new my_file[1];
    mode=NORMAL;
    sortmode=0;
    sortdir=0;
    ftp=new CMyFtp();
    ftpbuf=NULL;
    servername="bmw.vezer.elte.hu";
    prevuserpass="anonymous/VcFtpClient";
    act=this;
    search=NULL;
    dirhist=new CMyList<CDirHist>();
    // dirhist->
}

int CAct::RefreshPanel()
{
    int row=0;
    active->Enabled=false;
    if( tabs->Visible )
        tabs->Tabs->Items[tabs->TabIndex]->Caption=dirloc->Text;
    if( mode==NORMAL) {
        if( !dirent->SetLocation(String(dirloc->Text)) ) {
            prevdir=dirloc->Text;
            if( dirloc->Text[dirloc->Text.Length()]=='/' )
                dirloc->Text=dirloc->Text.SubString(1,dirloc->Text.Length()-1);
            while( dirloc->Text[dirloc->Text.Length()]!='/' )
                dirloc->Text=dirloc->Text.SubString(1,dirloc->Text.Length()-1);
            RefreshPanel();
            return 1;
        }
    } else if( mode==ARCH ) {
        if( !Form1->extls || !Form1->pacs[def_pac].listed )
            Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" list \""+String(dirloc->Text)+"\" >"+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/pack",false,true);
        Form1->pacs[def_pac].listed=true;
    } else if( mode==FTP ) {
        if( !ftp->Dir(String(Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp").c_str(),archdir.c_str(),ftpbuf) )
            return CheckFtpConnection(0);
        Form1->ExecCmd(Form1->packageprefix+"uftp \""+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp\" >"+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2",false,true);
    }

    CRPMLikePackage *dirlist=new CRPMLikePackage();
    if( panel ){delete []panel;panel=NULL;}
    int arch_count=0;
    if( mode==NORMAL ) {
        panel=new my_file[dirent->Count()];
    } else if( mode==ARCH ) {
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/pack").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the archive file!");
            prevdir=dirloc->Text;
            while( dirloc->Text[dirloc->Text.Length()]!='/' )
                dirloc->Text=dirloc->Text.SubString(1,dirloc->Text.Length()-1);
            mode=NORMAL;
            RefreshPanel();
            return 0;
        }
        char string[400];
        do {
            fgets(string, 400, f);
            AnsiString line=Trim(AnsiString(string));
            if( !feof(f) ) {
                AnsiString rights;
                AnsiString param;
                AnsiString pathnev;
                AnsiString size;
                TForm1::AnsiSplit(line,":",rights,param);
                TForm1::AnsiSplit(param,":",size,pathnev);
                if( rights=="" || size=="" || pathnev=="" || TForm1::AnsiCounter(line,':')<2 ) {
                    continue;
                }
                if( pathnev.Pos(" ->")>0 ) pathnev=pathnev.SubString(1,pathnev.Pos(" ->")-1);
                if( pathnev[pathnev.Length()]=='/' )
                    pathnev=pathnev.SubString(1,pathnev.Length()-1);
                if( Form1->pacs[def_pac].dir ) {
                    if((pathnev.Pos(archdir)==1 || archdir=="") && TForm1::AnsiCounter(archdir,'/')==TForm1::AnsiCounter(pathnev,'/') )
                        arch_count++;
                } else {
                    if( line[1]=='d' ) continue;
                    if( pathnev.Pos("./")==1 ) pathnev=pathnev.SubString(3,pathnev.Length()-2);
                    if( pathnev[1]=='/' ) pathnev=pathnev.SubString(2,pathnev.Length()-1);
                    bool isadir=false;
                    AnsiString nname=dirlist->GetNextDir(archdir,pathnev,isadir);
                    if( isadir && dirlist->Add(archdir+nname) )
                        arch_count++;
                    else
                    if( !isadir && archdir+nname==pathnev )
                        arch_count++;
                }
            }
        } while ( !feof(f) );
        fclose(f);
        panel=new my_file[arch_count+1];
    } else if( mode==SEARCH ) {
        panel=new my_file[search_num+1];
        newsearch=search;
    } else if( mode==FTP ) {
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the ftp2 file!");
            prevdir="/valami";
            while( dirloc->Text[dirloc->Text.Length()]!='/' )
                dirloc->Text=dirloc->Text.SubString(1,dirloc->Text.Length()-1);
            mode=NORMAL;
            RefreshPanel();
            return 0;
        }
        char string[400];
        do {
            fgets(string, 400, f);
            AnsiString line=Trim(AnsiString(string));
            if( !feof(f) ) {
                arch_count++;
            }
        } while ( !feof(f) );
        fclose(f);
        panel=new my_file[arch_count+1];
    }

    dirlist->Clear();

    selected=0;
    selected_bytes=0;
    sum=0;
    sum_bytes=0;

    if( mode==NORMAL ) {
// extls elements here
        int i=0;
        while ( i<dirent->Count() ) {
            panel[i].Mask=dirent->filelist[i].mask;
            panel[i].stat=dirent->filelist[i].attr;
            panel[i].Type=IntToStr(dirent->filelist[i].attr);
            panel[i].Name=dirent->filelist[i].name;
            panel[i].Size=dirent->filelist[i].size;

try {
            DateTimeToString(panel[i].Date,Form1->dateformat,FileDateToDateTime(dirent->filelist[i].date));
} catch(...) { }
            panel[i].uid=dirent->filelist[i].uid;
            panel[i].gid=dirent->filelist[i].gid;

            panel[i].pref=ExtractFileName(String(panel[i].Name));
            panel[i].ext=ExtractFileExt(String(panel[i].Name)).LowerCase();

            panel[i].exec=access(String(dirloc->Text+panel[i].Name).c_str(),R_OK | X_OK) == 0 ;

            panel[i].ii=GetIconIndex(panel[i].pref,panel[i].ext);
            panel[i].Link=dirent->filelist[i].link;
            sum++;
            if( panel[i].Mask[1]=='d' ) {
                panel[i].Type="Directory";
                panel[i].Size=0;
                panel[i].Mask[1]='d';
                if( panel[i].Name=="..")
                    panel[i].ii=BM_UP;
                else {
                    if( panel[i].Link=="") {
                        if( panel[i].exec )
                            panel[i].ii=BM_DIR;
                        else
                            panel[i].ii=BM_DIRNOACCESS;
                    } else {
                        panel[i].ii=BM_DIRLINK;
                        panel[i].Mask[1]='l';
                    }
                }
            } else {
                if( panel[i].Link!="") {
                    panel[i].Mask[1]='l';
                    panel[i].ii=BM_FILELINK;
                }
                sum_bytes+=panel[i].Size;
            }
            if( dirloc->Text+panel[i].Name==prevdir ) {
                prevdir="";
                row=i;
                panel[i].Focused=true;
            }
            else panel[i].Focused=false;
            panel[i].Selected=false;
            i++;
        }
    } else if( mode==ARCH ) {
// refresh panel with archive element
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/pack").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the archive file 2!");
            prevdir=dirloc->Text;
            while( dirloc->Text[dirloc->Text.Length()]!='/' )
                dirloc->Text=dirloc->Text.SubString(1,dirloc->Text.Length()-1);
            mode=NORMAL;
            RefreshPanel();
            return 0;
        }
        char cline[400];
        int i=1;
        panel[0].Name="..";
        panel[0].ii=BM_UP;
        panel[0].Size=0;
        panel[0].Type="Directory";
        if( dirloc->Text+archdir+panel[0].Name==prevdir ) {
            prevdir="";
            panel[0].Focused=true;
            row=0;
        } else
            panel[0].Focused=false;
        panel[0].Mask="drwxr-xr-x";
        panel[0].Selected=false;
        while ( i<=arch_count ) {
            fgets(cline, 400, f);
            AnsiString line=Trim(AnsiString(cline));
            AnsiString rights;
            AnsiString param;
            AnsiString pathnev;
            AnsiString size;
            TForm1::AnsiSplit(line,":",rights,param);
            TForm1::AnsiSplit(param,":",size,pathnev);
            if( rights=="" || size=="" || pathnev=="" || TForm1::AnsiCounter(line,':')<2 ) {
                continue;
            }
            if( pathnev.Pos(" ->")>0 ) pathnev=pathnev.SubString(1,pathnev.Pos(" ->")-1);
            if( pathnev[pathnev.Length()]=='/' )
                pathnev=pathnev.SubString(1,pathnev.Length()-1);
            if( Form1->pacs[def_pac].dir ) {
                if( !((pathnev.Pos(archdir)==1 || archdir=="") && TForm1::AnsiCounter(archdir,'/')==TForm1::AnsiCounter(pathnev,'/')) ) continue;
            } else {
                if( line[1]=='d' )
                    continue;
                if( pathnev.Pos("./")==1 )
                    pathnev=pathnev.SubString(3,pathnev.Length()-2);
                if( pathnev[1]=='/' )
                    pathnev=pathnev.SubString(2,pathnev.Length()-1);
                bool isadir=false;
                AnsiString nname=dirlist->GetNextDir(archdir,pathnev,isadir);
                if( isadir && dirlist->Add(archdir+nname) ) {
                    pathnev=archdir+nname;
                    line[1]='d';
                } else
                if( !(!isadir && archdir+nname==pathnev) )
                continue;
            }
            AnsiString name;
            AnsiString path;

            path=pathnev;
            if( path.Pos("/")>0 ) {
                while( path[path.Length()]!='/' )
                    path=path.SubString(1,path.Length()-1);
                name=pathnev.SubString(path.Length()+1,pathnev.Length()-1);
            } else {
                name=pathnev;
                path="";
            }
            panel[i].Name=name;
            try {
                panel[i].Size=StrToInt64(size);
            }
            catch(...) {
                try {
                    int len=size.Length();
                    AnsiString size1=size.SubString(1,len-5);
                    AnsiString size2=size.SubString(len-4,5);
                    panel[i].Size=(__int64(StrToInt(size1))*100000)+StrToInt(size2);
                } catch(...) {panel[i].Size=0;}
            }
            panel[i].Date="0";
            panel[i].Mask=rights;
            panel[i].uid=Form1->uid;
            panel[i].gid=Form1->gid;
            panel[i].exec=false;
            panel[i].pref=ExtractFileName(name);
            panel[i].ext=ExtractFileExt(name).LowerCase();
            panel[i].ii=GetIconIndex(panel[i].pref,panel[i].ext);
            if( line[1]=='l' )
                panel[i].ii=BM_FILELINK;
            panel[i].Link=path;
            sum++;
            sum_bytes+=panel[i].Size;
            if( line[1]=='d' ) {
                panel[i].Type="Directory";
                panel[i].Size=0;
                panel[i].ii=BM_DIR;
                panel[i].exec=true;
                panel[i].Mask[1]='d';
            } else {
                panel[i].Type="0";
                if( panel[i].Mask[4]=='x')
                    panel[i].exec=true;
            }
            if( dirloc->Text+archdir+panel[i].Name==prevdir ) {
                prevdir="";
                row=i;
                panel[i].Focused=true;
            } else panel[i].Focused=false;
            panel[i].Selected=false;
            i++;
        }
        fclose(f);
    } else if( mode==SEARCH )
// refresh panel with the search element
    for( int i=0;i<=search_num&&(i==0||newsearch);i++ ) {
            if( i==0 ) {
                panel[0].Name="..";
                panel[0].ii=BM_UP;
                panel[0].Mask="d---r-xr-xr-x";
                panel[0].Type="Directory";
                panel[0].Focused=true;
                panel[0].Selected=false;
                panel[0].Size=0;
                continue;
            }
            if( newsearch==search )
                dirent->SetLocation(newsearch->dir);

            panel[i].Name=newsearch->dir+dirent->filelist[newsearch->num].name;
            panel[i].Size=dirent->filelist[newsearch->num].size;
try {
            DateTimeToString(panel[i].Date,Form1->dateformat,FileDateToDateTime(dirent->filelist[newsearch->num].date));
} catch(...) { }
            panel[i].Type="0";
            panel[i].Mask=dirent->filelist[newsearch->num].mask;
            panel[i].stat=dirent->filelist[newsearch->num].attr;
            panel[i].uid=dirent->filelist[newsearch->num].uid;
            panel[i].gid=dirent->filelist[newsearch->num].gid;
            panel[i].Type=IntToStr(dirent->filelist[newsearch->num].attr);
            panel[i].exec=access(String(dirent->Location()+panel[i].Name).c_str(),R_OK | X_OK) == 0 ;
            panel[i].pref=ExtractFileName(String(panel[i].Name));
            panel[i].ext=ExtractFileExt(String(panel[i].Name)).LowerCase();
            panel[i].ii=GetIconIndex(panel[i].pref,panel[i].ext);
            panel[i].Link=dirent->filelist[newsearch->num].link;
            sum++;
            if( panel[i].Mask[1]=='d' ) {
                panel[i].Type="Directory";
                panel[i].Size=0;
                panel[i].Mask[1]='d';
                if( panel[i].Name=="..")
                    panel[i].ii=BM_UP;
                else {
                    if( panel[i].Link=="")
                        panel[i].ii=BM_DIR;
                    else {
                        panel[i].ii=BM_DIRLINK;
                        panel[i].Mask[1]='l';
                    }
                }
            } else {
                if( panel[i].Link!="") {
                    panel[i].Mask[1]='l';
                    panel[i].ii=BM_FILELINK;
                }
                sum_bytes+=panel[i].Size;
            }
        panel[i].Focused=false;
        panel[i].Selected=false;
        if( newsearch->next && newsearch->dir!=newsearch->next->dir )
            dirent->SetLocation(newsearch->next->dir);
        newsearch=newsearch->next;
    } else if( mode==FTP ) {
// refresh panel with ftp element
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the ftp2 file 2!");
            prevdir=dirloc->Text;
            while( dirloc->Text[dirloc->Text.Length()]!='/' )
                dirloc->Text=dirloc->Text.SubString(1,dirloc->Text.Length()-1);
            mode=NORMAL;
            RefreshPanel();
            return 0;
        }
        char cline[400];
        int i=1;
        panel[0].Name="..";
        panel[0].ii=BM_UP;
        panel[0].Size=0;
        panel[0].Type="Directory";
        if( dirloc->Text+panel[0].Name==prevdir ) {
            prevdir="";
            panel[0].Focused=true;
            row=0;
        } else
            panel[0].Focused=false;
        panel[0].Mask="drwxr-xr-x";
        panel[0].Selected=false;
        fgets(cline, 400, f);
try {
        while ( i<=arch_count ) {
            AnsiString line=Trim(AnsiString(cline));
            AnsiString rights;
            AnsiString param;
            AnsiString name;
            AnsiString size;
            TForm1::AnsiSplit(line,":",rights,param);
            TForm1::AnsiSplit(param,":",size,name);
            if( rights=="" || size=="" || name=="" || TForm1::AnsiCounter(line,':')<2 ) {
                if( arch_count>0 ) arch_count--;
                continue;
            }
            if( name.Pos(" ->")>0 ) name=name.SubString(1,name.Pos(" ->")-1);
            panel[i].Name=name;
            try {
                panel[i].Size=StrToInt64(size);
            } catch(...) {
                try {
                    int len=size.Length();
                    AnsiString size1=size.SubString(1,len-5);
                    AnsiString size2=size.SubString(len-4,5);
                    panel[i].Size=(__int64(StrToInt(size1))*100000)+StrToInt(size2);
                } catch(...) {panel[i].Size=0;}
            }
            panel[i].Date="0";
            panel[i].Mask=rights;
            panel[i].uid=Form1->uid;
            panel[i].gid=Form1->gid;
            panel[i].exec=false;
            panel[i].pref=ExtractFileName(name);
            panel[i].ext=ExtractFileExt(name).LowerCase();
            panel[i].ii=GetIconIndex(panel[i].pref,panel[i].ext);
            if( line[1]=='l' )
                panel[i].ii=BM_FILELINK;
            panel[i].Link="";
            sum++;
            sum_bytes+=panel[i].Size;
            if( line[1]=='d' ) {
                panel[i].Type="Directory";
                panel[i].Size=0;
                panel[i].ii=BM_DIR;
                panel[i].exec=true;
            } else {
                panel[i].Type="0";
                if( panel[i].Mask[4]=='x')
                    panel[i].exec=true;
            }
            if( dirloc->Text+panel[i].Name==prevdir ) {
                prevdir="";
                row=i;
                panel[i].Focused=true;
            } else panel[i].Focused=false;
            panel[i].Selected=false;
            fgets(cline, 400, f);
            i++;
        }
}
catch(...) {
    ShowMessage("!!! Error while reading ftp !!!");
}

        fclose(f);
    }
    if( mode==NORMAL ) {
        panelsort(dirent->Count(),row);
        active->RowCount=dirent->Count();
    } else
    if( mode==ARCH || mode==FTP ) {
        panelsort(arch_count+1,row);
        active->RowCount=arch_count+1;
    } else
    if( mode==SEARCH )
        active->RowCount=search_num+1;

    if( active->RowCount-sb->LargeChange>0 )
        sb->Max=active->RowCount-sb->LargeChange;
    else
        sb->Max=0;

    if( panel[0].Name!=".." ) CheckUpDp(row);
    if( active==Form1->act->active ) {
        active->Row=row;
        Form1->SetShowPath(String(dirloc->Text));
    }
    active->Invalidate();
    active->Enabled=true;
    if( tabs->Visible && tabs->Tabs->Items[tabs->TabIndex]->Caption!=dirloc->Text )
        tabs->Tabs->Items[tabs->TabIndex]->Caption=dirloc->Text;
    RefreshSelBar();
    if( dirlist ) {delete dirlist;dirlist=NULL;}
    return 0;
}

int CAct::Copy_my(CAct *nact,TShiftState Shift)
{
// chech one of the panels are not NORMAL
    if( Shift.Contains(ssShift) && mode!=NORMAL )
        return 0;
    if( mode==ARCH || nact->mode==ARCH ) {
        return Copy_Arch(nact);
    }
    if( mode==FTP || nact->mode==FTP ) {
        return Copy_Ftp(nact);
    }

    if( nact->mode==SEARCH ) {
        ShowMessage("You can not copy to search panel!");
        return 0;
    }

// show the copy form for check the what the user want
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Copy";
    if( Shift.Contains(ssShift) ) {
        actionform->doon->Text=dirloc->Text;
        if( selected==0 )
            actionform->doon2->Text=panel[active->Row].Name;
        else
            actionform->doon2->Text="*";
    } else {
        actionform->doon->Text=nact->dirloc->Text;
        actionform->doon2->Text="*";
    }
    actionform->mess1->Caption="Copytodir";
    actionform->mess2->Caption="Filemask";
    actionform->status=0;
    actionform->symlinks->Enabled=true;
    actionform->doon2->Enabled=true;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=true;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    CheckSelected();

    Form1->nowrefresh=false;
    int i=0;
    while( i<Form1->maxthreads && Form1->copy_thread[i]->created ) i++;
    if( i==Form1->maxthreads ) return 0;
    Form1->copy_thread[i]->Create(Form1->Owner,panel,active->RowCount,selected,"copy",
      String(dirloc->Text),String(actionform->doon->Text),
      String(actionform->doon2->Text),mode,actionform->symlinks->Checked,
      actionform->presattr->Checked,Form1->copybytes);
    Form1->copy_thread[i]->Execute();

    selected=0;
    selected_bytes=0;

    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[active->Row].Name;
    RefreshPanel();
    Form1->nowrefresh=true;
    delete actionform;
    return 0;
}

int CAct::Move_my(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode!=NORMAL || nact->mode!=NORMAL ) {
        ShowMessage("It has not been implemented, yet!");
        return -1;
    }

// show the move form
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Move";
    actionform->mess1->Caption="MoveToDir";
    actionform->mess2->Caption="Filemask";
    actionform->doon->Text=nact->dirloc->Text;
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=true;
    actionform->doon2->Text="*";
    actionform->presattr->Enabled=true;
    actionform->recursive->Enabled=false;
    actionform->ShowModal();
// move canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    CheckSelected();

    Form1->nowrefresh=false;

    if( active->Row+1<active->RowCount )
        prevdir=dirloc->Text+panel[active->Row+1].Name;
    else
        prevdir=dirloc->Text+panel[active->Row].Name;

    int i=0;
    while( i<Form1->maxthreads && Form1->copy_thread[i]->created ) i++;
    if( i==Form1->maxthreads ) return 0;
    Form1->copy_thread[i]->Create(Form1->Owner,panel,active->RowCount,selected,"move",
      String(dirloc->Text),String(actionform->doon->Text),
      String(actionform->doon2->Text),mode,actionform->symlinks->Checked,
      actionform->presattr->Checked,Form1->copybytes);
    Form1->copy_thread[i]->Execute();

    selected=0;
    selected_bytes=0;

    nact->prevdir="";
    nact->RefreshPanel();
    RefreshPanel();
    Form1->nowrefresh=true;
    delete actionform;
    return 0;
}

int CAct::MkDir_my(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode==FTP ) {
        return MkDir_my_Ftp();
    }
    if( mode!=NORMAL ) {
        ShowMessage("It has not been implemented, yet!");
        return -1;
    }
// create directory on act->panel
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Create Directory";
    actionform->doon->Text="";
    actionform->mess1->Caption="Directory name";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// directory creation canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    if( actionform->doon->Text!="" ) {
        act->prevdir=act->dirloc->Text+actionform->doon->Text;
        try {
            MkDir(String(act->dirloc->Text+actionform->doon->Text));
        }
        catch(...) {
            ShowMessage("Could not create "+actionform->doon->Text+"!");
            return -1;
        }
    }
    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+actionform->doon->Text;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::Delete_my(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode==ARCH ) {
        return Delete_FromArch();
    }
    if( mode==FTP ) {
        return Delete_my_Ftp();
    }

// show the delete form
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Delete";
    actionform->doon->Text="Do you want to delete from "+act->dirloc->Text+"?";
    actionform->mess1->Caption="";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// deletion canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    CheckSelected();
    Form1->nowrefresh=false;

    if( act->active->Row+1<act->active->RowCount )
        act->prevdir=act->dirloc->Text+act->panel[act->active->Row+1].Name;
    else
        act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;

    int i=0;
    while( i<Form1->maxthreads && Form1->copy_thread[i]->created ) i++;
    if( i==Form1->maxthreads ) return 0;
    Form1->copy_thread[i]->Create(Form1->Owner,act->panel,act->active->RowCount,selected,"delete",
      String(act->dirloc->Text),String(actionform->doon->Text),
      "",mode,actionform->symlinks->Checked,
      actionform->presattr->Checked,Form1->copybytes);
    Form1->copy_thread[i]->Execute();

    selected=0;
    selected_bytes=0;

    mode=NORMAL;
    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    RefreshPanel();
    Form1->nowrefresh=true;
    delete actionform;
    return 0;
}

int CAct::Enter_my()
{
    if( act->panel[act->active->Row].Name==".." ) {
        if( cdpp()==0 )
            RefreshPanel();
        return 0;
    } else {
        if( act->panel[act->active->Row].Type=="Directory" ) {
          if( mode==ARCH ) {
            archdir=archdir+act->panel[act->active->Row].Name+"/";
            RefreshPanel();
            act->prevdir=act->dirloc->Text+archdir+"..";
          } else if( mode==FTP ) {
            archdir=archdir+act->panel[act->active->Row].Name+"/";
            act->dirloc->Text="ftp://"+servername+archdir;
            act->prevdir=act->dirloc->Text+"..";
            RefreshPanel();
          } else {
            WideString olddir=act->dirloc->Text;
            WideString newdir=act->dirloc->Text+act->panel[act->active->Row].Name+"/";
            try {
                ChDir(String(newdir));
            }
            catch(...) {
                ShowMessage("Could not change directory "+newdir+"!");
                return -1;
            }
            if( !act->panel[act->active->Row].exec ) {
                return 0;
            }
            act->dirloc->Text=newdir;
            act->prevdir=act->dirloc->Text+"..";
            if( RefreshPanel()==-1 ) {
                act->dirloc->Text=olddir;
                act->prevdir=newdir.SubString(1,newdir.Length()-1);
                RefreshPanel();
            }
            return 0;
          }
        } else {
            int def_pac_new=Form1->GetPacIndByExt(act->panel[act->active->Row].ext);
            if( def_pac_new!=-1 ) {
                if( mode==FTP ) {
                    return 1;
                }
                WideString newdir;
                if( mode==SEARCH ) {
                    newdir=act->panel[act->active->Row].Name;
                } else if( mode==NORMAL ) {
                    newdir=act->dirloc->Text+act->panel[act->active->Row].Name;
                } else if( mode==ARCH ) {
                    Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" copyout \""+String(act->dirloc->Text)+"\" \""+String(act->panel[act->active->Row].Link+act->panel[act->active->Row].Name)+"\" \""+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/"+String(panel[act->active->Row].Name)+"\"",false,true);
                    newdir=Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/"+String(act->panel[act->active->Row].Name);
                    CDirHist ndh;
                    ndh.dir=String(act->dirloc->Text);
                    ndh.archdir=archdir;
                    ndh.mode=mode;
                    ndh.def_pac=def_pac;
                    dirhist->AddFirst(ndh);
                }
                def_pac=def_pac_new;
                Form1->pacs[def_pac].listed=false;
                mode=ARCH;
                archdir="";
                act->dirloc->Text=newdir;
                act->prevdir=act->dirloc->Text+"..";
                RefreshPanel();
                return 0;
            } else {
                int def_play=Form1->GetExtIndByExt(act->panel[act->active->Row].ext);
                if( def_play!=-1 ) {
                    if( mode!=NORMAL && mode!=SEARCH ) return 0;
// execute program for this extension
                    if( mode==SEARCH )
                        Form1->ExecCmd(String(Form1->exts[def_play].Handle+" \""+act->panel[act->active->Row].Name+"\""));
                    else
                        Form1->ExecCmd(String(Form1->exts[def_play].Handle+" \""+act->dirloc->Text+act->panel[act->active->Row].Name+"\""));
                } else {
// execute an executable
                    if( mode!=NORMAL && mode!=SEARCH && mode!=ARCH ) {
                        ShowMessage("It has not been implemented, yet!");
                        return 0;
                    }
                    if( act->panel[act->active->Row].exec )
                        if( mode==SEARCH )
                            Form1->ExecCmd(String(act->panel[act->active->Row].Name),true);
                        else
                        if( mode==ARCH ) {
                          if( Form1->pacs[def_pac].run )
                            Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" run \""+String(act->dirloc->Text)+"\" \""+String(act->panel[act->active->Row].Link+act->panel[act->active->Row].Name)+"\"",false,true);
                        } else
                            Form1->ExecCmd(String(act->dirloc->Text+act->panel[act->active->Row].Name),Form1->startwithxterm->Down);
                }
            }
        }
    }
    return 0;
}

int CAct::Rename_my(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode!=NORMAL ) {
        ShowMessage("It has not implemented, yet!");
        return -1;
    }
    if( act->panel[act->active->Row].Name==".." )
        return -1;

// show the move form
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Rename";
    if( selected==0 )
        actionform->doon->Text=act->panel[act->active->Row].Name;
    else
        actionform->doon->Text="*";
    actionform->mess1->Caption="New name";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// move canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    allproceed_err=false;
    CheckSelected();

// check for selected files
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( CheckDP(i)==1 ) {
            Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
            continue;
        }
        if( mode==SEARCH) {
            if( !RenameFile(String(act->panel[i].Name), String(act->dirloc->Text)+TForm1::GetStringByMask(String(act->panel[i].pref),String(actionform->doon->Text))) ) {
                int ret=1;
                if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while renaming file!","Error Renaming File","Ignore All","Ignore");
                if( 1==ret )
                    allproceed_err=true;
            }
        } else {
            if( !RenameFile(String(act->dirloc->Text+act->panel[i].Name), String(act->dirloc->Text)+TForm1::GetStringByMask(String(act->panel[i].Name),String(actionform->doon->Text))) ) {
                int ret=1;
                if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while renaming file!","Error Renaming File","Ignore All","Ignore");
                if( 1==ret )
                    allproceed_err=true;
            }
        }
    }

    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+actionform->doon->Text;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::CheckDP(int row)
{
    if( act->panel[row].Name==".." )
        return 1;
    return 0;
}
//---------------------------------------------------------------------------

void CAct::RefreshSelBar()
{
try {
    AnsiString free="0";
    AnsiString total="0";
    AnsiString per="100%";
    AnsiString here="";
    AnsiString selbytes=Form1->HumanSize(selected_bytes,"!!!");
    AnsiString bytes=Form1->HumanSize(sum_bytes,"!!!");
    if( selbytes==Form1->dirstr ) selbytes="0";
    if( bytes==Form1->dirstr ) bytes="0";
    GetFreeSpace(&free,&total,&per,&here);
    selbar->Text=IntToStr(selected)+" of "+IntToStr(sum)+" selected ("+selbytes+" of "+bytes+"bytes selected)";
    this->free->Text="Free "+free+" of "+total+" ("+per+") on "+here;
}
catch(...) {
    ShowMessage("!!! Error refreshing selection bar !!!");
}
}

void CAct::CheckSelected()
{
    if( selected==0 ) {
        selected++;
        selected_bytes+=act->panel[act->active->Row].Size;
        act->panel[act->active->Row].Selected=true;
    }
}

void CAct::SelectAll()
{
    for( int i=1;i<act->active->RowCount;i++ )
        if( !act->panel[i].Selected ) {
            selected++;
            selected_bytes+=act->panel[i].Size;
            act->panel[i].Selected=true;
        } else {
            selected--;
            selected_bytes-=act->panel[i].Size;
            act->panel[i].Selected=false;
        }
        act->active->Invalidate();
        RefreshSelBar();
}

__int64 CAct::GetDirSize(AnsiString SrcDir)
{
    __int64 size=0;
    if( act->dirent->SetLocation(SrcDir+"/") )
    for( int i=0;i<act->dirent->Count();i++ ) if( act->dirent->filelist[i].name!=".." ) {
        if( act->dirent->filelist[i].mask[1]=='d' && act->dirent->filelist[i].link=="" ) {
            size+=GetDirSize(SrcDir+"/"+String(act->dirent->filelist[i].name));
            act->dirent->SetLocation(SrcDir+"/");
        } else
            size+=act->dirent->filelist[i].size;
    }
    return size;
}

int CAct::Create_my(CAct *nact)
{
    if( mode!=NORMAL ) {
        ShowMessage("You can not create a file here!");
        return 0;
    }
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Create File";
    actionform->doon->Text="";
    actionform->mess1->Caption="Filename";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
    if( actionform->status==2 ) {delete actionform; return 2;}
    if( actionform->doon->Text=="" ) return 0;
    int ret=FileCreate(String(act->dirloc->Text+actionform->doon->Text));
    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+actionform->doon->Text;
    act->RefreshPanel();
    if( ret==-1 ) ShowMessage("I cannot create a file here!");
    delete actionform;
    return ret;
}

int CAct::CreateSymlink_my(CAct *nact)
{
    if( mode!=NORMAL ) {
        ShowMessage("You can not create a symlink here!");
        return 0;
    }
// Check that the user do something on the .. (parent dir)
    if( CheckDP(act->active->Row)==1 ) {
        Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
        return -1;
    }
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Create symlink";
    actionform->doon->Text=act->dirloc->Text+act->panel[act->active->Row].Name;
    actionform->mess1->Caption="Original file";
    actionform->mess2->Caption="Symlink name";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=true;
    actionform->doon2->Text=nact->dirloc->Text+act->panel[act->active->Row].Name;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    if( symlink(String(actionform->doon->Text).c_str(),String(actionform->doon2->Text).c_str())!=0 ) {
        ShowMessage("Symlink creation failed!");
        return -1;
    }

    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=actionform->doon->Text;
    RefreshPanel();
    delete actionform;
    return 0;
}


int CAct::EditSymlink_my(CAct *nact)
{
    if( mode!=NORMAL && mode!=SEARCH ) {
        ShowMessage("You can not edit symlink here!");
        return 0;
    }
// Check that the user do something on the .. (parent dir)
    if( CheckDP(act->active->Row)==1 ) {
        Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
        return -1;
    }
    if( act->panel[act->active->Row].Link=="" ) return 0;
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Modify symlink";
    actionform->doon->Text=act->panel[act->active->Row].Link;
    actionform->mess1->Caption="New linktarget";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    if( actionform->doon->Text=="" ) return 0;
    if( mode==SEARCH ) {
        DeleteFile(String(act->panel[act->active->Row].Name).c_str());
        if( symlink(String(actionform->doon->Text).c_str(),String(act->panel[act->active->Row].Name).c_str())!=0 ) {
            ShowMessage("Symlink creation failed!");
            return -1;
        }
    } else {
        DeleteFile(String(act->dirloc->Text+act->panel[act->active->Row].Name).c_str());
        if( symlink(String(actionform->doon->Text).c_str(),String(act->dirloc->Text+act->panel[act->active->Row].Name).c_str())!=0 ) {
            ShowMessage("Symlink creation failed!");
            return -1;
        }
    }
    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::Copy_Arch(CAct *nact)
{
    if( def_pac!=-1 || nact->def_pac!=-1 ) {
        if( mode==ARCH ) {
            if( Form1->pacs[def_pac].copyout ) {
                if( nact->mode==NORMAL )
                    return Copy_FromArch(nact);
                else return 0;
            } else {
                ShowMessage("There are no copyout definition for this archive!");
                return 0;
            }
        } else if( nact->mode==ARCH ) {
            if( Form1->pacs[nact->def_pac].copyin ) {
                if( mode==NORMAL )
                   return Copy_ToArch(nact);
                else
                    return 0;
            }else {
                ShowMessage("There are no copyin definition for this archive!");
                return 0;
            }
        } else
        ShowMessage("There are no panel in an archive file!");

    }

    ShowMessage("You are not in an archive file!");
    return -1;
}
//---------------------------------------------------------------------------
int CAct::Copy_FromArch(CAct *nact)
{
// show the copy form for check the what the user want
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Copy from an archive file";
    actionform->doon->Text=nact->dirloc->Text;
    actionform->mess1->Caption="CopyToDir";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=true;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    allproceed_err=false;

    CheckSelected();

    ProgressForm->Caption="Copy from archive";
    ProgressForm->Show();
    ProgressForm->ProgressBar2->Max=act->active->RowCount*10;
    ProgressForm->ProgressBar2->Position=0;

// check for selected files
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( CheckDP(i)==1 ) {
            Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
            continue;
        }
        if( act->panel[i].Mask[1]=='d' ) {
            MkDir(String(actionform->doon->Text+act->panel[i].Name));
            FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/pack").c_str(),"r");
            if( !f ) {
                ShowMessage("Can not read the archive file!");
                return 0;
            }
            char string[400];
            do {
                fgets(string, 400, f);
                AnsiString line=Trim(AnsiString(string));
                if( !feof(f) && line[1]!='d' ) {
                    AnsiString rights;
                    AnsiString param;
                    AnsiString pathnev;
                    AnsiString size;
                    TForm1::AnsiSplit(line,":",rights,param);
                    TForm1::AnsiSplit(param,":",size,pathnev);
                    AnsiString plusz;
                    if( !Form1->pacs[def_pac].dir ) {
                        if( pathnev.Pos("./")==1 ) {
                            pathnev=pathnev.SubString(3,pathnev.Length()-2);
                            plusz="./";
                        }
                        if( pathnev[1]=='/' ) {
                            pathnev=pathnev.SubString(2,pathnev.Length()-1);
                            plusz="/";
                        }
                    }
                    if((pathnev.Pos(archdir+String(act->panel[i].Name)+"/")==1)) {
                        AnsiString name;
                        AnsiString path;

                        path=pathnev;
                        if( pathnev[pathnev.Length()]=='/' )
                            pathnev=pathnev.SubString(1,pathnev.Length()-1);
                        if( path.Pos("/")>0 ) {
                            while( path[path.Length()]!='/' )
                                path=path.SubString(1,path.Length()-1);
                            name=pathnev.SubString(path.Length()+1,pathnev.Length()-1);
                        } else {
                            name=pathnev;
                            path="";
                        }

                        int len=String(archdir+act->panel[i].Name).Length();
                        if( path!="" )
                            MkDirLong_my(String(actionform->doon->Text+act->panel[i].Name)+"/",path.SubString(len+2,path.Length()-len));
                        ProgressForm->Label2->Caption="Copy this: "+name;
                        Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" copyout \""+String(act->dirloc->Text)+"\" \""+path+name+"\" \""+String(actionform->doon->Text+act->panel[i].Name)+"/"+path.SubString(len+2,path.Length()-len)+name+"\"",false,true);
                        if( actionform->presattr->Checked )
                            ChmodFile_my(String(actionform->doon->Text+act->panel[i].Name)+"/"+path.SubString(len+2,path.Length()-len)+name,rights,TForm1::StrToChmod(rights));
                    }
                }
            } while ( !feof(f) );
            fclose(f);
        } else {
            ProgressForm->Label2->Caption="Copy this: "+act->panel[i].Name;
            Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" copyout \""+String(act->dirloc->Text)+"\" \""+String(act->panel[i].Link+act->panel[i].Name)+"\" \""+String(actionform->doon->Text+act->panel[i].Name)+"\"",false,true);
            if( actionform->presattr->Checked )
                ChmodFile_my(String(actionform->doon->Text+act->panel[i].Name),String(act->panel[i].Mask),TForm1::StrToChmod(String(act->panel[i].Mask)));
        }
        ProgressForm->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) break;
    }
    ProgressForm->Close();

    nact->prevdir="";
    nact->RefreshPanel();
    Form1->pacs[act->def_pac].listed=false;
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}
//---------------------------------------------------------------------------
int CAct::Copy_ToArch(CAct *nact)
{
// show the copy form for check the what the user want
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Copy to an archive file";
    actionform->doon->Text=nact->dirloc->Text;
    actionform->mess1->Caption="CopyToArchive";
    actionform->mess2->Caption="Filename (mask)";
    actionform->doon2->Enabled=true;
    actionform->doon2->Text="*";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    CheckSelected();

    ProgressForm->Caption="Copy to archive";
    ProgressForm->Show();
    ProgressForm->ProgressBar2->Max=selected;
    ProgressForm->ProgressBar2->Position=0;

// check for selected files
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( CheckDP(i)==1 ) {
            Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
            continue;
        }
// the real copy
// copy only a file
        ProgressForm->Label2->Caption="Copy this: "+act->panel[i].Name;

        Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" copyin \""+String(nact->dirloc->Text)+"\" \""+archdir+TForm1::GetStringByMask(String(act->panel[i].Name),String(actionform->doon2->Text))+"\" \""+String(act->dirloc->Text+act->panel[i].Name)+"\"",false,true);

        ProgressForm->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) break;
    }
    ProgressForm->Close();

    Form1->pacs[nact->def_pac].listed=false;
    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}
//---------------------------------------------------------------------------

int CAct::MkDirLong_my(AnsiString ide, AnsiString ezt)
{
    AnsiString mnemo;
    AnsiString param=ezt;
    while( param.Pos("/")>0 ) {
        TForm1::AnsiSplit(param,"/",mnemo,param);
        ide=ide+mnemo+"/";
        try {
            MkDir(ide);
        }
        catch(...) {
            ShowMessage("Could not create "+ide+"!");
            return -1;
        }
    }
        try {
            MkDir(ide+param);
        }
        catch(...) {
            ShowMessage("Could not create "+param+"!");
            return -1;
        }
    return 0;
}
//---------------------------------------------------------------------------

int CAct::View_my()
{
// chech one of the panels are not NORMAL
    int i=0;
    for( i=0;i<Form1->maxthreads && Form1->viewforms[i] && !Form1->viewforms[i]->free;i++ ) {}
    if( i==Form1->maxthreads ) return 1;

    if( act->mode==FTP && act->panel[act->active->Row].Size>1000000) return 0;

    if( act->panel[act->active->Row].Type=="Directory" ) {
        if( act->mode==NORMAL )
        if( act->panel[act->active->Row].Name!=".." ) {
            act->panel[act->active->Row].Size=act->GetDirSize(String(act->dirloc->Text+act->panel[act->active->Row].Name));
            act->active->Invalidate();
        }
        return 0;
    }

    if( Form1->viewforms[i]!=NULL ) Form1->viewforms[i]=NULL;
    Form1->viewforms[i]=&TViewForm(Form1->Owner);

    if( act->mode==SEARCH ) {
        Form1->viewforms[i]->filename=String(act->panel[act->active->Row].Name);
    } else if( act->mode==NORMAL ) {
        Form1->viewforms[i]->filename=String(act->dirloc->Text+act->panel[act->active->Row].Name);
    } else if( act->mode==ARCH ) {
        Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" copyout \""+String(act->dirloc->Text)+"\" \""+String(act->panel[act->active->Row].Link+act->panel[act->active->Row].Name)+"\" \""+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/packview\"",false,true);
        Form1->viewforms[i]->filename=Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/packview";
    } else if( act->mode==FTP ) {
        if( !ftp->Get(String(Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftpview").c_str(),String(archdir+act->panel[act->active->Row].Name).c_str(),FTPLIB_BINARY,ftpbuf) )
            return CheckFtpConnection(0);
        Form1->viewforms[i]->filename=Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftpview";
    }

    Form1->viewforms[i]->filesize=act->panel[act->active->Row].Size;
    if( Form1->extviewer=="" ) {
        Form1->viewforms[i]->Show();
    } else {
        Form1->viewforms[i]->free=true;
        Form1->ExecCmd(Form1->extviewer+" \""+AnsiString(Form1->viewforms[i]->filename)+"\"");
    }

    return 0;
}

int CAct::ChmodDir_my(AnsiString SrcDir,AnsiString ChmodDir, AnsiString maskfile, AnsiString maskdir,bool symlinks, int owner_stat)
{
// check the new dir is readable
    ChmodFile_my(SrcDir+ChmodDir,maskdir,owner_stat);
    if( !ProgressForm->dirent->SetLocation(SrcDir+ChmodDir+"/") ) return 1;

    for( int i=0;i<ProgressForm->dirent->Count();i++ ) if( ProgressForm->dirent->filelist[i].name!=".." ) {
        if( !symlinks && ProgressForm->dirent->filelist[i].link!="" ) {
            ChmodFile_my(SrcDir+ChmodDir+"/"+ProgressForm->dirent->filelist[i].name,maskfile,ProgressForm->dirent->filelist[i].attr);
// chmod symlink
        } else
        if( ProgressForm->dirent->filelist[i].mask[1]=='d' ) {
            ChmodDir_my(SrcDir+ChmodDir+"/",ProgressForm->dirent->filelist[i].name,maskfile,maskdir,symlinks,ProgressForm->dirent->filelist[i].attr);
            ProgressForm->dirent->SetLocation(SrcDir+ChmodDir+"/");
        } else {
            ChmodFile_my(SrcDir+ChmodDir+"/"+ProgressForm->dirent->filelist[i].name,maskfile,ProgressForm->dirent->filelist[i].attr);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------

int CAct::ChmodFile_my(AnsiString path, AnsiString mask, int old_stat)
{
    int stat=TForm1::StrToChmod(mask,old_stat);
    if( chmod(String(path).c_str(),stat)!=0 ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Could not change permission!","Error Changing Perm.","Ignore All","Ignore");
        if( 1==ret )
            allproceed_err=true;
        return -1;
    }
    return 0;
}

int CAct::Chmod_my(CAct *nact)
{
    if( mode!=NORMAL && mode!=SEARCH ) {
        ShowMessage("It has not implemented, yet!");
        return -1;
    }

// show the form
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Chmod";
    actionform->doon->Text=act->panel[act->active->Row].Mask.SubString(2,act->panel[act->active->Row].Mask.Length()-1);
    actionform->mess1->Caption="For files";
    actionform->mess2->Caption="For directories";
    actionform->status=0;
    actionform->symlinks->Enabled=true;
    actionform->recursive->Enabled=true;
    actionform->doon2->Enabled=true;
    if( act->panel[act->active->Row].Type=="Directory" )
        actionform->doon2->Text=act->panel[act->active->Row].Mask.SubString(2,act->panel[act->active->Row].Mask.Length()-1);
    else
        actionform->doon2->Text="---rwxr-xr-x";
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// chmod canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    allproceed_err=false;

    CheckSelected();

// check for selected files
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( CheckDP(i)==1 ) {
            Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
            continue;
        }
// the real chmod
        if( !actionform->symlinks->Checked && act->panel[i].Link!="" ) {
            if( mode==SEARCH )
                 ChmodFile_my(String(act->panel[i].Name),String(actionform->doon->Text),act->panel[i].stat);
            else
                 ChmodFile_my(String(act->dirloc->Text+act->panel[i].Name),String(actionform->doon->Text),act->panel[i].stat);
// chmod symlink
        } else if( act->panel[i].Type!="Directory" ) {
// chmod only a file
            if( mode==SEARCH )
                ChmodFile_my(String(act->panel[i].Name),String(actionform->doon->Text),act->panel[i].stat);
            else
                ChmodFile_my(String(act->dirloc->Text+act->panel[i].Name),String(actionform->doon->Text),act->panel[i].stat);
        } else {
// chmod a directory
            if( actionform->recursive->Checked )
                ChmodDir_my(String(act->dirloc->Text),String(act->panel[i].Name),String(actionform->doon->Text),String(actionform->doon2->Text),actionform->symlinks->Checked,act->panel[i].stat);
            else
                ChmodFile_my(String(act->dirloc->Text+act->panel[i].Name),String(actionform->doon2->Text),act->panel[i].stat);
        }
    }

    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::ChownDir_my(AnsiString SrcDir,AnsiString ChownDir, int powner, int pgroup,bool symlinks)
{
// check the new dir is readable
    ChownFile_my(SrcDir+ChownDir,powner,pgroup);
    if( !ProgressForm->dirent->SetLocation(SrcDir+ChownDir+"/") ) return 1;

    for( int i=0;i<ProgressForm->dirent->Count();i++ ) if( ProgressForm->dirent->filelist[i].name!=".." ) {
        if( !symlinks && ProgressForm->dirent->filelist[i].link!="" ) {
            ChownFile_my(SrcDir+ChownDir+"/"+String(ProgressForm->dirent->filelist[i].name).c_str(),powner,pgroup);
// chownd symlink
        } else
        if( ProgressForm->dirent->filelist[i].mask[1]=='d' ) {
            ChownDir_my(SrcDir+ChownDir+"/",String(ProgressForm->dirent->filelist[i].name),powner,pgroup,symlinks);
            ProgressForm->dirent->SetLocation(SrcDir+ChownDir+"/");
        } else {
            ChownFile_my(SrcDir+ChownDir+"/"+String(ProgressForm->dirent->filelist[i].name).c_str(),powner,pgroup);
        }
    }
    return 0;
}

int CAct::ChownFile_my(AnsiString path, int powner, int pgroup)
{
    if( chown(String(path).c_str(),powner,pgroup)!=0 ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Could not change owner/group!","Error Changing owner","Ignore All","Ignore");
        if( 1==ret )
            allproceed_err=true;
        return -1;
    }
    return 0;
}

int CAct::Chown_my(CAct *nact)
{
    if( mode!=NORMAL && mode!=SEARCH ) {
        ShowMessage("It has not implemented, yet!");
        return -1;
    }
    if( act->panel[act->active->Row].Name==".." )
        return -1;

// show the form
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Chown";
    actionform->doon->Text=IntToStr(act->panel[act->active->Row].uid)+":"+IntToStr(act->panel[act->active->Row].gid);
    actionform->mess1->Caption="owner:group";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=true;
    actionform->recursive->Enabled=true;
    actionform->doon2->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    allproceed_err=false;

    if( actionform->doon->Text.Pos(":")<1 ) return -1;
    int newuid=0;
    int newgid=0;
try {
    newuid=StrToInt(String(actionform->doon->Text).SubString(1,String(actionform->doon->Text).Pos(":")-1));
    newgid=StrToInt(String(actionform->doon->Text).SubString(String(actionform->doon->Text).Pos(":")+1,String(actionform->doon->Text).Length()-String(actionform->doon->Text).Pos(":")));
}
catch(...) {
    ShowMessage("!!! Wrong format! You must use numbers separate with : !!!");
    return 2;
}
    CheckSelected();

// check for selected files
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( CheckDP(i)==1 ) {
            Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
            continue;
        }
// the real chown
        if( !actionform->symlinks->Checked && act->panel[i].Link!="" ) {
            if( mode==SEARCH )
                 ChownFile_my(String(act->panel[i].Name),newuid,newgid);
            else
                 ChownFile_my(String(act->dirloc->Text+act->panel[i].Name),newuid,newgid);
// chown symlink
        } else if( act->panel[i].Type!="Directory" ) {
// chown only a file
            if( mode==SEARCH )
                ChownFile_my(String(act->panel[i].Name),newuid,newgid);
            else
                ChownFile_my(String(act->dirloc->Text+act->panel[i].Name),newuid,newgid);
        } else {
// chmod a directory
            if( actionform->recursive->Checked )
                ChownDir_my(String(act->dirloc->Text),String(act->panel[i].Name),newuid,newgid,actionform->symlinks->Checked);
            else
                ChownFile_my(String(act->dirloc->Text+act->panel[i].Name),newuid,newgid);
        }
    }

    nact->prevdir="";
    if( act->dirloc->Text==nact->dirloc->Text )
        nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::SelectMask()
{
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Selection by mask";
    actionform->doon->Text="*";
    actionform->mess1->Caption="Mask";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// selection canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    for( int i=1;i<act->active->RowCount;i++ )
        if( Form1->FitOnMask(String(act->panel[i].Name),String(actionform->doon->Text)) ) {
        if( !act->panel[i].Selected ) {
            selected++;
            selected_bytes+=act->panel[i].Size;
            act->panel[i].Selected=true;
        } else {
            selected--;
            selected_bytes-=act->panel[i].Size;
            act->panel[i].Selected=false;
        }
    }
    act->active->Invalidate();
    RefreshSelBar();
    delete actionform;
    return 0;
}

void CAct::SelectNone()
{
    for( int i=1;i<act->active->RowCount;i++ )
        if( act->panel[i].Selected ) {
            selected--;
            selected_bytes-=act->panel[i].Size;
            act->panel[i].Selected=false;
        }
    act->active->Invalidate();
    RefreshSelBar();
}

void CAct::SelectNNone()
{
    for( int i=1;i<act->active->RowCount;i++ )
        if( !act->panel[i].Selected ) {
            selected++;
            selected_bytes+=act->panel[i].Size;
            act->panel[i].Selected=true;
        }
    act->active->Invalidate();
    RefreshSelBar();
}


int CAct::FindDir(AnsiString Dir,AnsiString File,AnsiString filemask,AnsiString contentmask, bool recursive)
{
// check the new dir is readable
    if( !ProgressForm->dirent->SetLocation(Dir+File+"/") ) return 1;
    ProgressForm->ProgressBar1->Max=ProgressForm->dirent->Count();
    ProgressForm->ProgressBar1->Position=0;
    ProgressForm->Label1->Caption="Find in here: "+Dir;

    for( int i=0;i<ProgressForm->dirent->Count();i++ ) if( ProgressForm->dirent->filelist[i].name!=".." ) {
        if( ProgressForm->dirent->filelist[i].mask[1]=='d' ) {
            if( recursive ) {
                FindDir(Dir+File+"/",String(ProgressForm->dirent->filelist[i].name),filemask,contentmask,recursive);
                ProgressForm->dirent->SetLocation(Dir+File+"/");
            }
        } else
            if( Form1->FitOnMask(String(ProgressForm->dirent->filelist[i].name),filemask) && (contentmask=="" || contentmask=="**" || FindInFile(String(ProgressForm->dirent->Location()+ProgressForm->dirent->filelist[i].name),contentmask,ProgressForm->dirent->filelist[i].size)) ) {
                newsearch->next=new CSearch();
                newsearch=newsearch->next;
                newsearch->dir=String(ProgressForm->dirent->Location());
                newsearch->num=i;
                newsearch->next=NULL;
                if( !search ) search=newsearch;
                search_num++;
            }
        ProgressForm->ProgressBar1->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) return 1;
    }
    return 0;
}

int CAct::FindFile_my()
{
    if( mode!=NORMAL ) return 0;

    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Find File";
    actionform->doon->Text="";
    actionform->doon2->Text="";
    actionform->mess1->Caption="Filename(mask)";
    actionform->mess2->Caption="Content (mask)";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=true;
    actionform->recursive->Enabled=true;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// selection canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    mode=SEARCH;
    SelectNone();
    ClearSearch();
    newsearch=new CSearch();


    ProgressForm->Caption="Find file";
    ProgressForm->Show();
    ProgressForm->ProgressBar2->Max=act->active->RowCount;
    ProgressForm->ProgressBar2->Position=0;

    FindDir(String(act->dirloc->Text).SubString(1,act->dirloc->Text.Length()-1),"",String(actionform->doon->Text),"*"+String(actionform->doon2->Text)+"*",actionform->recursive->Checked);

    ProgressForm->Close();

    RefreshPanel();
    delete actionform;
    return 0;
}

bool CAct::FindInFile(AnsiString filename,AnsiString mask,__int64 size)
{
    FILE *file;
    __int64 lastst=0;
    __int64 lastst2=0;
    int mn=1;
    char ch;
    __int64 herestream=0;
    __int64 starthere=herestream;
    bool found=false;

    file=fopen64((filename).c_str(),"r");
    if( !file ) return found;

    ProgressForm->ProgressBar3->Max=size;
    ProgressForm->ProgressBar3->Position=0;
    ProgressForm->Label3->Caption="Current file: "+filename;
    int readspeed=0;
    unsigned short h;
    unsigned short m;
    unsigned short ps;
    unsigned short s;
    unsigned short ms;
    GetTime().DecodeTime(&h,&m,&ps,&ms);

    while( !feof(file) && mn<=mask.Length() ) {
        Application->ProcessMessages();
        if( ProgressForm->cancel ) {
            fclose(file);
            return false;
        }

        fseek(file,herestream,SEEK_SET);
        ch=fgetc(file);
        readspeed+=1;
        ProgressForm->ProgressBar3->StepIt();
        GetTime().DecodeTime(&h,&m,&s,&ms);
        if( s!=ps ) {
            GetTime().DecodeTime(&h,&m,&ps,&ms);
            ProgressForm->speed->Caption=" Speed: "+IntToStr(readspeed/1024)+" Kbyte/sec";
            readspeed=0;
            ProgressForm->Invalidate();
        }

        if( mask[mn]=='*' ) {
            lastst=mn;
            lastst2=herestream;
            if( mn<mask.Length() ) {
                mn++;
                continue;
            } else {
                found=true;
                break;
            }
        }

        if( ch=='\n' ) {
            ch=' ';
        }
        if( Form1->ignorecase ) {
            if( ch>='A' && ch<='Z' ) ch+=32;
            if( mask[mn]>='A' && mask[mn]<='Z' ) mask[mn]+=32;
        }
        if( ch==mask[mn] || mask[mn]=='?' ) {
            mn++;
            if( mn>mask.Length() )
                if( feof(file) ) {
                    found=true;
                    break;
                } else
                    if( lastst==0 ) {
                        found=false;
                        break;
                    } else {
                        mn=lastst;
                        herestream=lastst2++;
                    }
        } else {
            if( lastst==0 ) {
                found=false;
                break;
            } else {
                mn=lastst;
                herestream=lastst2++;
            }
        }
        herestream++;
    }

    fclose(file);
    return found;
}

void CAct::CheckUpDp(int &row)
{
    for( int i=0;i<active->RowCount;i++ )
    if( panel[i].Name==".." ) {
        my_file ddfile=panel[i];
        for( int j=i;j>0;j-- )
            panel[j]=panel[j-1];
        panel[0]=ddfile;
        if( panel[0].Focused ) row=0; else
        if( panel[i].Focused ) row=i;
        break;
    }
}

void CAct::ShowAllDirectorySize()
{
    for( int i=0;i<act->active->RowCount;i++ )
        if( act->panel[i].Type=="Directory" && act->panel[i].Name!=".." ) {
            act->panel[i].Size=GetDirSize(String(act->dirloc->Text+act->panel[i].Name));
        }
    act->active->Invalidate();
}

int CAct::Delete_FromArch()
{
    if( mode!=ARCH || !Form1->pacs[def_pac].rm ) return 1;

// show the copy form for check the what the user want
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Delete from an archive file";
    actionform->doon->Text="Do you want to delete from"+act->dirloc->Text+"?";
    actionform->mess1->Caption="";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    CheckSelected();

// check for selected files
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( CheckDP(i)==1 ) {
            Form1->StatusBar1->SimpleText="You cannot do this on the .. directory!";
            continue;
        }
// the real copy
        Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" rm \""+String(act->dirloc->Text)+"\" \""+String(act->panel[i].Link+act->panel[i].Name)+"\"",false,true);
    }

    Form1->pacs[act->def_pac].listed=false;
    if( act->active->Row+1<act->active->RowCount )
        act->prevdir=act->dirloc->Text+act->panel[act->active->Row+1].Name;
    else
        act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::NewFtpConnection()
{
// show the copy form for check the what the user want
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Connect to an ftp server";
    actionform->doon->Text=servername;
    actionform->mess1->Caption="Server[:Port]";
    actionform->mess2->Caption="User/Pass";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=true;
    actionform->doon2->Text=prevuserpass;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {
        if( mode==FTP ) {
            act->prevdir="/..";
            act->dirloc->Text="/";
            mode=NORMAL;
            RefreshPanel();
        }
        if( actionform ) delete actionform;
        actionform=NULL;
        return 2;
    }
    servername=String(actionform->doon->Text);
    AnsiString line=String(actionform->doon2->Text);
    prevuserpass=line;
    if( line.Pos("/")<=0 ) return 1;
    AnsiString uname;
    AnsiString pass;
    TForm1::AnsiSplit(line,"/",uname,pass);


    if( ftp ) {
        delete ftp;ftp=NULL;
    }
    if( ftpbuf ) {delete ftpbuf;ftpbuf=NULL;}
    ftp=new CMyFtp();
    if( servername.Pos("/")>1 ) {
        TForm1::AnsiSplit(servername,"/",servername,archdir);
        archdir="/"+archdir;
    } else
        archdir="/";
    if( !ftp->Connect(servername.c_str(),&ftpbuf) ) {
        ShowMessage("FTP connection failed: "+servername);
        return 1;
    }
    if( !ftp->Login(uname.c_str(),pass.c_str(),ftpbuf) ) {
        ShowMessage("FTP login failed: "+uname+"/"+pass);
        return 1;
    }
    mode=FTP;
    act->dirloc->Text="ftp://"+servername+archdir;
    RefreshPanel();
    if( actionform ) delete actionform;
    actionform=NULL;
    return 0;
}
//---------------------------------------------------------------------------

int CAct::ftp_reread(AnsiString dir)
{
    int arch_count=0;
        if( !ftp->Dir(String(Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp").c_str(),dir.c_str(),ftpbuf) )
            return 0;
        Form1->ExecCmd(Form1->packageprefix+"uftp \""+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp\" >"+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2",false,true);
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the ftp2 file!");
            return 0;
        }
        char string[400];
        do {
            fgets(string, 400, f);
            AnsiString line=Trim(AnsiString(string));
            if( !feof(f) ) {
                arch_count++;
            }
        } while ( !feof(f) );
        fclose(f);
        return arch_count+1;
}

bool CAct::ftp_getname(AnsiString dir,int pi,int count,AnsiString *pname,__int64 *psize,AnsiString *pattr)
{
    if( pi==0 ) {
        *pname="..";
        *psize=0;
        return true;
    }
    int arch_count=count;
    if( arch_count==0 )
        arch_count=ftp_reread(dir);
// refresh panel with ftp element
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the ftp2 file 2!");
            return 0;
        }
        char cline[400];
        int i=1;
        fgets(cline, 400, f);
        while ( i<=arch_count ) {
            AnsiString line=Trim(AnsiString(cline));
            AnsiString rights;
            AnsiString param;
            AnsiString name;
            AnsiString size;
            TForm1::AnsiSplit(line,":",rights,param);
            TForm1::AnsiSplit(param,":",size,name);
            if( pi==i ) {
                fclose(f);
                *pname=name;
                *pattr=rights;
                try {
                    *psize=StrToInt64(size);
                }
                catch(...) {
                    int len=size.Length();
                    AnsiString size1=size.SubString(1,len-5);
                    AnsiString size2=size.SubString(len-4,5);
                    *psize=(__int64(StrToInt(size1))*100000)+StrToInt(size2);
                }
                return true;
            }
            i++;
            fgets(cline, 400, f);
        }
        fclose(f);

    return false;
}

bool CAct::ftp_isdir(AnsiString dir,int pi,int count)
{
    if( pi==0 ) return true;
    int arch_count=count;
    if( arch_count==0 )
        arch_count=ftp_reread(dir);
// refresh panel with ftp element
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftp2").c_str(),"r");
        if( !f ) {
            ShowMessage("Can not read the ftp2 file 2!");
            return 0;
        }
        char cline[400];
        int i=1;
        fgets(cline, 400, f);
        while ( i<=arch_count ) {
            AnsiString line=Trim(AnsiString(cline));
            AnsiString rights;
            AnsiString param;
            AnsiString name;
            AnsiString size;
            TForm1::AnsiSplit(line,":",rights,param);
            TForm1::AnsiSplit(param,":",size,name);
            if( i==pi )
                if( rights[1]=='d' ) {
                    fclose(f);
                    return true;
                } else {
                    fclose(f);
                    return false;
                }
            i++;
            fgets(cline, 400, f);
        }
        fclose(f);

    return false;
}

int CAct::MkDir_my_Ftp()
{
// chech one of the panels are not NORMAL
    if( mode!=FTP ) {
        ShowMessage("How can you be here?");
        return 1;
    }
    if( !CheckFtpConnection() ) return 1;
// create directory on act->panel
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Create Directory on the ftp server";
    actionform->doon->Text="";
    actionform->mess1->Caption="Directory name";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// directory creation canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    if( actionform->doon->Text!="" ) {
        act->prevdir=act->dirloc->Text+actionform->doon->Text;
        if( !ftp->Mkdir(String(archdir+actionform->doon->Text).c_str(),ftpbuf) ) {
            ShowMessage("Could not create "+actionform->doon->Text+"!");
            return -1;
        }
    }
    act->prevdir=act->dirloc->Text+actionform->doon->Text;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::Copy_Ftp(CAct *nact)
{
    if( mode==FTP ) {
        if( nact->mode==NORMAL )
            return Copy_FromFtp(nact);
        else {
            ShowMessage("Copy only to normal from ftp!");
            return 0;
        }
    } else {
        if( mode==NORMAL )
            return Copy_ToFtp(nact);
        else {
            ShowMessage("Copy only from normal to ftp!");
            return 0;
        }
    }

    ShowMessage("You have no ftp connection!");
    return -1;
}

// copy a whole directory
int CAct::CopyDir_FromFtp(AnsiString SrcDir,AnsiString CpDirFrom,AnsiString DstDir,AnsiString CpDirTo, bool presattr, AnsiString attr)
{
    int count=ftp_reread(SrcDir+CpDirFrom);
    ProgressForm->ProgressBar1->Max=count;
    ProgressForm->ProgressBar1->Position=0;
    ProgressForm->Label1->Caption="Copy this: "+CpDirFrom;

    try {
        MkDir(DstDir+CpDirTo);
    }
    catch(...) {
// ---MJ---
        ShowMessage("Error creating "+CpDirTo+" while copying!");
        return 1;
    }
    for( int i=1;i<count;i++ ) {
      AnsiString name;
      __int64 size=0;
      AnsiString pattr;
      ftp_getname(SrcDir+CpDirFrom,i,count,&name,&size,&pattr);
      if( name!=".." ) {
        if( ftp_isdir(SrcDir+CpDirFrom,i,count) ) {
            CopyDir_FromFtp(SrcDir+CpDirFrom+"/",name,DstDir+CpDirTo+"/",name,presattr,pattr);
            count=ftp_reread(SrcDir+CpDirFrom);
        } else
            CopyFile_FromFtp(SrcDir+CpDirFrom+"/"+name,DstDir+CpDirTo+"/"+name,size,presattr,pattr);
        ProgressForm->ProgressBar1->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel )
            return 1;
      }
    }
    if( presattr )ChmodFile_my(DstDir+CpDirTo,attr,0);
    return 0;
}
//---------------------------------------------------------------------------

// copy only one file
int CAct::CopyFile_FromFtp(AnsiString Src,AnsiString Dst,__int64 size, bool presattr, AnsiString attr)
{
    if( FileExists(Dst) ) {
        int ret=1;
        if( !allproceed ) ret=TForm1::MessageDlg_my("The destination file "+Dst+" exists. Overwrite it?","Warning Creating File","Overwrite All","No","Cancel op.","Overwrite");
        if( 1==ret )
            allproceed=true;
        if( 3==ret ) {
            ProgressForm->cancel=true;
            return 1;
        }
        if( 2==ret )
            return 1;
    }

    if( ftp->Get(Dst.c_str(),Src.c_str(),FTPLIB_BINARY,ftpbuf,size,ProgressForm) ) {
        if( presattr )
            ChmodFile_my(Dst,attr,0);
        return 0;
    } else {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while copying file "+Dst+"!","Error Copy File (FTP)","Ignore All","Ignore","Cancel copy");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            ProgressForm->cancel=true;
        return 1;
    }
}
//---------------------------------------------------------------------------

int CAct::Copy_FromFtp(CAct *nact)
{
    if( !CheckFtpConnection() ) return 1;

    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Copy from ftp";
    actionform->doon->Text=nact->dirloc->Text;
    actionform->mess1->Caption="Copytodir";
    actionform->mess2->Caption="Filemask";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=true;
    actionform->doon2->Text="*";
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=true;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    allproceed_err=false;
    CheckSelected();

// check for selected files
    ProgressForm->Caption="Copy from FTP";
    ProgressForm->Show();
    ProgressForm->ProgressBar2->Max=selected;
    ProgressForm->ProgressBar2->Position=0;
    allproceed=false;
    allproceed_err=false;

    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
// Check that the user do something on the .. (parent dir)
        if( act->panel[i].Name==".." ) {
            continue;
        }
        ProgressForm->Label2->Caption="Copy this: "+act->panel[i].Name;
// the real copy
        if( act->panel[i].Type!="Directory" ) {
// copy only a file
            CopyFile_FromFtp(String(archdir+act->panel[i].Name),String(actionform->doon->Text)+TForm1::GetStringByMask(String(act->panel[i].Name),String(actionform->doon2->Text)),act->panel[i].Size,actionform->presattr->Checked,TForm1::StrToChmod(String(act->panel[i].Mask)));
        } else {
// copy a directory
            CopyDir_FromFtp(String(archdir),String(act->panel[i].Name),String(actionform->doon->Text),TForm1::GetStringByMask(String(act->panel[i].Name),String(actionform->doon2->Text)),actionform->presattr->Checked,TForm1::StrToChmod(String(act->panel[i].Mask)));
        }
        ProgressForm->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) {
            act->dirloc->Text="/valami";
            if( ftp ) {delete ftp;ftp=NULL;}
            mode=NORMAL;
            break;
        }
    }
    ProgressForm->Close();
    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}

// copy a whole directory
int CAct::CopyDir_ToFtp(AnsiString SrcDir,AnsiString CpDirFrom,AnsiString DstDir,AnsiString CpDirTo,CAct* nact)
{
// check the new dir is readable
    if( !ProgressForm->dirent->SetLocation(SrcDir+CpDirFrom+"/") ) return 1;

    ProgressForm->ProgressBar1->Max=ProgressForm->dirent->Count();
    ProgressForm->ProgressBar1->Position=0;
    ProgressForm->Label1->Caption="Copy this: "+CpDirFrom;
    if( !nact->ftp->Mkdir(String(DstDir+CpDirTo).c_str(),nact->ftpbuf) ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Cannot create a dir on the ftp server!","Error Create Dir. (FTP)","Ignore All","Ignore","Cancel");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            ProgressForm->cancel=true;
        return 1;
    }

    for( int i=0;i<ProgressForm->dirent->Count();i++ ) if( ProgressForm->dirent->filelist[i].name!=".." ) {
        if( ProgressForm->dirent->filelist[i].mask[1]=='d' && ProgressForm->dirent->filelist[i].link=="" ) {
            CopyDir_ToFtp(SrcDir+CpDirFrom+"/",String(ProgressForm->dirent->filelist[i].name),DstDir+CpDirTo+"/",String(ProgressForm->dirent->filelist[i].name),nact);
            ProgressForm->dirent->SetLocation(SrcDir+CpDirFrom+"/");
        } else
            CopyFile_ToFtp(SrcDir+CpDirFrom+"/"+String(ProgressForm->dirent->filelist[i].name).c_str(),DstDir+CpDirTo+"/"+String(ProgressForm->dirent->filelist[i].name).c_str(),ProgressForm->dirent->filelist[i].size,nact);
        ProgressForm->ProgressBar1->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------

// copy only one file
int CAct::CopyFile_ToFtp(AnsiString Src,AnsiString Dst, __int64 size,CAct* nact)
{
    if( nact->ftp->Put(Src.c_str(),Dst.c_str(),FTPLIB_BINARY,nact->ftpbuf,size,size,ProgressForm) ) {
        return 0;
    } else {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while copying file "+Dst+"!","Error Copy File (FTP)","Ignore All","Ignore","Cancel");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            ProgressForm->cancel=true;
        return 1;
    }
}
//---------------------------------------------------------------------------

int CAct::Copy_ToFtp(CAct *nact)
{
    if( !nact->CheckFtpConnection() ) return 1;
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Copy to ftp";
    actionform->doon->Text=nact->archdir;
    actionform->mess1->Caption="Copytodir";
    actionform->mess2->Caption="Filemask";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=true;
    actionform->doon2->Text="*";
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=true;
    actionform->ShowModal();
// copy canceled
    if( actionform->status==2 ) {delete actionform; return 2;}
    allproceed_err=false;

    CheckSelected();

// check for selected files
    ProgressForm->Caption="Copy to FTP";
    ProgressForm->Show();
    ProgressForm->ProgressBar2->Max=selected;
    ProgressForm->ProgressBar2->Position=0;

    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;

// Check that the user do something on the .. (parent dir)
        if( act->panel[i].Name==".." ) {
            continue;
        }
        ProgressForm->Label2->Caption="Copy this: "+act->panel[i].Name;
// the real copy
        if( act->panel[i].Type!="Directory" ) {
// copy only a file
            CopyFile_ToFtp(String(act->dirloc->Text+act->panel[i].Name),String(actionform->doon->Text)+TForm1::GetStringByMask(String(act->panel[i].Name),String(actionform->doon2->Text)),act->panel[i].Size,nact);
        } else {
// copy a directory
            CopyDir_ToFtp(String(act->dirloc->Text),String(act->panel[i].Name),String(actionform->doon->Text),TForm1::GetStringByMask(String(act->panel[i].Name),String(actionform->doon2->Text)),nact);
        }
        ProgressForm->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) {
            nact->dirloc->Text="/valami";
            if( nact->ftp ) {delete nact->ftp;nact->ftp=NULL;}
            nact->mode=NORMAL;
            break;
        }
    }
    ProgressForm->Close();
    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    delete actionform;
    return 0;
}

int CAct::Delete_my_Ftp()
{
    if( !CheckFtpConnection() ) return 1;

// show the delete form
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Delete from ftp server";
    actionform->doon->Text="Do you want to delete from "+archdir+"?";
    actionform->mess1->Caption="";
    actionform->mess2->Caption="";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->doon2->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->ShowModal();
// deletion canceled
    if( actionform->status==2 ) {delete actionform; return 2;}

    CheckSelected();

    ProgressForm->Caption="Delete from FTP";
    ProgressForm->Show();
    ProgressForm->ProgressBar2->Max=selected;
    ProgressForm->ProgressBar2->Position=0;

    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;

// Check that the user do something on the .. (parent dir)
        if( act->panel[i].Type=="Directory" ) {
            DeleteDir_my_Ftp(String(archdir),String(act->panel[i].Name));
        } else
            ftp->Delete(String(archdir+act->panel[i].Name).c_str(),ftpbuf);
        ProgressForm->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( ProgressForm->cancel ) break;
    }

    if( act->active->Row+1<act->active->RowCount )
        act->prevdir=act->dirloc->Text+act->panel[act->active->Row+1].Name;
    else
        act->prevdir=act->dirloc->Text+act->panel[act->active->Row].Name;
    RefreshPanel();
    ProgressForm->Close();
    delete actionform;
    return 0;
}

// copy a whole directory
int CAct::DeleteDir_my_Ftp(AnsiString SrcDir,AnsiString DelDir)
{
    int count=ftp_reread(SrcDir+DelDir);
    int here=1;
    ProgressForm->ProgressBar1->Max=count;
    ProgressForm->ProgressBar1->Position=0;
    ProgressForm->Label1->Caption="Delete this: "+DelDir;

    for( int i=1;here<count;i++ ) {
      Application->ProcessMessages();
      if( ProgressForm->cancel ) return 1;
      AnsiString name;
      __int64 size=0;
      AnsiString pattr;
      ftp_getname(SrcDir+DelDir,here,count,&name,&size,&pattr);
      if( name!=".." ) {
        if( ftp_isdir(SrcDir+DelDir,i,count) ) {
            here+=DeleteDir_my_Ftp(SrcDir+DelDir+"/",name);
            count=ftp_reread(SrcDir+DelDir);
        } else
            here+=(1-ftp->Delete(String(SrcDir+DelDir+"/"+name).c_str(),ftpbuf));
        ProgressForm->ProgressBar1->StepIt();
      }
    }
    ftp->Rmdir((SrcDir+DelDir).c_str(),ftpbuf);
    return here-1;
}

// noop=0 if you know that the connection isn't live
int CAct::CheckFtpConnection(int noop)
{
    if( noop==1 )
        noop=ftp->Noop(ftpbuf);

    if( noop==1 ) return 1;

    if( NewFtpConnection()!=0 )
        return 0;
    else
        return 1;
}

void CAct::GetFreeSpace(AnsiString *free,AnsiString *total,AnsiString *per,AnsiString *phere)
{
    if( mode==NORMAL || mode==SEARCH ) {
        Form1->ExecCmd(Form1->packageprefix+"dinfo \""+String(dirloc->Text)+"\" >"+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/dinfo",false,true);
        FILE *f=fopen((Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/dinfo").c_str(),"r");
        if( !f ) {
            *free="0";
            *total="0";
            return;
        }
        char string[400];
        fgets(string, 400, f);
        *free=Trim(AnsiString(string));
        fgets(string, 400, f);
        *total=Trim(AnsiString(string));
        fgets(string, 400, f);
        *per=Trim(AnsiString(string));
        fgets(string, 400, f);
        *phere=Trim(AnsiString(string));
        fclose(f);
    } else {
        *free="0";
        *total="0";
        *per="100%";
        *phere="";
    }
}

int CAct::cdpp()
{
        if( mode==ARCH ) {
            if( archdir!="" ) {
                archdir=archdir.SubString(1,archdir.Length()-1);
                act->prevdir=act->dirloc->Text+archdir;
                while( archdir!="" && archdir[archdir.Length()]!='/' )
                    archdir=archdir.SubString(1,archdir.Length()-1);
                RefreshPanel();
                return 1;
            } else {
                if( dirhist->IsNull() ) {
                    act->dirloc->Text=act->dirloc->Text+"/";
                    mode=NORMAL;
                } else {
                    prevdir=dirhist->GetFirst().dir+dirhist->GetFirst().archdir+ExtractFileName(String(act->dirloc->Text));
                    act->dirloc->Text=dirhist->GetFirst().dir;
                    archdir=dirhist->GetFirst().archdir;
                    mode=dirhist->GetFirst().mode;
                    def_pac=dirhist->GetFirst().def_pac;
                    dirhist->DelFirst();
                    Form1->pacs[act->def_pac].listed=false;
                    RefreshPanel();
                    return 1;
                }
            }
        }
        if( mode==FTP ) {
            if( archdir!="/" ) {
                archdir=archdir.SubString(1,archdir.Length()-1);
                act->prevdir="ftp://"+servername+archdir;
                while( archdir!="" && archdir[archdir.Length()]!='/' )
                    archdir=archdir.SubString(1,archdir.Length()-1);
                act->dirloc->Text="ftp://"+servername+archdir;
                RefreshPanel();
                return 1;
            } else {
                act->dirloc->Text="/valami";
                if( ftp ) {delete ftp;ftp=NULL;}
                if( ftpbuf ) {delete ftpbuf;ftpbuf=NULL;}
                mode=NORMAL;
            }
        }
        if( mode==SEARCH ) {
            act->dirloc->Text=act->dirloc->Text+"fakedir/"; // :)
            mode=NORMAL;
        }
        if( act->dirloc->Text=="/" ) return 1;
        act->dirloc->Text=act->dirloc->Text.SubString(1,act->dirloc->Text.Length()-1);
        act->prevdir=act->dirloc->Text;
        while( act->dirloc->Text[act->dirloc->Text.Length()]!='/' )
            act->dirloc->Text=act->dirloc->Text.SubString(1,act->dirloc->Text.Length()-1);
        try {
            ChDir(String(act->dirloc->Text));
        }
        catch(...) {
            ShowMessage("Could not change directory "+act->dirloc->Text+"!");
            return -1;
        }
        return 0;
}

void CAct::panelsort(int count,int &cursor)
{
    my_file *tmppanel=new my_file[count];
    int here=1;
    int retcur=0;

    for( int i=0;i<count;i++ ) {
        if( panel[i].Name==".." ) {
            if( cursor==i ) retcur=0;
            tmppanel[0]=panel[i];
            continue;
        }

        int j=0;
        if( dirloc->Text!="/" ) j=1;

        bool kisebb=false;

        if( sortmode==0 )
            kisebb=(tmppanel[j].Name<=panel[i].Name);
        else
        if( sortmode==1 )
            kisebb=(tmppanel[j].Size<=panel[i].Size);
        else
        if( sortmode==2 )
            kisebb=(tmppanel[j].Date<=panel[i].Date);
        if( sortdir==1 )
            kisebb=!kisebb;

        while( j<here &&
        ((tmppanel[j].Type=="Directory" && panel[i].Type!="Directory") ||
        ((tmppanel[j].Type==panel[i].Type || (tmppanel[j].Type!="Directory" && panel[i].Type!="Directory")) &&
        kisebb)) ) {
            j++;
            if( sortmode==0 )
                kisebb=(tmppanel[j].Name<=panel[i].Name);
            else
            if( sortmode==1 )
                kisebb=(tmppanel[j].Size<=panel[i].Size);
            else
            if( sortmode==2 )
                kisebb=(tmppanel[j].Date<=panel[i].Date);
            if( sortdir==1 )
                kisebb=!kisebb;

        }
        for( int k=here-1;k>=j;k-- ) {
            tmppanel[k+1]=tmppanel[k];
            if( k==retcur ) retcur++;
        }
        here++;
        if( cursor==i ) {
            retcur=j;
        }
        tmppanel[j]=panel[i];
    }

// copy back
    for( int i=0;i<count;i++ ) {
        if( retcur==i ) cursor=i;
        panel[i]=tmppanel[i];
    }
    delete []tmppanel;
}

void CAct::CloseFTPConnection()
{
    if( mode==FTP ) {
        archdir="/";
        act->dirloc->Text="/valami";
        if( ftp ) {delete ftp;ftp=NULL;}
        if( ftpbuf ) {delete ftpbuf;ftpbuf=NULL;}
        mode=NORMAL;
        act->dirloc->Text=act->dirloc->Text.SubString(1,act->dirloc->Text.Length()-1);
        act->prevdir=act->dirloc->Text;
        while( act->dirloc->Text[act->dirloc->Text.Length()]!='/' )
            act->dirloc->Text=act->dirloc->Text.SubString(1,act->dirloc->Text.Length()-1);
        RefreshPanel();
    }
}

void CAct::InternalView()
{
    int i=0;
    for( i=0;i<Form1->maxthreads && !Form1->viewforms[i]->free;i++ ) {}
    if( i==Form1->maxthreads ) return;

    if( act->mode==FTP && act->panel[act->active->Row].Size>1000000) return;

    if( act->panel[act->active->Row].Type=="Directory" ) {
        if( act->mode==NORMAL )
        if( act->panel[act->active->Row].Name!=".." ) {
            act->panel[act->active->Row].Size=act->GetDirSize(String(act->dirloc->Text+act->panel[act->active->Row].Name));
            act->active->Invalidate();
        }
        return;
    }

    if( act->mode==SEARCH ) {
        Form1->viewforms[i]->filename=String(act->panel[act->active->Row].Name);
    } else if( act->mode==NORMAL ) {
        Form1->viewforms[i]->filename=String(act->dirloc->Text+act->panel[act->active->Row].Name);
    } else if( act->mode==ARCH ) {
        Form1->ExecCmd(Form1->packageprefix+Form1->pacs[def_pac].Handle+" copyout \""+String(act->dirloc->Text)+"\" \""+String(act->panel[act->active->Row].Link+act->panel[act->active->Row].Name)+"\" \""+Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/packview\"",false,true);
        Form1->viewforms[i]->filename=Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/packview";
    } else if( act->mode==FTP ) {
        if( !ftp->Get(String(Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftpview").c_str(),String(archdir+act->panel[act->active->Row].Name).c_str(),FTPLIB_BINARY,ftpbuf) ) {
            CheckFtpConnection(0);
            return;
        }
        Form1->viewforms[i]->filename=Form1->tmppath+"fctmp"+IntToStr(Form1->uid)+"/ftpview";
    }

    Form1->viewforms[i]->filesize=act->panel[act->active->Row].Size;
    Form1->viewforms[i]->Show();
}
//---------------------------------------------------------------------------

int CAct::MultiRename(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode!=NORMAL ) {
        ShowMessage("It has not been implemented, yet!");
        return -1;
    }
    CheckSelected();
    Form1->nowrefresh=false;

    mrt=&TMultiRenameTool(Form1->Owner);
    mrt->num=0;
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        mrt->num++;
    }

    if( mrt->onames ) delete []mrt->onames;
    if( mrt->nnames ) delete []mrt->nnames;
    mrt->onames=new CFile[mrt->num];
    mrt->nnames=new CFile[mrt->num];
    int here=0;
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        mrt->onames[here].name=String(panel[i].Name);
        mrt->onames[here].path=String(dirloc->Text);
        mrt->onames[here].size=IntToStr(panel[i].Size);
        struct stat64 tf;
        try {
            if( lstat64(String(dirloc->Text+panel[i].Name).c_str(),&tf)!=0 ) {}
        } catch(...) {continue;}
        mrt->onames[here].date=tf.st_mtim.tv_sec;
        here++;
    }

    mrt->ShowModal();

    if( mrt->status==0 ) {
        for( int i=0;i<act->active->RowCount;i++ )
            act->panel[i].Selected=false;
        selected=0;
        selected_bytes=0;
        return 0;
    }

    here=0;
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
        act->panel[i].Selected=false;
        selected--;
        selected_bytes-=act->panel[i].Size;
        if( Trim(mrt->nnames[here].name)!="" )
            RenameFile(String(dirloc->Text+panel[i].Name),Trim(String(dirloc->Text)+mrt->nnames[here].name));
        here++;
    }
    selected=0;
    selected_bytes=0;

    nact->prevdir="";
    nact->RefreshPanel();
    prevdir=dirloc->Text+panel[active->Row].Name;
    RefreshPanel();
    delete mrt;
    Form1->nowrefresh=true;
    return 0;
}

void CAct::ClearSearch()
{
    search_num=0;
    if( !search ) return;
    CSearch *delthis=search;
    CSearch *delnext=delthis->next;
    while( delthis ) {
        delnext=delthis->next;
        delete delthis;
        delthis=delnext;
    }
    search=NULL;
}

int CAct::Create_Archive(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode!=NORMAL || nact->mode!=NORMAL || act->panel[act->active->Row].Name==".." ) {
        ShowMessage("You can do it on normal panels!");
        return 0;
    }

    CheckSelected();
    archive_filelist="";
    for( int i=0;i<act->active->RowCount;i++ )
    if( act->panel[i].Selected ) {
//        act->panel[i].Selected=false;
//        selected--;
//        selected_bytes-=act->panel[i].Size;
        archive_filelist+=" \""+act->panel[i].Name+"\"";
    }
// ide jovok n
    TActionForm *actionform;
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Create Archive file";
    actionform->mess1->Caption="The command";
    actionform->mess2->Caption="Archive type";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;
    actionform->archive=1;

    for( int i=0;i<Form1->cr_pacs.Length();i++ )
        if(Form1->cr_pacs[i].Handle!="")
            actionform->doon2->Items->Add(Form1->cr_pacs[i].Name);

    actionform->doon->Text="";

    actionform->ShowModal();
    if( actionform->status==2 ) {delete actionform; return 2;}

    if( actionform->doon->Text!="" ) {
//        ProgressForm->Label3->Caption=actionform->doon->Text;
//        ProgressForm->Show();
        ChDir(String(act->dirloc->Text));
        if( actionform->doon->Text.Pos(">")>0 || actionform->doon->Text.Pos("<")>0 )
            Form1->ExecCmd(String(actionform->doon->Text),false,true);
        else
            Form1->ExecCmd(String(actionform->doon->Text),true,true);
//        ProgressForm->Close();
    }

    selected=0;
    selected_bytes=0;

    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[active->Row].Name;
    RefreshPanel();
    Form1->nowrefresh=true;
    delete actionform;
    return 0;
}

int CAct::Unpack_Archive(CAct *nact)
{
// chech one of the panels are not NORMAL
    if( mode!=NORMAL || nact->mode!=NORMAL || act->panel[act->active->Row].Name==".." ) {
        ShowMessage("You can do it on normal panels!");
        return 0;
    }

// ide jovok n
    TActionForm *actionform;
    actionform=&TActionForm(Form1->Owner);
    actionform->Caption="Unpack Archive file";
    actionform->mess1->Caption="The command";
    actionform->mess2->Caption="Archive type";
    actionform->status=0;
    actionform->symlinks->Enabled=false;
    actionform->recursive->Enabled=false;
    actionform->presattr->Enabled=false;

    actionform->archive=2;
    for( int i=0;i<Form1->cr_pacs.Length();i++ )
        if(Form1->cr_pacs[i].HandleExtr!="")
            actionform->doon2->Items->Add(Form1->cr_pacs[i].Name);

    actionform->doon->Text="";

    actionform->ShowModal();
    if( actionform->status==2 ) {delete actionform; return 2;}

    if( actionform->doon->Text!="" ) {
//        ProgressForm->Label3->Caption=actionform->doon->Text;
//        ProgressForm->Show();
        ChDir(String(nact->dirloc->Text));
        if( actionform->doon->Text.Pos(">")>0 || actionform->doon->Text.Pos("<")>0 )
            Form1->ExecCmd(String(actionform->doon->Text),false,true);
        else
            Form1->ExecCmd(String(actionform->doon->Text),true,true);
        ChDir(String(act->dirloc->Text));
//        ProgressForm->Close();
    }

    selected=0;
    selected_bytes=0;

    nact->prevdir="";
    nact->RefreshPanel();
    act->prevdir=act->dirloc->Text+act->panel[active->Row].Name;
    RefreshPanel();
    Form1->nowrefresh=true;
    delete actionform;
    return 0;
}

