/****************************************************************
*                                                               *
*    Name: MyPanel.h                                            *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This file describe the base file class, and the panel  *
*        class. There are the operations of the panels.         *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef MyPanelH
#define MyPanelH
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QComCtrls.hpp>
#include <QExtCtrls.hpp>
#include <QFileCtrls.hpp>
#include <QMenus.hpp>
#include <QTypes.hpp>
#include <QGrids.hpp>
#include <QImgList.hpp>
#include "MyDirent.h"
#include "MyFtp.h"
#include "const.h"
#include "MultiRename.h"
#include "Action.h"
#include "MyList.h"

//---------------------------------------------------------------------------
class TActionForm;

class CSearch
{
public:
    AnsiString dir;
    int num;
    CSearch *next;
    CSearch *prev;
};

class CDirHist
{
public:
    AnsiString dir;
    AnsiString archdir;
    int mode;
    int def_pac;
};

class my_file
{
public:
    WideString Name;
    WideString Mask;
    __int64 Size;
    AnsiString Date;
    AnsiString Type;
    AnsiString Link;
    AnsiString ext;
    AnsiString pref;
    int ii;
    bool Focused;
    bool Selected;
    AnsiString Owner;
    AnsiString Group;
    int uid;
    int gid;
    bool exec;
    int stat;
};

class CAct
{
public:
    TDrawGrid *active;
    TEdit *dirloc;
    TScrollBar *sb;
    TEdit *selbar;
    TEdit *free;
    TTabControl *tabs;

    TMultiRenameTool *mrt;
    TActionForm *actionform;

    my_file* panel;
    CMyDirent *dirent;

    int num;
    WideString prevdir;
    int selected;
    __int64 selected_bytes;
    int sum;
    __int64 sum_bytes;
    int mode; // 0 - normal, 1 - archive, 2 - FTP
    int sortmode; // 0 - name, 1 - size, 2 - date
    int sortdir; // 0 - asc, 2 - desc
    AnsiString archdir;
    CSearch *search;
    CSearch *newsearch;
    int search_num;
    int def_pac;
    CMyFtp *ftp;
    netbuf *ftpbuf;
    bool allproceed;
    bool allproceed_err;
    AnsiString servername;
    AnsiString prevuserpass;
    CAct *act;
    CMyList<CDirHist> *dirhist;
    AnsiString archive_filelist;

    CAct();
    int RefreshPanel();
    int Copy_my(CAct* nact,TShiftState Shift);
    int Move_my(CAct* nact);
    int Delete_my(CAct* nact);
    int MkDir_my(CAct* nact);
    int Enter_my();
    int Rename_my(CAct* nact);
    int CheckDP(int row);
    void RefreshSelBar();
    void CheckSelected();
    void SelectAll();
    __int64 GetDirSize(AnsiString SrcDir);
    int Create_my(CAct *nact);
    int CreateSymlink_my(CAct* nact);
    int EditSymlink_my(CAct* nact);
    int Copy_Arch(CAct* nact);
    int Copy_FromArch(CAct* nact);
    int Copy_ToArch(CAct* nact);
    int MkDirLong_my(AnsiString ide, AnsiString ezt);
    int Delete_FromArch();
    int View_my();
    int Chmod_my(CAct* nact);
    int Chown_my(CAct* nact);
    int ChmodDir_my(AnsiString SrcDir,AnsiString ChmodDir, AnsiString maskfile, AnsiString maskdir,bool symlinks, int owner_stat);
    int ChmodFile_my(AnsiString path, AnsiString mask, int old_stat);
    int ChownDir_my(AnsiString SrcDir,AnsiString ChownDir, int powner, int pgroup,bool symlinks);
    int ChownFile_my(AnsiString path, int powner, int pgroup);
    void SelectNone();
    void SelectNNone();
    int SelectMask();
    int FindDir(AnsiString Dir,AnsiString File,AnsiString filemask,AnsiString contentmask, bool recursive);
    int FindFile_my();
    bool FindInFile(AnsiString filename,AnsiString mask,__int64 size);
    void CheckUpDp(int &row);
    void ShowAllDirectorySize();
    int ftp_reread(AnsiString dir);
    bool ftp_getname(AnsiString dir,int pi,int count,AnsiString *pname,__int64 *psize,AnsiString *pattr);
    bool ftp_isdir(AnsiString dir,int pi,int count=0);
    int Copy_Ftp(CAct* nact);
    int MkDir_my_Ftp();
    int DeleteDir_my_Ftp(AnsiString SrcDir,AnsiString DelDir);
    int Delete_my_Ftp();
    int Copy_ToFtp(CAct* nact);
    int Copy_FromFtp(CAct* nact);
    int CopyDir_ToFtp(AnsiString SrcDir,AnsiString CpDirFrom,AnsiString DstDir,AnsiString CpDirTo,CAct* nact);
    int CopyFile_ToFtp(AnsiString Src,AnsiString Dst,__int64 size,CAct* nact);
    int CopyDir_FromFtp(AnsiString SrcDir,AnsiString CpDirFrom,AnsiString DstDir,AnsiString CpDirTo, bool presattr, AnsiString attr);
    int CopyFile_FromFtp(AnsiString Src,AnsiString Dst,__int64 size, bool presattr, AnsiString attr);
    int NewFtpConnection();
    int CheckFtpConnection(int noop=1);
    void GetFreeSpace(AnsiString *free,AnsiString *total,AnsiString *per,AnsiString *phere);
    void panelsort(int count,int &cursor);
    int cdpp();
    void CloseFTPConnection();
    void InternalView();
    int MultiRename(CAct *nact);
    void ClearSearch();
    int Create_Archive(CAct *nact);
    int Unpack_Archive(CAct *nact);
};

#endif
