/****************************************************************
*                                                               *
*    Name: MyThread.cpp                                         *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the cpp file of the CMyThread class. This      *
*        will handle the parallel copy, move and delete. It is  *
*        only singletask, because of the popups.                *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------


#pragma hdrstop

#include "MyThread.h"
#include "const.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

// copy a whole directory
int CMyThread::CopyDir(AnsiString SrcDir,AnsiString CpDirFrom,AnsiString DstDir,AnsiString CpDirTo, bool presattr, int attr)
{
// check the new dir is readable
    if( !progform->dirent->SetLocation(SrcDir+CpDirFrom+"/") ) return 1;
    progform->ProgressBar1->Max=progform->dirent->Count();
    progform->ProgressBar1->Position=0;
    progform->Label1->Caption="Copy this: "+progform->dirent->Location();

    try {
        MkDir(DstDir+CpDirTo);
    }
    catch(...) {
// ---MJ---
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Error creating "+CpDirTo+" while copying!","Error Creating Dir.","Ignore All","Ignore","Cancel copy");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return -1;
    }
    for( int i=0;i<progform->dirent->Count();i++ ) if( progform->dirent->filelist[i].name!=".." ) {
        if( !symlinks && progform->dirent->filelist[i].link!="" ) {
            symlink(String(progform->dirent->filelist[i].link).c_str(),String(DstDir+CpDirTo+"/"+progform->dirent->filelist[i].name).c_str());
// copy symlink
        } else
        if( progform->dirent->filelist[i].mask[1]=='d' ) {
            CopyDir(SrcDir+CpDirFrom+"/",String(progform->dirent->filelist[i].name),DstDir+CpDirTo+"/",String(progform->dirent->filelist[i].name),presattr,progform->dirent->filelist[i].attr);
            progform->dirent->SetLocation(SrcDir+CpDirFrom+"/");
        } else
            if( progform->dirent->filelist[i].link!="" ) {
                CopyFileTo_my(progform->dirent->filelist[i].link,DstDir+CpDirTo+"/"+String(progform->dirent->filelist[i].name),presattr,progform->dirent->filelist[i].attr,progform->dirent->filelist[i].size);
            } else {
                CopyFileTo_my(SrcDir+CpDirFrom+"/"+String(progform->dirent->filelist[i].name),DstDir+CpDirTo+"/"+String(progform->dirent->filelist[i].name),presattr,progform->dirent->filelist[i].attr,progform->dirent->filelist[i].size);
            }
        progform->ProgressBar1->StepIt();
        Application->ProcessMessages();
        if( progform->cancel ) return 1;
    }
    if( presattr ) ChmodFile_my(DstDir+CpDirTo,attr);
    return 0;
}
//---------------------------------------------------------------------------

// copy only one file
int CMyThread::CopyFileTo_my(AnsiString Src,AnsiString Dst, bool presattr, int attr, __int64 size)
{
    if( Src==Dst ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Cannot copy a file to itself!","Error Creating File","Ignore All","Ignore","Cancel copy");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return 1;
    }

    if( FileExists(Dst) ) {
        int ret=1;
        if( allproceed_app ) ret=6;
        if( !allproceed ) ret=TForm1::MessageDlg_my("The destination file "+Dst+" exists. Overwrite it?","Warning Creating File","Overwrite All","No","Cancel op.","Overwrite","Append","Append All");
        if( 1==ret ) {
            allproceed=true;
            FILE *dst=fopen64((Dst).c_str(),"w");
            if( dst ) fclose(dst);
        }
        if( 2==ret )
            return 1;
        if( 3==ret ) {
            progform->cancel=true;
            return 1;
        }
        if( 4==ret ) {
            FILE *dst=fopen64((Dst).c_str(),"w");
            fclose(dst);
        }
        if( 6==ret ) {
            allproceed=true;
            allproceed_app=true;
        }
    }

    if( CopyFileTo_Base(Src,Dst,size) ) {
        if( presattr )
            ChmodFile_my(Dst,attr);
        return 0;
    } else {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while copying file "+Dst+"!","Error Copy File","Ignore All","Ignore","Cancel copy");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return 1;
    }
}
//---------------------------------------------------------------------------

int CMyThread::Copy_my()
{
// check for selected files
    progform->ProgressBar2->Max=count2;
    progform->ProgressBar2->Position=0;

    for( int i=0;i<count;i++ )
    if( panel[i].Selected ) {
        panel[i].Selected=false;
// Check that the user do something on the .. (parent dir)
        if( panel[i].Name==".." ) {
            continue;
        }
        progform->Label2->Caption="Copy this: "+panel[i].Name;
// the real copy
        if( !symlinks && panel[i].Link!="" ) {
            symlink(String(panel[i].Link).c_str(),(String(dstdir)+GetStringByMask(String(panel[i].Name),String(mask))).c_str());
// copy symlink
        } else if( panel[i].Type!="Directory" ) {
// copy only a file
                if ( panel[i].Link!="" )
                    CopyFileTo_my(String(panel[i].Link),String(dstdir)+GetStringByMask(String(panel[i].Name),String(mask)),attr,panel[i].stat,panel[i].Size);
                else
                if( mode==SEARCH )
                    CopyFileTo_my(String(panel[i].Name),String(dstdir)+GetStringByMask(String(panel[i].pref),String(mask)),attr,panel[i].stat,panel[i].Size);
                else
                    CopyFileTo_my(String(srcdir+panel[i].Name),String(dstdir)+GetStringByMask(String(panel[i].Name),String(mask)),attr,panel[i].stat,panel[i].Size);
        } else {
// copy a directory
// prefixchecking
            if( (dstdir+GetStringByMask(String(panel[i].Name),mask)).Pos(String(srcdir+panel[i].Name))==1 ) {
                int ret=1;
                if( !allproceed_err ) ret=TForm1::MessageDlg_my("The source is prefix of the destination","Error Copy File","Ignore All","Ignore","Cancel copy");
                if( 1==ret )
                    allproceed_err=true;
                if( 3==ret )
                    progform->cancel=true;
            } else
                CopyDir(String(srcdir),String(panel[i].Name),String(dstdir),GetStringByMask(String(panel[i].Name),String(mask)),attr,panel[i].stat);
        }
        progform->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( progform->cancel ) break;
    }
    progform->Close();
    delete progform;
    return 0;
}

// move a whole directory
int CMyThread::MoveDir(AnsiString SrcDir,AnsiString MvDirFrom,AnsiString DstDir,AnsiString MvDirTo, bool presattr, int attr)
{
    int ret=0;
// check the new dir is readable
    if( !progform->dirent->SetLocation(SrcDir+MvDirFrom+"/") ) return 1;
    progform->ProgressBar1->Max=progform->dirent->Count();
    progform->ProgressBar1->Position=0;
    progform->Label1->Caption="Move this: "+progform->dirent->Location();

    try {
        MkDir(DstDir+MvDirTo);
    }
    catch(...) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Could not create "+DstDir+MvDirTo+" while moving!","Error Moving File","Ignore All","Ignore","Cancel move");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return -1;
    }
    for( int i=0;ret+1<progform->dirent->Count();i++ ) {
        Application->ProcessMessages();
        if( progform->cancel ) return 1;

        int movethis=0;
        while( progform->dirent->filelist[movethis].name==".." ) movethis++;
        movethis+=ret;
        while( progform->dirent->filelist[movethis].name==".." ) movethis++;
        if( progform->dirent->filelist[movethis].mask[1]=='d' && progform->dirent->filelist[movethis].link=="" )
            ret+=MoveDir(SrcDir+MvDirFrom+"/",String(progform->dirent->filelist[movethis].name),DstDir+MvDirTo+"/",String(progform->dirent->filelist[movethis].name), presattr,progform->dirent->filelist[movethis].attr);
        else
            ret+=MoveFileTo_my(SrcDir+MvDirFrom+"/"+String(progform->dirent->filelist[movethis].name),DstDir+MvDirTo+"/"+String(progform->dirent->filelist[movethis].name), presattr,progform->dirent->filelist[movethis].attr,progform->dirent->filelist[movethis].size,progform->dirent->filelist[movethis].link!="");
        progform->dirent->SetLocation(SrcDir+MvDirFrom+"/");
        progform->ProgressBar1->StepIt();
    }
    if( presattr ) ChmodFile_my(DstDir+MvDirTo, attr);
    if( !RemoveDir(SrcDir+MvDirFrom) ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Could not delete "+SrcDir+MvDirFrom+" while moving!","Error Moving File","Ignore All","Ignore","Cancel move");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
    }
    return ret;
}
//---------------------------------------------------------------------------

int CMyThread::MoveFileTo_my(AnsiString Src,AnsiString Dst, bool presattr, int attr,__int64 size,bool link)
{
// move the file to itself
    if( Src==Dst ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Cannot move a file to itself!","Error Moving File","Ignore All","Ignore","Cancel move");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return 1;
    }

// destination file exist
    if( FileExists(Dst) ) {
        int ret=1;
        if( allproceed_app ) ret=6;
        if( !allproceed ) ret=TForm1::MessageDlg_my("The destination file "+Dst+" exists. Overwrite it?","Warning Creating File","Overwrite All","No","Cancel op.","Overwrite","Append","Append All");
        if( 1==ret ) {
            allproceed=true;
            FILE *dst=fopen64((Dst).c_str(),"w");
            if( dst ) fclose(dst);
        }
        if( 3==ret ) {
            progform->cancel=true;
            return 1;
        }
        if( 2==ret )
            return 1;
        if( 4==ret ) {
            FILE *dst=fopen64((Dst).c_str(),"w");
            fclose(dst);
        }
        if( 6==ret ) {
            allproceed=true;
            allproceed_app=true;
        }
    }

// first rename file, if successed then return
    if( RenameFile(Src,Dst) ) {
        if( presattr && !link)
            ChmodFile_my(Dst, attr);
        return 0;
    } else {
// if could not rename, then copy it
        if( link ) {
            char linktarget[2000];
            int ll=0;
            if( 0<(ll=readlink(Trim(Src).c_str(),linktarget,2000)) ) {
                symlink(linktarget,String(Dst).c_str());
                if( DeleteFile(Src) )
                    return 0;
            }
        } else
        if( CopyFileTo_Base(Src,Dst,size) ) {
            if( presattr )
                ChmodFile_my(Dst,attr);
// after copy delete the source
            if( DeleteFile(Src) )
                return 0;
            else {
// error in deleting
                int ret=1;
                if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while moveing file "+Dst+"! Could not delete the sorce file!","Error Moving File","Ignore All","Ignore","Cancel move");
                if( 1==ret )
                    allproceed_err=true;
                if( 3==ret )
                    progform->cancel=true;
                return 1;
            }
        } else {
// error in copying
            int ret=1;
            if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while moveing file "+Dst+"! Could not delete the sorce file!","Error Moving File","Ignore All","Ignore","Cancel move");
            if( 1==ret )
                allproceed_err=true;
            if( 3==ret )
                progform->cancel=true;
            return 1;
        }
        return 0;
    }
}
//---------------------------------------------------------------------------

int CMyThread::Move_my()
{
// check for selected files
    progform->ProgressBar2->Max=count2;
    progform->ProgressBar2->Position=0;
    for( int i=0;i<count;i++ )
    if( panel[i].Selected ) {
        panel[i].Selected=false;
// Check that the user do something on the .. (parent dir)
        if( panel[i].Name==".." ) {
            continue;
        }
        progform->Label2->Caption="Move this: "+panel[i].Name;
// the real move
        if( panel[i].Type!="Directory" || panel[i].Link!="" ) {
            if( mode==SEARCH )
                MoveFileTo_my(String(panel[i].Name),String(dstdir)+GetStringByMask(String(panel[i].pref),mask),attr,panel[i].stat,panel[i].Size,panel[i].Link!="");
            else
                MoveFileTo_my(String(srcdir+panel[i].Name),dstdir+GetStringByMask(String(panel[i].Name),String(mask)),attr,panel[i].stat,panel[i].Size,panel[i].Link!="");
        } else {
            if( (dstdir+GetStringByMask(String(panel[i].Name),mask)).Pos(String(srcdir+panel[i].Name))==1) {
                int ret=1;
                if( !allproceed_err ) ret=TForm1::MessageDlg_my("The source is prefix of the destination!","Error Moving File","Ignore All","Ignore","Cancel move");
                if( 1==ret )
                    allproceed_err=true;
                if( 3==ret )
                    progform->cancel=true;
            } else
                MoveDir(srcdir,String(panel[i].Name),dstdir,GetStringByMask(String(panel[i].Name),mask),attr,panel[i].stat);
        }
        progform->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( progform->cancel ) break;
    }
    progform->Close();
    delete progform;
    return 0;
}
//---------------------------------------------------------------------------

int CMyThread::DeleteDir(AnsiString SrcDir,AnsiString DelDir)
{
    int ret=0;
// check the new dir is readable
    if( !progform->dirent->SetLocation(SrcDir+DelDir+"/") ) return 1;
    progform->ProgressBar1->Max=progform->dirent->Count();
    progform->ProgressBar1->Position=0;
    progform->Label1->Caption="Delete this: "+progform->dirent->Location();

    for( int i=0;ret+1<progform->dirent->Count();i++ ) {
        Application->ProcessMessages();
        if( progform->cancel ) return 1;

        int delthis=0;
        while( progform->dirent->filelist[delthis].name==".." ) delthis++;
        delthis+=ret;
        while( progform->dirent->filelist[delthis].name==".." ) delthis++;
        if( progform->dirent->filelist[delthis].mask[1]=='d' && progform->dirent->filelist[delthis].link=="" )
            ret+=DeleteDir(SrcDir+DelDir+"/",String(progform->dirent->filelist[delthis].name));
        else
            ret+=DeleteFile_my(SrcDir+DelDir+"/"+String(progform->dirent->filelist[delthis].name));
        progform->dirent->SetLocation(SrcDir+DelDir+"/");
        progform->ProgressBar1->StepIt();
    }
    if( !RemoveDir(SrcDir+DelDir) ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Could not delete "+SrcDir+DelDir+"!","Error Deleting Dir.","Ignore All","Ignore","Cancel delete");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
    }
    return ret;
}
//---------------------------------------------------------------------------

int CMyThread::DeleteFile_my(AnsiString Src)
{
    if( DeleteFile(Src) )
        return 0;
    else {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("An error has occured while deleting file "+Src+"!","Error Deleting File","Ignore All","Ignore","Cancel delete");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return 1;
    }
}
//---------------------------------------------------------------------------

int CMyThread::Delete_my()
{
// check for selected files
    progform->ProgressBar2->Max=count2;
    progform->ProgressBar2->Position=0;
    for( int i=0;i<count;i++ )
    if( panel[i].Selected ) {
        panel[i].Selected=false;
// Check that the user do something on the .. (parent dir)
        if( panel[i].Name==".." ) {
            continue;
        }
        progform->Label2->Caption="Delete this: "+panel[i].Name;
        if( panel[i].Type!="Directory" || panel[i].Link!="" ) {
            if( mode==SEARCH )
                DeleteFile_my(String(panel[i].Name));
            else
                DeleteFile_my(String(srcdir+panel[i].Name));
        } else
            DeleteDir(srcdir,String(panel[i].Name));
        progform->ProgressBar2->StepIt();
        Application->ProcessMessages();
        if( progform->cancel ) break;
    }
    progform->Close();
    delete progform;
    return 0;
}
//---------------------------------------------------------------------------

int CMyThread::ChmodFile_my(AnsiString path, int stat)
{
    if( chmod(String(path).c_str(),stat)!=0 ) {
        int ret=1;
        if( !allproceed_err ) ret=TForm1::MessageDlg_my("Could not change permission on "+path+"!","Error Changing Perm.","Ignore All","Ignore","Cancel op.");
        if( 1==ret )
            allproceed_err=true;
        if( 3==ret )
            progform->cancel=true;
        return -1;
    }
    return 0;
}

AnsiString CMyThread::GetStringByMask(AnsiString string, AnsiString mask)
{
    AnsiString ret="";
    for( int i=1;i<=mask.Length();i++ ) {
        if( mask[i]=='*' )
            ret=ret+string;
        else
            ret=ret+mask[i];
    }
    return ret;
}

int CMyThread::Create(TComponent* Owner,my_file* ppanel,int pcount,int pcount2,AnsiString pwhattodo,AnsiString psrcdir,AnsiString pdstdir,AnsiString pmask,int pmode,bool psymlink,bool pattr,int pcopybytes)
{
    progform=&TProgressForm(Owner);
    progform->Caption=pwhattodo;
    progform->Show();
    count=pcount;
    count2=pcount2;
    panel=new my_file[count];
    for( int i=0;i<count;i++ ) panel[i]=ppanel[i];
    whattodo=pwhattodo;
    srcdir=psrcdir;
    dstdir=pdstdir;
    mask=pmask;
    mode=pmode;
    symlinks=psymlink;
    attr=pattr;
    created=true;
    copybytes=pcopybytes;
    allproceed=false;
    allproceed_err=false;
    allproceed_app=false;
}

int CMyThread::todo()
{
    if( whattodo=="copy" )
        return Copy_my();
    else
    if( whattodo=="move" )
        return Move_my();
    else
    if( whattodo=="delete" )
        return Delete_my();
}

bool CMyThread::CopyFileTo_Base(AnsiString Src,AnsiString Dst,__int64 size)
{
    FILE *src=fopen64((Src).c_str(),"r");
    FILE *dst=fopen64((Dst).c_str(),"a");
    if( !src || !dst ) {
        return false;
    }

    progform->ProgressBar3->Max=size/copybytes;
    progform->ProgressBar3->Position=0;
    progform->Label3->Caption="Current file: "+Src;

    char *buffer=new char[copybytes];
    int readed=0;
    int readspeed=0;
    unsigned short h;
    unsigned short m;
    unsigned short ps;
    unsigned short s;
    unsigned short ms;

    TDateTime sms=GetTime();

    GetTime().DecodeTime(&h,&m,&ps,&ms);

    while( !feof(src) ) {
        readed=fread(buffer,sizeof(char),copybytes,src);
        if( readed<0 || ( readed==0 && size>0 ) )  {
            fclose(src);
            fclose(dst);
            delete []buffer;
            return false;
        }
        readed=fwrite(buffer,sizeof(char),readed,dst);
        if( readed<0 || ( readed==0 && size>0 ) )  {
            fclose(src);
            fclose(dst);
            delete []buffer;
            return false;
        }
        readspeed+=readed;
        progform->ProgressBar3->StepIt();
        GetTime().DecodeTime(&h,&m,&s,&ms);
        Application->ProcessMessages();
        if( progform->cancel ) {
            fclose(src);
            fclose(dst);
            delete []buffer;
            return false;
        }
        if( s!=ps ) {
            GetTime().DecodeTime(&h,&m,&ps,&ms);

            float est=DateTimeToTimeStamp(GetTime()-sms).Time/1000.0f;
            if( progform->ProgressBar3->Position>0 )
                est=(progform->ProgressBar3->Max-progform->ProgressBar3->Position)*(est/progform->ProgressBar3->Position);

            progform->speed->Caption=" Speed: "+IntToStr(readspeed/1024)+" Kbyte/sec  Rest. time: "+FloatToStr(int(est*100)/100.0f)+" sec";
            readspeed=0;
            progform->Invalidate();
        }
    }

    fclose(src);
    fclose(dst);
    delete []buffer;
    return true;
}
