/****************************************************************
*                                                               *
*    Name: RPMLikePackage.cpp                                   *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*       In this file we will handle the package file like RPMs, *
*       in other words that packages that filelist does not     *
*       contain the directories, or the file's path is not from *
*       the start, there are files that parent dir are not in   *
*       the filelist                                            *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------


#pragma hdrstop

#include "RPMLikePackage.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

CRPMLikePackage::CRPMLikePackage()
{
    sp=0;
    dirs=new CMyList<AnsiString>();
}

CRPMLikePackage::~CRPMLikePackage()
{
    dirs->DelList();
}

bool CRPMLikePackage::Add(AnsiString newdir)
{
    for( int i=0;i<sp;i++ ) {
        if( newdir==dirs->Get(i) ) return false;
    }

    dirs->AddFirst(newdir);
    sp++;
    return true;
}

int CRPMLikePackage::GetSp()
{
    return sp;
}

AnsiString CRPMLikePackage::GetNextDir(AnsiString archdir,AnsiString pathnev,bool &isadir)
{
    isadir=false;
    if( pathnev.Pos(archdir)!=1 && archdir!="" )
        return "";

    int start=archdir.Length()+1;
    int len=pathnev.Length();
    if( start>=len ) return "";
    AnsiString ret=pathnev.SubString(start,len-start+1);
    if( ret.Pos("/")>0) {
        ret=ret.SubString(1,ret.Pos("/")-1);
        isadir=true;
    }
    return ret;
}


