/****************************************************************
*                                                               *
*    Name: RPMLikePackage.h                                     *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*       In this file we will handle the package file like RPMs, *
*       in other words that packages that filelist does not     *
*       contain the directories, or the file's path is not from *
*       the start, there are files that parent dir are not in   *
*       the filelist                                            *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef RPMLikePackageH
#define RPMLikePackageH
#include <QTypes.hpp>
#include <StrUtils.hpp>
#include "MyList.h"
//---------------------------------------------------------------------------
class CRPMLikePackage
{
private:
    CMyList<AnsiString> *dirs;
    int sp;

public:
    CRPMLikePackage();
    ~CRPMLikePackage();
    bool Add(AnsiString newdir);
    void Clear() {sp=0;dirs->DelList();}
    int GetSp();
    
    static AnsiString GetNextDir(AnsiString archdir,AnsiString pathnev,bool &isadir);
};
#endif
