/****************************************************************
*                                                               *
*    Name: Viewer.h                                             *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the header file of the viewer class. This      *
*        class handle the files to view them.                   *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef ViewerH
#define ViewerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QComCtrls.hpp>
#include <stdio.h>
#include <QExtCtrls.hpp>
#include "Action.h"
//---------------------------------------------------------------------------
class TActionForm;

class TViewForm : public TForm
{
__published:	// IDE-managed Components
    TMemo *Viewer_my;
    TScrollBar *ScrollBar1;
    TStatusBar *status;
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall Viewer_myKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ScrollBar1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall ScrollBar1Scroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormCreate(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __int64 filesize;
    AnsiString filename;
    __int64 lwidth;
    __int64 lheight;
    __int64 line_num;
    __int64 herestream;
    __int64 hereline;
    __int64 herelinememo;
    FILE *file;
    AnsiString *viewer_lines;
    AnsiString findstring;
    int findfromhere;
    bool free;
    TActionForm *actionform;

    __fastcall TViewForm(TComponent* Owner);
    int read(int pos);
    void refresh();
    void up(int n=1);
    void down(int n=1);
    void FindInFile(AnsiString mask);
    void FindInFile_my();
};
//---------------------------------------------------------------------------
extern PACKAGE TViewForm *ViewForm;
//---------------------------------------------------------------------------
#endif
