/****************************************************************
*                                                               *
*    Name: const.h                                              *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the header file of the constants.              *
*                                                               *
****************************************************************/
#ifndef _CONST_H
#define _CONST_H

#define NORMAL 	     0
#define ARCH 	     1
#define FTP 	     2
#define SEARCH 	     3
#define BM_UP 	     0
#define BM_DIR 	     1
#define BM_DIRLINK 	     2
#define BM_DIRNOACCESS     3

#define BM_FILE	     4
#define BM_FILELINK      5
#define BM_FILELINKNOEX  6

#define BM_TEX	 7
#define BM_TXT   8
#define BM_BMP	 9
#define BM_GIF	 10
#define BM_IMG	 11
#define BM_JPG	 12
#define BM_PDF	 13
#define BM_PNG	 14
#define BM_PS	 15
#define BM_XBM	 16
#define BM_XCF	 17
#define BM_XPM	 18
#define BM_3D	 19
#define BM_VID	 20
#define BM_MP3	 21
#define BM_SND	 22
#define BM_WWW	 23
#define BM_XML	 24
#define BM_ARCH	 25
#define BM_RPM	 26
#define BM_TAR	 27
#define BM_TGZ	 28
#define BM_DEB   29

#define BM_LOCK	 30
#define BM_DOC	 31
#define BM_CALC	 32
#define BM_PRES	 33
#define BM_MATH	 34

#define BM_CC	 35
#define BM_C	 36
#define BM_O	 42
#define BM_H	 38
#define BM_J	 39
#define BM_KYLIX 40
#define BM_TCL 	 43

#define BM_EXE	 44
#define BM_CFG	 45
#define BM_DLL	 46

#define BM_PENGUIN     47
#define BM_INFO  	 52
#define BM_HLP	 50

#define BM_EXEC  53

int GetIconIndex(AnsiString IFN,AnsiString IFT) {
  IFN=IFN.LowerCase();
  IFT=IFT.LowerCase();
  if (IFN == "readme")  return  BM_INFO;
  if (IFN == "install")  return  BM_INFO;

  if (IFN == "license")  return  BM_PENGUIN;
  if (IFN == "copying")  return  BM_PENGUIN;
  if (IFN == "copyright")  return  BM_PENGUIN;

  //text files
  if (IFT == ".txt")   return  BM_TXT;
  if (IFT == ".asc")  return  BM_TXT;
  if (IFT == ".tex")  return  BM_TXT;

  //unclassified images
  if (IFT == ".ddw")  return  BM_IMG;
  if (IFT == ".tif")  return  BM_IMG;
  if (IFT == ".tiff")  return  BM_IMG;
  if (IFT == ".wmf")  return  BM_IMG;
  if (IFT == ".pcx")  return  BM_IMG;
  if (IFT == ".ico")  return  BM_IMG;

  //classified images with own icon
  if (IFT == ".bmp")  return  BM_BMP;
  if (IFT == ".gif")  return  BM_GIF;
  if (IFT == ".jpg")  return  BM_JPG;
  if (IFT == ".jpeg")  return  BM_JPG;
  if (IFT == ".nol")  return  BM_IMG;
  if (IFT == ".png")  return  BM_PNG;
  if (IFT == ".xpm")  return  BM_XPM;
  if (IFT == ".xbm")  return  BM_XBM;

  //configuration files
  if (IFT == ".cfg")  return  BM_CFG;
  if (IFT == ".ini")  return  BM_CFG;
  if (IFT == ".log")  return  BM_CFG;

  //documentation files
  if (IFT == ".pdf")  return  BM_PDF;
  if (IFT == ".ps")   return  BM_PS;
  if (IFT == ".eps")  return  BM_PS;

  //video files
  if (IFT == ".mov")   return  BM_VID;
  if (IFT == ".mpg")   return  BM_VID;
  if (IFT == ".mpeg")  return  BM_VID;
  if (IFT == ".avi")   return  BM_VID;
  if (IFT == ".vid")   return  BM_VID;

  if (IFT == ".wmv")   return  BM_VID;
  if (IFT == ".asf")  return  BM_VID;

  //sound files
  if (IFT == ".wav")   return  BM_SND;
  if (IFT == ".snd")   return  BM_SND;
  if (IFT == ".voc")   return  BM_SND;
  if (IFT == ".au")    return  BM_SND;
  if (IFT == ".mp3")   return  BM_SND;
  if (IFT == ".mid")   return  BM_SND;
  if (IFT == ".midi")  return  BM_SND;

  if (IFT == ".ogg")  return  BM_SND;
  if (IFT == ".wma")  return  BM_SND;

  //gimp files
  if (IFT == ".xcf")   return  BM_XCF;

  //redhat rpm files
  if (IFT == ".rpm")   return  BM_RPM;

  //debian deb files
  if (IFT == ".deb")   return  BM_DEB;

  //www files
  if (IFT == ".html")   return  BM_WWW;
  if (IFT == ".htm")    return  BM_WWW;
  if (IFT == ".css")    return  BM_WWW;
  if (IFT == ".js")     return  BM_WWW;

  if (IFT == ".xml")    return  BM_XML;

  //3D or virtual reality files
  if (IFT == ".wrl")  return  BM_3D;
  if (IFT == ".pow")  return  BM_3D;

  //molecular program files
  if (IFT == ".pdb")  return  BM_3D;
  if (IFT == ".mol")  return  BM_3D;
  if (IFT == ".xyz")  return  BM_3D;
  if (IFT == ".zyx")  return  BM_3D;
  if (IFT == ".alc")  return  BM_3D;
  if (IFT == ".cml")  return  BM_3D;
  if (IFT == ".cdxml")  return  BM_3D;
  if (IFT == ".xdc")  return  BM_3D;

  //archive files
  if (IFT == ".tgz")  return  BM_TGZ;

  if (IFT == ".gz")    return  BM_ARCH;
  if (IFT == ".gzip")  return  BM_ARCH;
  if (IFT == ".tar")   return  BM_ARCH;
  if (IFT == ".zip")   return  BM_ARCH;
  if (IFT == ".arj")   return  BM_ARCH;
  if (IFT == ".z")     return  BM_ARCH;

  if (IFT == ".rar")   return  BM_ARCH;
  if (IFT == ".r00")   return  BM_ARCH;

  if (IFT == ".r01")   return  BM_ARCH;

  if (IFT == ".r02")   return  BM_ARCH;

  if (IFT == ".r03")   return  BM_ARCH;

  if (IFT == ".r04")   return  BM_ARCH;

  if (IFT == ".r05")   return  BM_ARCH;

  if (IFT == ".r06")   return  BM_ARCH;

  if (IFT == ".r07")   return  BM_ARCH;

  if (IFT == ".r08")   return  BM_ARCH;

  if (IFT == ".r09")   return  BM_ARCH;

  if (IFT == ".r10")   return  BM_ARCH;

  if (IFT == ".r11")   return  BM_ARCH;

  if (IFT == ".r12")   return  BM_ARCH;

  if (IFT == ".r13")   return  BM_ARCH;

  if (IFT == ".r14")   return  BM_ARCH;

  if (IFT == ".r15")   return  BM_ARCH;

  if (IFT == ".r16")   return  BM_ARCH;

  if (IFT == ".r17")   return  BM_ARCH;

  if (IFT == ".r18")   return  BM_ARCH;

  if (IFT == ".r19")   return  BM_ARCH;

  if (IFT == ".bz2")     return  BM_ARCH;

  if (IFT == ".iso")    return  BM_ARCH;

  //security files
  if (IFT == ".pgp")   return  BM_LOCK;
  if (IFT == ".gpg")   return  BM_LOCK;
  if (IFT == ".jbc")   return  BM_LOCK;
  if (IFT == ".pgd")   return  BM_LOCK;

  //dosuments
  if (IFT == ".doc")   return  BM_DOC;
  if (IFT == ".rtf")   return  BM_DOC;
  if (IFT == ".602")   return  BM_DOC;
  if (IFT == ".sxw")   return  BM_DOC;
  if (IFT == ".sdw")   return  BM_DOC;

  //spreadsheet
  if (IFT == ".xls")   return  BM_CALC;
  if (IFT == ".sxc")   return  BM_CALC;
  if (IFT == ".sdc")   return  BM_CALC;

  //presentations
  if (IFT == ".ppt")   return  BM_PRES;
  if (IFT == ".pps")   return  BM_PRES;

  //executable files
  if (IFT == ".exe")   return  BM_EXE;
  if (IFT == ".sys")   return  BM_EXE;
  if (IFT == ".com")   return  BM_EXE;
  if (IFT == ".bat")   return  BM_EXE;
  if (IFT == ".sh")   return  BM_EXE;
  if (IFT == ".tcl")   return  BM_EXE;
  if (IFT == ".tk")   return  BM_EXE;

  //libraries
  if (IFT == ".dll")   return  BM_DLL;
  if (IFT == ".lib")   return  BM_DLL;
  if (IFT == ".so")   return  BM_DLL;
  if (IFT == ".a")   return  BM_DLL;

  //delphi files
  if (IFT == ".pas")   return  BM_KYLIX;
  if (IFT == ".dfm")   return  BM_KYLIX;
  if (IFT == ".xfm")   return  BM_KYLIX;
  if (IFT == ".dpr")   return  BM_KYLIX;
  if (IFT == ".kpr")   return  BM_KYLIX;
  if (IFT == ".dcu")   return  BM_KYLIX;
  if (IFT == ".kof")   return  BM_KYLIX;
  if (IFT == ".c")   return  BM_C;
  if (IFT == ".o")   return  BM_O;
  if (IFT == ".h")   return  BM_H;
  if (IFT == ".hpp")   return  BM_H;
  if (IFT == ".c++")   return  BM_CC;
  if (IFT == ".cpp")   return  BM_CC;
  if (IFT == ".java")   return  BM_J;
  if (IFT == ".class") return  BM_J;
  if (IFT == ".bpr") return  BM_KYLIX;
  return BM_FILE;
 }


#endif
